#include "main.h"
#include "properties.h"

static void	cb_set_label(GtkWidget *sender, GtkWidget *widget)
{
  if (GTK_IS_ENTRY(sender))
    {
      GtkWidget *label_widget;
      gchar   *label;
      
      label_widget = g_list_first(gtk_container_children
				  (GTK_CONTAINER(widget)))->data;
      label = gtk_entry_get_text(GTK_ENTRY(sender));
      gtk_label_set(GTK_LABEL(label_widget), label);
      refresh_widget_code_from_properties(widget);
    }
}

void		GtkButton_properties(GtkWidget *widget)
{
  GtkWidget	*entry;
  GtkWidget	*label_widget;
  gchar		*label;
  GtkWidget	*table;
  
  g_return_if_fail(GTK_IS_BUTTON(widget)); 
  table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
			      "properties"); 
  AddPropertyLabel(table, NB_WIDGET_PROP+1, "Label", "Label of the button");
  entry = AddEntryProperty(table, NB_WIDGET_PROP+1);
  label_widget = g_list_first(gtk_container_children
			      (GTK_CONTAINER(widget)))->data;
  gtk_label_get(GTK_LABEL(label_widget), &label); 
  gtk_entry_set_text(GTK_ENTRY(entry), label); 
  gtk_signal_connect(GTK_OBJECT(entry), "changed", 
		     GTK_SIGNAL_FUNC(cb_set_label), widget); 
}

