/*
** clist.c
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Wed Jun  9 23:17:35 1999 Maxime VERNIER
** Last update Sat Apr  1 23:50:43 2000 Sebastien Thebert
*/
#include "main.h"

gint row_selected;

void	cb_clist_add_a_row(GtkWidget *sender, GtkWidget *clist)
{
  gchar *text[2]= { "", "" };
  
  gtk_clist_insert(GTK_CLIST(clist), 0, text);
}

static void	cb_set_cell_text(GtkWidget *entry, GtkWidget *clist)
{
  gchar		*text = gtk_entry_get_text(GTK_ENTRY(entry)); 
  gint		*column;
  
  printf("%d\n", row_selected);
  column = gtk_object_get_data(GTK_OBJECT(entry), "column_selected"); 
  printf("%d\n", *column); 
  if (column)
    gtk_clist_set_text(GTK_CLIST(clist), row_selected, *column, text);
}

void		cb_clist_select_row(GtkWidget *widget, gint row, gint column,
				    GdkEventButton *event, gpointer data)
{
  GtkWidget *notebook;
  GtkWidget *label, *table;
  gchar *text, *tooltip;
  gint i;
  
  row_selected = row;
  table = gtk_table_new(GTK_CLIST(widget)->columns, 2, FALSE);
  text = xmalloc(sizeof(*text)*TEXT_LENGTH);
  tooltip = xmalloc(sizeof(*tooltip)*TEXT_LENGTH);
  for (i = 0; i < GTK_CLIST(widget)->columns; i++)
    {
      GtkWidget *entry;
      gint *column_selected;
      
      sprintf(text, "Text %d", i + 1);
      sprintf(tooltip, "Text of the cell (%d,%d)", i + 1, row + 1);
      AddPropertyLabel(table, i + 1, text, tooltip);
      entry = AddEntryProperty(table, i + 1);
      gtk_clist_get_text(GTK_CLIST(widget), row, i, &text);
      gtk_entry_set_text(GTK_ENTRY(entry), text); 
      column_selected = xmalloc(sizeof(*column_selected));
      *column_selected = i;
      gtk_object_set_data(GTK_OBJECT(entry), "column_selected", 
			  column_selected);
      gtk_signal_connect(GTK_OBJECT(entry), "changed", 
			 GTK_SIGNAL_FUNC(cb_set_cell_text), widget);
    } 
  gtk_widget_show(table);
  sprintf(text, "Row %d", row + 1);
  label = gtk_label_new(text);
  gtk_widget_show(label);
  notebook = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				 "notebook");
  gtk_notebook_remove_page(GTK_NOTEBOOK(notebook), 1); 
  gtk_notebook_insert_page(GTK_NOTEBOOK(notebook), table, label, 1);
  free(text);
  free(tooltip); 
}

gint			popup_show(GtkWidget *widget, GdkEvent *event)
{
  GtkMenu		*menu;
  GdkEventButton	*event_button;
  
  g_return_val_if_fail (widget != NULL, FALSE);
  g_return_val_if_fail (GTK_IS_MENU (widget), FALSE);
  g_return_val_if_fail (event != NULL, FALSE);
  /* The "widget" is the menu that was supplied when 
   * gtk_signal_connect_object was called.
   */
  menu = GTK_MENU (widget);
  
  if (event->type == GDK_BUTTON_PRESS)
    {
      event_button = (GdkEventButton *)event;
      if (event_button->button == 2)
	{
	  gtk_menu_popup (menu, NULL, NULL, NULL, NULL, 
			  event_button->button, event_button->time);
	  return TRUE;
	}
    }
  return FALSE;
}

void		cb_click_column(GtkCList *clist, gint column, gpointer data)
{
  GtkWidget	*button;
  
  button = gtk_clist_get_column_widget(clist, column)->parent;
  edit_properties_of_widget(button);
}

void	cb_set_shadow_type(GtkWidget *sender, GtkWidget *widget)
{
  if (GTK_IS_ENTRY(sender))
    {
      GtkShadowType	shadow_type;
      gchar		*text;
      
      text = gtk_entry_get_text(GTK_ENTRY(sender)); 
      shadow_type = get_shadow_type(text);
      gtk_clist_set_shadow_type(GTK_CLIST(widget), shadow_type);
    }
}

static void	cb_show_titles(GtkWidget *sender, GtkWidget *widget)
{
  GtkWidget	*label;
  GtkWidget	*active;
  
  label = g_list_first(gtk_container_children(GTK_CONTAINER(sender)))->data; 
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(sender)))
    {
      gtk_label_set(GTK_LABEL(label), "False"); 
      gtk_clist_column_titles_hide(GTK_CLIST(widget));
      active = gtk_object_get_data(GTK_OBJECT(sender), "active"); 
      gtk_widget_set_sensitive(active, FALSE); 
    }
  else
    {
      gtk_label_set(GTK_LABEL(label), "True");
      gtk_clist_column_titles_show(GTK_CLIST(widget));
      active = gtk_object_get_data(GTK_OBJECT(sender), "active"); 
      gtk_widget_set_sensitive(active, TRUE); 
    }
}

static void	cb_titles_active(GtkWidget *sender, GtkWidget *widget)
{
  GtkWidget	*label;
  
  label = g_list_first(gtk_container_children(GTK_CONTAINER(sender)))->data; 
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(sender)))
    {
      gtk_label_set(GTK_LABEL(label), "False"); 
      gtk_clist_column_titles_passive(GTK_CLIST(widget));
      gtk_object_set_data(GTK_OBJECT(widget), "titles active", widget); 
    }
  else
    {
      gtk_label_set(GTK_LABEL(label), "True");
      gtk_clist_column_titles_active(GTK_CLIST(widget));
      gtk_object_set_data(GTK_OBJECT(widget), "titles active", NULL); 
    }
}


/*static void 
cb_set_active(GtkWidget *sender, GtkWidget *widget)
{
  GtkWidget *label;
  
  label = g_list_first(gtk_container_children(GTK_CONTAINER(sender)))->data; 
  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(sender)))
    {
      gtk_label_set(GTK_LABEL(label), "False"); 
      gtk_clist_column_title_passive(GTK_CLIST(widget), column_selected);
      gtk_object_set_data(GTK_OBJECT(widget), "titles active", widget); 
    }
  else
  {
  gtk_label_set(GTK_LABEL(label), "True");
  gtk_clist_column_title_active(GTK_CLIST(widget), column_selected);
  gtk_object_set_data(GTK_OBJECT(widget), "titles active", NULL); 
  }
  }
*/

static void	cb_set_selection_mode(GtkWidget *entry, GtkWidget *widget)
{
  gchar		*text = gtk_entry_get_text(GTK_ENTRY(entry));
  
  if (!strcmp(text, "single"))
    gtk_clist_set_selection_mode(GTK_CLIST(widget), GTK_SELECTION_SINGLE);
  else
    if (!strcmp(text, "browse"))
      gtk_clist_set_selection_mode(GTK_CLIST(widget), GTK_SELECTION_BROWSE);
    else
      if (!strcmp(text, "multiple"))
	gtk_clist_set_selection_mode(GTK_CLIST(widget), 
				     GTK_SELECTION_MULTIPLE);
      else
	if (!strcmp(text, "extended"))
	  gtk_clist_set_selection_mode(GTK_CLIST(widget), 
				       GTK_SELECTION_EXTENDED);
}

void		GtkCList_properties(GtkWidget *widget)
{
  GtkWidget	*property, *property2;
  GList		*list;
  gpointer      data;
  gchar		*text;
  GtkWidget	*table;
  
  g_return_if_fail(GTK_IS_CLIST(widget)); 
  table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
			      "properties"); 
  AddPropertyLabel(table, NB_WIDGET_PROP + 1,
		   "Selection mode", "Selection mode of the clist");
  list = GtkSelectionModeList();
  property = AddComboProperty(table, NB_WIDGET_PROP + 1, list);
  text = GtkSelectionModeText(GTK_CLIST(widget)->selection_mode);
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(property)->entry), text); 
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(property)->entry), "changed", 
		     GTK_SIGNAL_FUNC(cb_set_selection_mode), widget); 
  AddPropertyLabel(table, NB_WIDGET_PROP + 2,
		   "Shadow type", "Shadow type of the clist");
  list = GtkShadowTypeList();
  property = AddComboProperty(table, NB_WIDGET_PROP + 2, list);
  property = GTK_COMBO(property)->entry;
  gtk_signal_connect(GTK_OBJECT(property), "changed", 
		     GTK_SIGNAL_FUNC(cb_set_shadow_type), widget); 
  text = GtkShadowTypeText(GTK_CLIST(widget)->shadow_type);
  gtk_entry_set_text(GTK_ENTRY(property), text); 
  AddPropertyLabel(table, NB_WIDGET_PROP+3,
		   "Show titles", "Are the column titles visible ?");
  if (GTK_CLIST_SHOW_TITLES(widget))
    property = AddToggleProperty(table, NB_WIDGET_PROP + 3, FALSE, "True");
  else
    property = AddToggleProperty(table, NB_WIDGET_PROP + 3, TRUE, "False");
  gtk_signal_connect(GTK_OBJECT(property), "toggled", 
		     GTK_SIGNAL_FUNC(cb_show_titles), widget); 
  AddPropertyLabel(table, NB_WIDGET_PROP + 4,
		   "Active", "Are the column titles active ?");
  data = gtk_object_get_data(GTK_OBJECT(widget), "titles active"); 
  if (!data)
    property2 = AddToggleProperty(table, NB_WIDGET_PROP + 4, FALSE, "True");
  else
    property2 = AddToggleProperty(table, NB_WIDGET_PROP + 4, TRUE, "False");
  gtk_signal_connect(GTK_OBJECT(property2), "toggled", 
		     GTK_SIGNAL_FUNC(cb_titles_active), widget);
  gtk_object_set_data(GTK_OBJECT(property), "active", property2); 
}

void	GtkCList_save(FILE *fp, int tab, GtkWidget *widget)
{
  write_num_property(fp, tab, "SEL_MODE", GTK_CLIST(widget)->selection_mode);
  write_num_property(fp, tab, "SHADOW", GTK_CLIST(widget)->shadow_type);
  write_num_property(fp, tab, "SHOW_TITLES", GTK_CLIST_SHOW_TITLES(widget));
  if (!gtk_object_get_data(GTK_OBJECT(widget), "titles active"))
    write_num_property(fp, tab, "ACTIVE", TRUE);
  else
    write_num_property(fp, tab, "ACTIVE", FALSE);
  write_num_property(fp, tab, "NB_COLUMNS", GTK_CLIST(widget)->columns);
}


