/*
** code_gen_buttons.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Sun Jan 23 02:57:09 2000 Sebastien Thebert
** Last update Sat Apr  1 23:44:15 2000 Sebastien Thebert
*/
#include "main.h"

/*
** create_button_code
*/
void		create_button_code(char *name_win, GtkWidget *bt, int type)
{
  GtkWidget	*label; 
  char		*line, *fct_line;
  char		*label_str;
  
  fct_line = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  write_widget_declaration(bt, fct_line);
  get_container_last_line(&line, bt);
  seek_in_fct_before(fct_line, line);
  strcpy(line, gtk_widget_get_name(bt));
  switch(type)
    {
    case BUTTON:
      add_to_widget_list(gtk_widget_get_name(bt), BUTTON);
      strcat(line, " = gtk_button_new_with_label(\"");
      break;
    case TOGGLE_BUTTON:
      add_to_widget_list(gtk_widget_get_name(bt), TOGGLE_BUTTON);
      strcat(line, " = gtk_toggle_button_new_with_label(\"");
      break;
    case CHECK_BUTTON:
      add_to_widget_list(gtk_widget_get_name(bt), CHECK_BUTTON);
      strcat(line, " = gtk_check_button_new_with_label(\"");
      break;
    }
  label = GTK_WIDGET(g_list_first
		     (gtk_container_children(GTK_CONTAINER(bt)))->data);
  gtk_label_get(GTK_LABEL(label), &label_str);
  strcat(line, label_str);
  strcat(line, "\");\n");
  coloration(line);
  write_widget_set_size(bt);
  if (((type == TOGGLE_BUTTON) || (type == CHECK_BUTTON))
      && (!GTK_TOGGLE_BUTTON(bt)->active))
    color_line(3, "gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(",
	       gtk_widget_get_name(bt), "), TRUE);\n"); 
  write_widget_sensitive_show_and_put(bt);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}

/***********************************************************/
void		delete_button_code(char *name_win, GtkWidget *bt, int type)
{
  char		*line;
  gint		pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(bt));
  pos_fct_begin = search_string(line, 0);
  strcpy(line, gtk_widget_get_name(bt));
  switch(type)
    {
    case BUTTON:
      strcat(line, " = gtk_button_new_with_label(\"");
      break;
    case TOGGLE_BUTTON:
      strcat(line, " = gtk_toggle_button_new_with_label(\"");
      break;
    case CHECK_BUTTON:
      strcat(line, " = gtk_check_button_new_with_label(\"");
      break;
    }
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),", gtk_widget_get_name(bt));
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(bt));
  delete_line(line, pos_fct_begin);  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
}

/***********************************************************/
void	refresh_button_code(char *name_win, GtkWidget *bt, int type)
{
  delete_button_code(name_win, bt, type);
  create_button_code(name_win, bt, type);
}
