/*
** code_gen_c_file.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 17:18:33 2000 Sebastien Thebert
** Last update Tue Apr  4 17:36:53 2000 Sebastien Thebert
*/
#include "main.h"

/*
** create headers and files
*/
void		create_headers_and_files()
{
  GtkWidget	*widget;
  char		*window_name;
  int		i;
  
  create_main_header_file();
  for (i = 0; i < g_list_length(epingle->window_list); i++)
    {
      widget = g_list_nth(epingle->window_list, i)->data;
      window_name = gtk_widget_get_name(widget);
      create_h_file(window_name);
    }
  create_c_file(epingle->project_name);  
  for (i = 0; i < g_list_length(epingle->window_list); i++)
    {
      widget = g_list_nth(epingle->window_list, i)->data;
      window_name = gtk_widget_get_name(widget);
      create_c_file(window_name);
    }
}

/*
** create main header file
*/
void		create_main_header_file(void)
{
  FILE		*file;
  char		*filename;
  GtkWidget	*widget;
  int		i;
  
  filename = xmalloc(sizeof (char) * FN_LENGTH);
  concat(&filename, 4, epingle->project_path, "/",
	 epingle->project_name, ".h");  
  if ((file = fopen(filename, "w")) != NULL)
    {
      fprintf(file, "#include <gtk/gtk.h>\n\n");
      for (i = 0; i < g_list_length(epingle->window_list); i++)
	{
	  widget = g_list_nth(epingle->window_list, i)->data;
	  fprintf(file, "#include \"%s.h\"\n", gtk_widget_get_name(widget));
      	}
      fclose(file);
    }
  else
    g_error("EPingle ERROR: Unable to create header file !\n");
  free(filename);
}

/*
** create header file
*/
void	create_h_file(char *name_win)
{
  FILE	*file;
  char	*filename;
  
  filename = xmalloc(sizeof (char) * FN_LENGTH);
  concat(&filename, 4, epingle->project_path, "/", name_win, ".h");
  if ((file = fopen(filename, "w")) != NULL)
    {
      fprintf(file, "#include <gtk/gtk.h>\n\n");
      fprintf(file, "void create_%s(void);\n", name_win);
      fclose(file);
    }
  else
    g_error("EPingle ERROR: Unable to create header file !\n");
  free(filename);
}

/*
** write line in c file
*/
void	write_line(FILE *file, char **line, char *tmp, int *pos)
{
  char	c;
  
  c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), *pos);
  if (c == '\n')
    {
      **line = '\0';
      *line = tmp;
      fprintf(file, "%s\n", *line);
      strcpy(*line, "");
    }
  else
    {
      **line = c;
      (*line)++;
    }
  (*pos)++;
}

/*
** create c file
*/
void	create_c_file(char *name_win)
{
  FILE	*file;
  char	*filename;
  char	*name_text;
  char	*tmp;
  char	*line;
  gint	pos;
  gint	length_text;
  
  name_text = xmalloc(sizeof (char) * LENGTH);
  filename = xmalloc(sizeof (char) * FN_LENGTH);
  tmp = line = xmalloc(sizeof (char) * 120);
  concat(&filename, 4, epingle->project_path, "/", name_win, ".c");
  if ((file = fopen(filename, "w")) != NULL)
    {
      concat(&name_text, 2, "text_", name_win); 
      epingle->edit_text = gtk_object_get_data(GTK_OBJECT
					       (epingle->editor_notebook),
					       name_text);
      length_text = gtk_text_get_length(GTK_TEXT(epingle->edit_text));
      pos = 0;
      while (pos < length_text)
	write_line(file, &line, tmp, &pos);
      fclose(file);
    }
  else
    g_error("EPingle ERROR: Unable to create file !\n");
  free(tmp);
  free(name_text);
  free(filename);
}

/*
** open c file
*/
void		open_c_file(char *win)
{
  FILE		*file;
  char		*filename, *file_str;
  /*    GtkWidget	*hbox, *vscrollbar;*/
  
  filename = xmalloc(sizeof (char) * FN_LENGTH);
  file_str = xmalloc(sizeof (char) * FN_LENGTH);
  concat(&filename, 3, epingle->project_path, "/", win);
  /*  concat(&name_text, 2, "text_", win);*/
  /*  hbox = gtk_hbox_new(FALSE, 0);*/
  /*  gtk_box_pack_start(GTK_BOX(hbox), text, TRUE, TRUE, 0);*/
  /*  vscrollbar = gtk_vscrollbar_new(GTK_TEXT(text)->vadj);*/
  /*  gtk_box_pack_start(GTK_BOX(hbox), vscrollbar, FALSE, FALSE, 0);*/
  /*  gtk_widget_show(vscrollbar);*/
  /*  gtk_widget_show(hbox); */
  strcat(filename, ".c");
  file = fopen(filename, "r");
  while (fgets(file_str, FN_LENGTH, file) != NULL)
    coloration(file_str);  
  fclose(file);
  free(file_str);
  free(filename);
}

/*
** create main c file
*/
void		create_main_file(void)
{
  create_edit_page(epingle->project_name);
  color_line(3, "#include \"", epingle->project_name, ".h\"\n\n"); 
  coloration("GtkWidget *bt_storage;\n");
  coloration("GtkTooltips *tooltips;\n\n");
  coloration("int main(int argc, char *argv[])\n");
  coloration("{\n");
  coloration("gtk_init(&argc, &argv);\n\n");
  coloration("tooltips = gtk_tooltips_new();\n");
  coloration("bt_storage = gtk_button_new();\n");
  coloration("gtk_widget_realize(bt_storage);\n\n");
  coloration("gtk_main();\n\n");
  coloration("return (0);\n}\n");
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
}

void		delete_old_project()
{
  GtkWidget	*window;
  char		*name_text;
  
  name_text = xmalloc(sizeof (char) * LENGTH);
  while (g_list_length(epingle->window_list))
    {
      window = g_list_first(epingle->window_list)->data;
      destroy_window(window);
    }
  concat(&name_text, 2, "text_", epingle->project_name);
  epingle->edit_text = gtk_object_get_data(GTK_OBJECT
					   (epingle->editor_notebook),
  					   name_text);
  gtk_widget_destroy(epingle->edit_text);
  gtk_notebook_remove_page(GTK_NOTEBOOK(epingle->editor_notebook), 0);
}

