/*
** code_gen_combo.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:24:02 2000 Sebastien Thebert
** Last update Tue Apr  4 16:59:48 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
void		create_combo_box_code(char *name_win, GtkWidget *combo)
{
  char		*fct_line, *line;
  char		*str_list;
  GtkWidget	*list_item, *label_widget;
  GList		*list;
  gint		i;
  
  fct_line = xmalloc(sizeof (char) * FN_LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  add_to_widget_list(gtk_widget_get_name(combo), COMBO);
  concat(&fct_line, 2, "void create_", get_container_name(combo)); 
  seek_in_fct_after(fct_line, "fixed;\n");
  color_line(3, "GtkWidget *", gtk_widget_get_name(combo), ";\n");
  color_line(3, "GList *list_", gtk_widget_get_name(combo), " = NULL;\n");
  
  get_container_last_line(&line, combo);
  seek_in_fct_before(fct_line, line);
  color_line(2, gtk_widget_get_name(combo), " = gtk_combo_new();\n");
  color_line(3, "list_", gtk_widget_get_name(combo), " = NULL;\n");
  list = gtk_container_children(GTK_CONTAINER(GTK_COMBO(combo)->list));
  for (i = 0; i < g_list_length(list); i++) 
    {
      list_item = g_list_nth(list, i)->data;
      label_widget = g_list_first(gtk_container_children(GTK_CONTAINER
							 (list_item)))->data;
      gtk_label_get(GTK_LABEL(label_widget),&str_list);
      color_line(7, "list_", gtk_widget_get_name(combo),
		 " = g_list_append(list_", gtk_widget_get_name(combo),
		 ", \"", str_list, "\");\n");
    }
  color_line(5, "gtk_combo_set_popdown_strings(GTK_COMBO(",
	     gtk_widget_get_name(combo), "), list_",
	     gtk_widget_get_name(combo), ");\n");
  
  write_widget_set_size(combo);
  write_widget_sensitive_show_and_put(combo);
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(fct_line);
}

/***********************************************************/
void		delete_combo_box_code(char *name_win, GtkWidget *combo)
{
  char		*line;
  gint		pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(combo));
  pos_fct_begin = search_string(line, 0);
  concat(&line, 2, gtk_widget_get_name(combo), " = gtk_combo_new();"); 
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),",
	 gtk_widget_get_name(combo)); 
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(combo));
  delete_line(line, pos_fct_begin);
  concat(&line, 3, "GList *list_", gtk_widget_get_name(combo), " = NULL;\n");
  delete_line(line, pos_fct_begin);
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
}

/***********************************************************/
void	refresh_combo_box_code(char *name_win, GtkWidget *combo)
{
  delete_combo_box_code(name_win, combo);
  create_combo_box_code(name_win, combo);
}
