/*
** code_gen_drawingarea.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:55:26 2000 Sebastien Thebert
** Last update Sat Apr  1 23:43:14 2000 Sebastien Thebert
*/
#include "main.h"


/***********************************************************/
void	create_drawing_area_code(char *name_win, GtkWidget *drawing_area)
{
  char	*line, *fct_line;
  char	*str1, *str2;
  
  fct_line = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH); 
  freeze_edit_text(name_win);
  add_to_widget_list(gtk_widget_get_name(drawing_area), DRAWING_AREA);
  write_widget_declaration(drawing_area, fct_line);
  
  get_container_last_line(&line, drawing_area);
  seek_in_fct_before(fct_line, line);
  color_line(2, gtk_widget_get_name(drawing_area),
	     " = gtk_drawing_area_new();\n");
  str1 = int_to_str(drawing_area->allocation.width);
  str2 = int_to_str(drawing_area->allocation.height);
  color_line(7, "gtk_drawing_area_size(GTK_DRAWING_AREA(",
	     gtk_widget_get_name(drawing_area), "), ",
	     str1, ", ", str2, ");\n");
  free(str1);
  free(str2);
  if (GTK_WIDGET_VISIBLE(drawing_area))
    color_line(3, "gtk_widget_show(", gtk_widget_get_name(drawing_area),
	       ");\n");
  else
    color_line(3, "gtk_widget_realize(", gtk_widget_get_name(drawing_area),
	       ");\n");
  /*  gdk_window_set_background(drawing_area->window, cl);*/
  str1 = int_to_str(drawing_area->parent->allocation.x);
  str2 = int_to_str(drawing_area->parent->allocation.y);
  color_line(7, "gtk_fixed_put(GTK_FIXED(fixed),",
	     gtk_widget_get_name(drawing_area), ",", 
	     str1, ",", str2, ");\n");
  free(str1);
  free(str2);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}

/***********************************************************/
void	delete_drawing_area_code(char *name_win, GtkWidget *drawing_area)
{
  char	*line;
  gint	pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(drawing_area));
  pos_fct_begin = search_string(line, 0);
  concat(&line, 2, gtk_widget_get_name(drawing_area),
	 " = gtk_drawing_area_new();\n"); 
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),",
	 gtk_widget_get_name(drawing_area)); 
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(drawing_area));
  delete_line(line, pos_fct_begin);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
}

/***********************************************************/
void	refresh_drawing_area_code(char *name_win, GtkWidget *drawing_area)
{
  delete_drawing_area_code(name_win, drawing_area);
  create_drawing_area_code(name_win, drawing_area);
}

