/*
** code_gen_entry.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:21:30 2000 Sebastien Thebert
** Last update Tue Apr  4 01:55:44 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
void	create_entry_code(char *name_win, GtkWidget *entry)
{
  char	*fct_line;
  char	*line;
  char	*str;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  fct_line = xmalloc(sizeof (char) * FN_LENGTH);
  add_to_widget_list(gtk_widget_get_name(entry), ENTRY);
  freeze_edit_text(name_win);
  write_widget_declaration(entry, fct_line);
  
  get_container_last_line(&line, entry);
  seek_in_fct_before(fct_line, line);
  color_line(2, gtk_widget_get_name(entry), " = gtk_entry_new();\n");
  str = int_to_str(GTK_ENTRY(entry)->text_max_length);
  color_line(3, "gtk_entry_set_max_length(", str, ");\n");
  free(str);
  if (!(GTK_ENTRY(entry)->visible))
    color_line(3, "gtk_entry_set_visibility(GTK_ENTRY(",
	       gtk_widget_get_name(entry), "), FALSE);\n");
  if (!(GTK_ENTRY(entry)->editable.editable))
    color_line(3, "gtk_entry_set_editable(GTK_ENTRY(",
	       gtk_widget_get_name(entry), "), FALSE);\n");
  color_line(5, "gtk_entry_set_text(GTK_ENTRY(", gtk_widget_get_name(entry),
	     "), \"", gtk_entry_get_text(GTK_ENTRY(entry)), "\");\n");
  write_widget_set_size(entry);
  write_widget_sensitive_show_and_put(entry); 
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(fct_line);
  free(line);
}

/***********************************************************/
void	delete_entry_code(char *name_win, GtkWidget *entry)
{
  char	*line;
  gint	pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(entry));
  pos_fct_begin = search_string(line, 0);
  concat(&line, 2, gtk_widget_get_name(entry), " = gtk_entry_new();"); 
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),",
	 gtk_widget_get_name(entry)); 
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(entry));
  delete_line(line, pos_fct_begin);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
}

/***********************************************************/
void	refresh_entry_code(char *name_win, GtkWidget *entry)
{
  delete_entry_code(name_win, entry);
  create_entry_code(name_win, entry);
}


