/*
** code_gen_fontselector.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 16:15:36 2000 Sebastien Thebert
** Last update Sat Apr  1 23:47:22 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
void		create_font_selector_code(GtkWidget *window)
{
  write_window_declaration(window);
  add_to_widget_list(gtk_widget_get_name(window), FONT_SELECTION_DIALOG);
  create_edit_page(gtk_widget_get_name(window));
  color_line(3, "#include \"", gtk_widget_get_name(window), ".h\"\n\n");
  coloration("extern GtkWidget *bt_storage;\n\n");
  color_line(3, "void create_", gtk_widget_get_name(window), "(void)\n{\n");  
  color_line(3, "GtkWidget *", gtk_widget_get_name(window), ";\n\n");
  color_line(4, gtk_widget_get_name(window),
	     " = gtk_font_selection_dialog_new(\"",
	     GTK_WINDOW(window)->title, "\");\n");
  write_window_sensitive_and_show(window);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
}

/***********************************************************/
void	refresh_font_selector_code(GtkWidget *window)
{
  char	*line;
  gint	pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(gtk_widget_get_name(window));
  concat(&line, 2, "void create_", gtk_widget_get_name(window));
  pos_fct_begin = search_string(line, 0);

  concat(&line, 2, gtk_widget_get_name(window),
	 " = gtk_font_selection_dialog_new(");
  pos = search_string(line, pos_fct_begin);
  
  concat(&line, 3, "gtk_widget_show(", gtk_widget_get_name(window),");\n");
  if (search_string(line, pos) == -1)
    concat(&line, 3, "gtk_widget_realize(",
	   gtk_widget_get_name(window),");\n");
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos); 
  color_line(4, gtk_widget_get_name(window),
	     " = gtk_font_selection_dialog_new(\"",
	     GTK_WINDOW(window)->title, "\");\n");
  if (!GTK_WIDGET_SENSITIVE(window))
    color_line(3, "gtk_widget_sensitive(", gtk_widget_get_name(window),
	       ", FALSE);\n");
  if (GTK_WIDGET_VISIBLE(window))
    color_line(3, "gtk_widget_show(", gtk_widget_get_name(window), ");\n");
  else
    color_line(3, "gtk_widget_realize(", gtk_widget_get_name(window), ");\n");
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
}









