/*
** code_gen_frame.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:28:34 2000 Sebastien Thebert
** Last update Sat Apr  1 23:42:15 2000 Sebastien Thebert
*/
#include "main.h"

/*
** line_create_frame
*/
void	line_create_frame(GtkWidget *frame)
{
  char	*str1, *str2, *str3, *str4;
  
  str1 = int_to_str(frame->parent->allocation.x);
  str2 = int_to_str(frame->parent->allocation.y);
  str3 = int_to_str(frame->parent->allocation.width);
  str4 = int_to_str(frame->parent->allocation.height);
  color_line(13, "create_", gtk_widget_get_name(frame), "(fixed, ",
	     str1, ", ", str2, ", ", str3, ", ", str4, ", \"",
	     GTK_FRAME(frame)->label, "\");\n");
  free(str1);
  free(str2);
  free(str3);
  free(str4);
}

/***********************************************************/
void	create_frame_code(char *name_win, GtkWidget *frame)
{
  char	*line;
  char	*fct_line;
  
  fct_line = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH); 
  freeze_edit_text(name_win);
  add_to_widget_list(gtk_widget_get_name(frame), FRAME);
  
  concat(&fct_line, 2, "void create_", get_container_name(frame));     
  
  get_container_last_line(&line, frame);
  
  seek_in_fct_before(fct_line, line);
  line_create_frame(frame);
  
  concat(&line, 3, "void create_", name_win, "(void)\n");
  seek_before(line);
  color_line(3, "void create_", gtk_widget_get_name(frame),
	     "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height, gchar *label)\n");  
  coloration("{\n");
  coloration("GtkWidget *frame;\n");
  coloration("GtkWidget *fixed;\n\n");
  coloration("frame = gtk_frame_new(label);\n"); 
  coloration("fixed = gtk_fixed_new();\n");
  coloration("gtk_widget_show(fixed);\n");
  coloration("gtk_widget_set_usize(frame, width, height);\n");
  
  if (!GTK_WIDGET_SENSITIVE(frame))
    coloration("gtk_widget_sensitive(frame, FALSE);\n");
  
  if (GTK_WIDGET_VISIBLE(frame))
    coloration("gtk_widget_show(frame);\n");
  else
    coloration("gtk_widget_realize(frame);\n");
  
  coloration("gtk_container_add(GTK_CONTAINER(frame), fixed);\n");   
  coloration("gtk_fixed_put(GTK_FIXED(fixed_parent), frame, x, y);\n");
  coloration("}\n\n");
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}

/***********************************************************/
void	delete_frame_code(char *name_win, GtkWidget *frame)
{
  char	*line, *fct_line;
  gint	pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  fct_line = xmalloc(sizeof (char) * LENGTH);
  freeze_edit_text(name_win);
  concat(&fct_line, 2, "create_", get_container_name(frame));
  concat(&line, 3, "create_", gtk_widget_get_name(frame), "(");
  delete_line(line, search_string(fct_line, 0));
  concat(&line, 3, "void create_", gtk_widget_get_name(frame),
	 "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height, gchar *label)\n");  
  pos = search_string(line, 0);
  strcpy(line, "gtk_fixed_put(GTK_FIXED(fixed_parent), frame, x, y);\n");
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos);
  delete_line("}\n\n", pos);
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}

/***********************************************************/
void	refresh_frame_code(char *name_win, GtkWidget *frame)
{
  char	*line;
  char	*fct_line;
  gint	pos;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  fct_line = xmalloc(sizeof (char) * FN_LENGTH);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  concat(&fct_line, 2, "create_", get_container_name(frame));
  concat(&line, 3, "create_", gtk_widget_get_name(frame), "(");
  
  delete_line(line, search_string(fct_line, 0)); 
  line_create_frame(frame);
  
  concat(&fct_line, 3, "void create_", gtk_widget_get_name(frame),
	 "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height, gchar *label)\n");  
  
  strcpy(line, "gtk_widget_show(frame);\n");
  pos = search_string(fct_line, 0);
  if (search_string(line, pos) == -1)
    strcpy(line, "gtk_widget_realize(frame);\n");
  delete_line(line, pos);
  if (GTK_WIDGET_VISIBLE(frame))
    coloration("gtk_widget_show(frame);\n");
  else
    coloration("gtk_widget_realize(frame);\n");
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}
