/*
** code_gen_label.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Sun Jan 23 21:26:02 2000 Sebastien Thebert
** Last update Sat Apr  1 23:39:37 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
void	create_label_code(char *name_win, GtkWidget *label)
{
  char	*label_str;
  char	*fct_line;
  char	*line;
  
  fct_line = xmalloc(sizeof (char) * FN_LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  add_to_widget_list(gtk_widget_get_name(label), LABEL);
  freeze_edit_text(name_win);
  write_widget_declaration(label, fct_line);
  
  get_container_last_line(&line, label);
  seek_in_fct_before(fct_line, line);
  
  gtk_label_get(GTK_LABEL(label), &label_str);
  color_line(4, gtk_widget_get_name(label), " = gtk_label_new(\"",
	     label_str, "\");\n");
  
  write_widget_set_size(label);
  write_widget_sensitive_show_and_put(label);
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(fct_line);
}

/***********************************************************/
void		delete_label_code(char *name_win, GtkWidget *label)
{
  char		*line;
  gint		pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof(char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(label));
  pos_fct_begin = search_string(line, 0);
  concat(&line, 2, gtk_widget_get_name(label), " = gtk_label_new(\""); 
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),",
	 gtk_widget_get_name(label)); 
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(label));
  delete_line(line, pos_fct_begin);
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
}

/***********************************************************/
void	refresh_label_code(char *name_win, GtkWidget *label)
{
  delete_label_code(name_win, label);
  create_label_code(name_win, label);
}

