/*
** code_gen_notebook.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:34:09 2000 Sebastien Thebert
** Last update Sat Apr  1 23:37:35 2000 Sebastien Thebert
*/
#include "main.h"

/*
** line_create_notebook
*/
void	line_create_notebook(GtkWidget *nb)
{
  char	*str1, *str2, *str3, *str4;
  
  str1 = int_to_str(nb->allocation.x);
  str2 = int_to_str(nb->allocation.y);
  str3 = int_to_str(nb->allocation.width);
  str4 = int_to_str(nb->allocation.height);
  color_line(11, "create_", gtk_widget_get_name(nb), "(fixed, ",
	     str1, ", ", str2, ", ", str3, ", ", str4, ");\n");
  free(str1);
  free(str2);
  free(str3);
  free(str4);
}

/***********************************************************/
void	create_notebook_code(char *name_win, GtkWidget *nb)
{
  char	*line;
  char	*fct_line;
  
  fct_line = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH); 
  freeze_edit_text(name_win);
  add_to_widget_list(gtk_widget_get_name(nb), NOTEBOOK);
  
  concat(&fct_line, 2, "void create_", get_container_name(nb));     
  get_container_last_line(&line, nb);
  seek_in_fct_before(fct_line, line);
  line_create_notebook(nb);
  
  concat(&line, 3, "void create_", name_win, "(void)\n");
  seek_before(line);
  color_line(3, "void create_", gtk_widget_get_name(nb),
	     "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height)\n");  
  coloration("{\n");
  coloration("GtkWidget *notebook;\n");
  coloration("GtkWidget *fixed;\n\n");
  coloration("notebook = gtk_notebook_new();\n"); 
  coloration("gtk_widget_set_usize(notebook, width, height);\n");
  
  if (GTK_NOTEBOOK(nb)->tab_pos == GTK_POS_LEFT)
    coloration("gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_LEFT);\n");
  else if (GTK_NOTEBOOK(nb)->tab_pos == GTK_POS_RIGHT)
    coloration("gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_RIGHT);\n");
  else if (GTK_NOTEBOOK(nb)->tab_pos == GTK_POS_TOP)
    coloration("gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);\n");
  else if (GTK_NOTEBOOK(nb)->tab_pos == GTK_POS_BOTTOM)
    coloration("gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_BOTTOM);\n");
  
  if (!GTK_WIDGET_SENSITIVE(nb))
    coloration("gtk_widget_sensitive(notebook, FALSE);\n");
  
  if (GTK_WIDGET_VISIBLE(nb))
    coloration("gtk_widget_show(notebook);\n"); 
  else
    coloration("gtk_widget_realize(notebook);\n");
  
  coloration("gtk_fixed_put(GTK_FIXED(fixed_parent), notebook, x, y);\n");
  coloration("}\n\n");
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line); 
}

/***********************************************************/
void	delete_notebook_code(char *name_win, GtkWidget *nb)
{
  char	*name_text, *line, *fct_line;
  gint	pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  fct_line = xmalloc(sizeof (char) * LENGTH);
  name_text = xmalloc(sizeof (char) * LENGTH);
  concat(&name_text, 2, "text_", name_win);
  epingle->edit_text =
    gtk_object_get_data(GTK_OBJECT(epingle->editor_notebook), name_text);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  concat(&fct_line, 2, "create_", get_container_name(nb));
  concat(&line, 3, "create_", gtk_widget_get_name(nb), "(");
  delete_line(line, search_string(fct_line, 0));
  concat(&line, 2, "void create_", gtk_widget_get_name(nb),
	 "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height)\n");  
  pos = search_string(line, 0);
  strcpy(line, "gtk_fixed_put(GTK_FIXED(fixed_parent), notebook, x, y);\n");
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos);
  delete_line("}\n\n", pos);
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(name_text);
  free(line);
  free(fct_line);
}

/***********************************************************/
void	refresh_notebook_code(char *name_win, GtkWidget *nb)
{
  char	*line, *fct_line;
  gint	pos;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  fct_line = xmalloc(sizeof (char) * LENGTH);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  concat(&fct_line, 2, "create_", get_container_name(nb));
  concat(&line, 3, "create_", gtk_widget_get_name(nb), "(");
  
  delete_line(line, search_string(fct_line, 0));
  line_create_notebook(nb);
  
  concat(&fct_line, 3, "void create_", gtk_widget_get_name(nb),
	 "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height)\n");  
  
  strcpy(line, "gtk_widget_show(notebook);\n");
  pos = search_string(fct_line, 0);
  if (search_string(line, pos) == -1)
    strcpy(line, "gtk_widget_realize(notebook);\n");
  delete_line(line, pos);
  if (GTK_WIDGET_VISIBLE(nb))
    coloration("gtk_widget_show(notebook);\n");
  else
    coloration("gtk_widget_realize(notebook);\n");
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}








