/*
** code_gen_optionmenu.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:46:14 2000 Sebastien Thebert
** Last update Sat Apr  1 23:36:25 2000 Sebastien Thebert
*/
#include "main.h"

/*
** line_set_usize
*/
void	line_set_usize(GtkWidget *option_menu)
{
  char	*str1;
  char	*str2;
  
  str1 = int_to_str(option_menu->allocation.width);
  str2 = int_to_str(option_menu->allocation.height);
  color_line(7, "gtk_widget_set_usize(", gtk_widget_get_name(option_menu),
	     ", ", str1, ", ", str2, ");\n");
  free(str1);
  free(str2);
}

void	line_put(GtkWidget *option_menu)
{
  char	*str1;
  char	*str2;
  
  str1 = int_to_str(option_menu->allocation.x);
  str2 = int_to_str(option_menu->allocation.y);
  color_line(7, "gtk_fixed_put(GTK_FIXED(fixed),",
	     gtk_widget_get_name(option_menu), ",", str1, ",", str2, ");\n");
  free(str1);
  free(str2); 
}

/***********************************************************/
void		create_option_menu_code(char *name_win, GtkWidget *option_menu)
{
  char		*fct_line;
  char		*line;
  char		*str_list;
  GtkWidget	*menu, *list_item, *label_widget;
  GList		*children;
  gint		i;
  
  fct_line = xmalloc(sizeof (char) * FN_LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  add_to_widget_list(gtk_widget_get_name(option_menu), OPTION_MENU);
  
  concat(&fct_line, 2, "void create_", get_container_name(option_menu)); 
  seek_in_fct_after(fct_line, "fixed;\n");
  color_line(3, "GtkWidget *", gtk_widget_get_name(option_menu), ";\n");
  
  get_container_last_line(&line, option_menu);
  
  seek_in_fct_before(fct_line, line);
  color_line(2, gtk_widget_get_name(option_menu),
	     " = gtk_option_menu_new();\n");
  menu = gtk_option_menu_get_menu(GTK_OPTION_MENU(option_menu));
  if (menu)
    {
      children = GTK_MENU_SHELL(menu)->children;
      color_line(3, "menu_", gtk_widget_get_name(option_menu),
		 " = gtk_menu_new();\n");
      for(i = 0; i < g_list_length(children); i++) 
	{
	  list_item = g_list_nth(children, i)->data;
	  label_widget = g_list_first(gtk_container_children
				      (GTK_CONTAINER(list_item)))->data;
	  gtk_label_get(GTK_LABEL(label_widget), &str_list);
	  color_line(3, "menu_item = gtk_menu_item_new_with_label(\"",
		     str_list, "\");\n");
	  color_line(3, "gtk_menu_append(GTK_MENU(menu_",
		     gtk_widget_get_name(option_menu), "), menu_item);\n");
	  coloration("gtk_widget_show(menu_item);\n"); 
	}
    }
  if (GTK_WIDGET_VISIBLE(option_menu))
    color_line(3, "gtk_widget_show(",
	       gtk_widget_get_name(option_menu), ");\n");
  else
    color_line(3, "gtk_widget_realize(",
	       gtk_widget_get_name(option_menu), ");\n");
  line_set_usize(option_menu);
  line_put(option_menu);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(fct_line);
  free(line);
}

/***********************************************************/
void	delete_option_menu_code(char *name_win, GtkWidget *option_menu)
{
  char		*line;
  gint		pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof(char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(option_menu));
  pos_fct_begin = search_string(line, 0);  
  concat(&line, 2, gtk_widget_get_name(option_menu),
	 " = gtk_option_menu_new();\n"); 
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),",
	 gtk_widget_get_name(option_menu)); 
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(option_menu));
  delete_line(line, pos_fct_begin);  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));  
  free(line);
}

/***********************************************************/
void	refresh_option_menu_code(char *name_win, GtkWidget *option_menu)
{
  delete_option_menu_code(name_win, option_menu);
  create_option_menu_code(name_win, option_menu);
}
