/*
** code_gen_progressbar.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:40:58 2000 Sebastien Thebert
** Last update Sat Apr  1 23:35:41 2000 Sebastien Thebert
*/
#include "main.h"

/*
** write_pb_orientation
*/
void	write_pb_orientation(GtkWidget *pb)
{
  if (GTK_PROGRESS_BAR(pb)->orientation == GTK_PROGRESS_LEFT_TO_RIGHT)
    color_line(3, "gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(",
	       gtk_widget_get_name(pb), "), GTK_PROGRESS_LEFT_TO_RIGHT);\n"); 
  else if (GTK_PROGRESS_BAR(pb)->orientation == GTK_PROGRESS_RIGHT_TO_LEFT)
    color_line(3, "gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(",
	       gtk_widget_get_name(pb), "), GTK_PROGRESS_RIGHT_TO_LEFT);\n"); 
  else if (GTK_PROGRESS_BAR(pb)->orientation == GTK_PROGRESS_BOTTOM_TO_TOP)
    color_line(3, "gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(",
	       gtk_widget_get_name(pb), "), GTK_PROGRESS_BOTTOM_TO_TOP);\n");  
  else if (GTK_PROGRESS_BAR(pb)->orientation == GTK_PROGRESS_TOP_TO_BOTTOM)
    color_line(3, "gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(",
	       gtk_widget_get_name(pb), "), GTK_PROGRESS_TOP_TO_BOTTOM);\n");  
}

/*
** write_pb_style
*/
void	write_pb_style(GtkWidget *pb)
{
  if (GTK_PROGRESS_BAR(pb)->bar_style == GTK_PROGRESS_CONTINUOUS)
    color_line(3, "gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(",
	       gtk_widget_get_name(pb), "), GTK_PROGRESS_CONTINUOUS);\n");
  else
    color_line(3, "gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(",
	       gtk_widget_get_name(pb), "), GTK_PROGRESS_DISCRETE);\n");
}

/*
** write_pb_text
*/
void	write_pb_text(GtkWidget *pb)
{
  if (GTK_PROGRESS(pb)->show_text)
    color_line(3, "gtk_progress_set_show_text(GTK_PROGRESS(",
	       gtk_widget_get_name(pb), "), TRUE);\n");
  else
    color_line(3, "gtk_progress_set_show_text(GTK_PROGRESS(",
	       gtk_widget_get_name(pb), "), FALSE);\n");
}

/*
** write_pb_percentage
*/
void	write_pb_percentage(GtkWidget *pb)
{
  gint	percent;
  char	*str;
  
  percent = 100 * gtk_progress_get_current_percentage(GTK_PROGRESS(pb));
  str = int_to_str(percent);
  color_line(5, "gtk_progress_bar_update(GTK_PROGRESS_BAR(",
	     gtk_widget_get_name(pb), "), 0.", str, ");\n");
  free(str);
}

/*
** create_progress_bar_code
*/
void	create_progress_bar_code(char *name_win, GtkWidget *pb)
{
  char	*fct_line;
  char	*line;
  
  fct_line = xmalloc(sizeof (char) * FN_LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  add_to_widget_list(gtk_widget_get_name(pb), PROGRESS_BAR);
  
  write_widget_declaration(pb, fct_line);
  
  get_container_last_line(&line, pb);
  seek_in_fct_before(fct_line, line);
  color_line(2, gtk_widget_get_name(pb), " = gtk_progress_bar_new();\n");
  
  write_widget_set_size(pb);
  write_pb_orientation(pb);
  write_pb_style(pb);
  write_pb_text(pb);
  write_pb_percentage(pb);
  write_widget_show(pb);
  write_widget_put(pb);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}

/*
** delete_progress_bar_code
*/
void	delete_progress_bar_code(char *name_win, GtkWidget *pb)
{
  char	*line;
  gint	pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(pb));
  pos_fct_begin = search_string(line, 0);  
  concat(&line, 2, gtk_widget_get_name(pb), " = gtk_progress_bar_new();\n"); 
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),",
	 gtk_widget_get_name(pb)); 
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2 - pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(pb));
  delete_line(line, pos_fct_begin);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));  
  free(line);
}

/*
** refresh_progress_bar_code
*/
void	refresh_progress_bar_code(char *name_win, GtkWidget *pb)
{
  delete_progress_bar_code(name_win, pb);
  create_progress_bar_code(name_win, pb);
}

