/*
** code_gen_table.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:36:59 2000 Sebastien Thebert
** Last update Sat Apr  1 23:35:03 2000 Sebastien Thebert
*/
#include "main.h"

/*
** line_create_table
*/
void	line_table_attach(GtkTableChild *child)
{
  char	*str1, *str2, *str3, *str4;
  
  str1 = int_to_str(child->left_attach);
  str2 = int_to_str(child->right_attach);
  str3 = int_to_str(child->top_attach);
  str4 = int_to_str(child->bottom_attach);
  color_line(11, "gtk_table_attach_defaults(GTK_TABLE(table), ",
	     gtk_widget_get_name(child->widget), ", ",
	     str1, ", ", str2, ", ", str3, ", ", str4, ");\n");
  free(str1);
  free(str2);
  free(str3);
  free(str4); 
}

/*
** create_widget_in_table_code
*/
void	create_widget_in_table_code(char *name_win, GtkTableChild *child)
{
  char	*line, *fct_line;
  
  fct_line = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH); 
  add_to_widget_list(gtk_widget_get_name(child->widget), TABLE);
  concat(&fct_line, 2, "void create_", get_container_name(child->widget));
  seek_in_fct_after(fct_line, "fixed;\n");
  color_line(3, "GtkWidget *", gtk_widget_get_name(child->widget), ";\n");
  get_container_last_line(&line, child->widget);
  seek_in_fct_before(fct_line, line);
  if (GTK_IS_CHECK_BUTTON(child->widget))
    color_line(4, gtk_widget_get_name(child->widget),
	       " = gtk_check_button_new_with_label(\"",
	       gtk_widget_get_name(child->widget), "\");\n");
  else if (GTK_IS_TOGGLE_BUTTON(child->widget))
    color_line(4, gtk_widget_get_name(child->widget),
	       " = gtk_toggle_button_new_with_label(\"",
	       gtk_widget_get_name(child->widget), "\");\n");
  else if (GTK_IS_BUTTON(child->widget))
    color_line(4, gtk_widget_get_name(child->widget),
	       " = gtk_button_new_with_label(\"",
	       gtk_widget_get_name(child->widget), "\");\n");
  if (GTK_IS_LABEL(child->widget))
    color_line(4, gtk_widget_get_name(child->widget), " = gtk_label_new(\"",
	       gtk_widget_get_name(child->widget), "\");\n");
  if (GTK_IS_ENTRY(child->widget))
    color_line(2, gtk_widget_get_name(child->widget), " = gtk_entry_new();\n");
  if (GTK_IS_COMBO(child->widget))
    color_line(2, gtk_widget_get_name(child->widget), " = gtk_combo_new();\n");
  if (GTK_IS_DRAWING_AREA(child->widget))
    color_line(2, gtk_widget_get_name(child->widget),
	       " = gtk_drawing_area_new();\n");
  
  color_line(3, "gtk_widget_show(", gtk_widget_get_name(child->widget),
	     ");\n");
  line_table_attach(child);
}

/*
** line_create_table
*/
void	line_create_table(GtkWidget *table)
{
  char	*str1, *str2, *str3, *str4;
  char	*str5, *str6, *str7, *str8;
  
  str1 = int_to_str(table->parent->allocation.x);
  str2 = int_to_str(table->parent->allocation.y);
  str3 = int_to_str(table->parent->allocation.width);
  str4 = int_to_str(table->parent->allocation.height);
  str5 = int_to_str(GTK_TABLE(table)->nrows);
  str6 = int_to_str(GTK_TABLE(table)->ncols);
  str7 = int_to_str(GTK_TABLE(table)->row_spacing);
  str8 = int_to_str(GTK_TABLE(table)->column_spacing);
  color_line(19, "create_", gtk_widget_get_name(table), "(fixed, ",
	     str1, ", ", str2, ", ", str3, ", ", str4, ", ",
	     str5, ", ", str6, ", ", str7, ", ", str8, ");\n");
  free(str1);
  free(str2);
  free(str3);
  free(str4);
  free(str5);
  free(str6);
  free(str7);
  free(str8);
}

/*
** create_table_code
*/
void		create_table_code(char *name_win, GtkWidget *table)
{
  char		*name_text;
  char		*line, *fct_line;
  gint		i;
  GtkTableChild *table_child;
  
  name_text = xmalloc(sizeof (char) * LENGTH);
  fct_line = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * 300); 
  concat(&name_text, 2, "text_", name_win);
  epingle->edit_text =
    gtk_object_get_data(GTK_OBJECT(epingle->editor_notebook), name_text);
  add_to_widget_list(gtk_widget_get_name(table), TABLE);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  
  concat(&fct_line, 2, "void create_", get_container_name(table));     
  get_container_last_line(&line, table);
  
  seek_in_fct_before(fct_line, line);
  line_create_table(table);  
  concat(&line, 3, "void create_", name_win, "(void)\n");
  seek_before(line);
  color_line(4, "void create_", gtk_widget_get_name(table),
	     "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height, ",
	     "gint rows, gint columns, gint rows_spacing, gint columns_spacing)\n");  
  coloration("{\n");
  coloration("GtkWidget *table;\n");
  coloration("GtkWidget *fixed;\n\n");
  
  coloration("table = gtk_table_new(rows, columns, TRUE);\n"); 
  coloration("gtk_table_set_row_spacings(GTK_TABLE(table), rows_spacing);\n");
  coloration("gtk_table_set_col_spacings(GTK_TABLE(table), columns_spacing);\n");
  coloration("gtk_widget_set_usize(table, width, height);\n");
  
  if (GTK_WIDGET_VISIBLE(table))
    coloration("gtk_widget_show(table);\n");
  else
    coloration("gtk_widget_realize(table);\n");
  
  coloration("gtk_fixed_put(GTK_FIXED(fixed_parent), table, x, y);\n");
  coloration("}\n\n");
  
  for (i = 0; i < g_list_length(GTK_TABLE(table)->children); i++)
    {
      table_child = g_list_nth(GTK_TABLE(table)->children, i)->data;
      create_widget_in_table_code(name_win, table_child);
    }
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(name_text);
  free(line);
  free(fct_line); 
}

/*
** delete_table_code
*/
void	delete_table_code(char *name_win, GtkWidget *table)
{
  char	*line, *fct_line;
  gint	pos, pos2;
  
  line = xmalloc(sizeof (char) * 300);
  fct_line = xmalloc(sizeof (char) * LENGTH);
  freeze_edit_text(name_win);
  concat(&fct_line, 2, "create_", get_container_name(table));
  concat(&line, 3, "create_", gtk_widget_get_name(table), "(");
  delete_line(line, search_string(fct_line, 0));
  concat(&line, 4, "void create_", gtk_widget_get_name(table),
	 "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height, ", 
	 "gint rows, gint columns, gint rows_spacing, gint columns_spacing)\n");  
  pos = search_string(line, 0);
  strcpy(line, "gtk_fixed_put(GTK_FIXED(fixed_parent), table, x, y);\n");
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos);
  delete_line("}\n\n", pos);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}

/*
** refresh_table_code
*/ 
void	refresh_table_code(char *name_win, GtkWidget *table)
{
  char	*line, *fct_line;
  gint	pos;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  fct_line = xmalloc(sizeof (char) * 300);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  concat(&fct_line, 2, "create_", get_container_name(table));
  concat(&line, 3, "create_", gtk_widget_get_name(table), "(");
  delete_line(line, search_string(fct_line, 0));  
  line_create_table(table);
  concat(&fct_line, 3, "void create_", gtk_widget_get_name(table),
	 "(GtkWidget *fixed_parent, gint x, gint y, gint width, gint height, ",
	 "gint rows, gint columns, gint rows_spacing, gint columns_spacing)\n");    
  strcpy(line, "gtk_widget_show(table);\n");
  pos = search_string(fct_line, 0);
  if (search_string(line, pos) == -1)
    strcpy(line, "gtk_widget_realize(table);\n");
  delete_line(line, pos);
  if (GTK_WIDGET_VISIBLE(table))
    coloration("gtk_widget_show(table);\n");
  else
    coloration("gtk_widget_realize(table);\n");  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line);
  free(fct_line);
}
