/*
** code_gen_text.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 03:59:41 2000 Sebastien Thebert
** Last update Sat Apr  1 23:33:18 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
void	create_gtktext_code(char *name_win, GtkWidget *gtktext)
{
  char	*fct_line;
  char	*line;
  
  fct_line = xmalloc(sizeof (char) * FN_LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  add_to_widget_list(gtk_widget_get_name(gtktext), TEXT);
  
  write_widget_declaration(gtktext, fct_line);
  
  get_container_last_line(&line, gtktext);
  seek_in_fct_before(fct_line, line);
  color_line(2, gtk_widget_get_name(gtktext),
	     " = gtk_text_new(NULL, NULL);\n");
  if (!(GTK_TEXT(gtktext)->editable.editable))
    color_line(3, "gtk_text_set_editable(GTK_TEXT(",
	       gtk_widget_get_name(gtktext), "), FALSE);\n");
  
  write_widget_set_size(gtktext);
  write_widget_sensitive_show_and_put(gtktext);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(fct_line);
}


/***********************************************************/
void		delete_gtktext_code(char *name_win, GtkWidget *gtktext)
{
  char		*line;
  gint		pos_fct_begin, pos, pos2;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  freeze_edit_text(name_win);
  concat(&line, 2, "void create_", get_container_name(gtktext));
  pos_fct_begin = search_string(line, 0);
  concat(&line, 2, gtk_widget_get_name(gtktext),
	 " = gtk_text_new(NULL, NULL);"); 
  pos = search_string(line, pos_fct_begin);
  concat(&line, 2, "gtk_fixed_put(GTK_FIXED(fixed),",
	 gtk_widget_get_name(gtktext)); 
  pos2 = search_string(line, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
  delete_line(line, pos_fct_begin);
  concat(&line, 2, "GtkWidget *", gtk_widget_get_name(gtktext));
  delete_line(line, pos_fct_begin);
  
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));  
  free(line);
}


/***********************************************************/
void	refresh_gtktext_code(char *name_win, GtkWidget *gtktext)
{
  delete_gtktext_code(name_win, gtktext);
  create_gtktext_code(name_win, gtktext);
}
