/*
** code_gen_tooltips.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Wed Jan 26 03:30:18 2000 Sebastien Thebert
** Last update Sat Apr  1 23:32:29 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
void			create_tooltips_code(char *name_win, GtkWidget *widget)
{
  char			*fct_line, *line;
  GtkTooltipsData	*tooltips_data = NULL;
  
  tooltips_data = gtk_tooltips_data_get(widget);   
  if (tooltips_data)
    {
      fct_line = xmalloc(sizeof (char) * FN_LENGTH);
      line = xmalloc(sizeof (char) * FN_LENGTH);
      freeze_edit_text(name_win);
      concat(&fct_line, 2, "void create_", get_container_name(widget));
      get_container_last_line(&line, widget);
      seek_in_fct_before(fct_line, line);
      color_line(5, "gtk_tooltips_set_tip(tooltips, ",
		 gtk_widget_get_name(widget), ", \"",
		 tooltips_data->tip_text, "\", NULL);\n");
      gtk_text_thaw(GTK_TEXT(epingle->edit_text));
      free(fct_line);
      free(line);
    }
}

/***********************************************************/
void			delete_tooltips_code(char *name_win, GtkWidget *widget)
{
  char			*line;
  gint			pos_fct_begin;
  GtkTooltipsData	*tooltips_data = NULL;
  
  tooltips_data = gtk_tooltips_data_get(widget);  
  if (tooltips_data)
    {
      line = xmalloc(sizeof (char) * FN_LENGTH);
      freeze_edit_text(name_win);
      concat(&line, 2, "void create_", get_container_name(widget));
      pos_fct_begin = search_string(line, 0);
      concat(&line, 5, "gtk_tooltips_set_tip(tooltips, ",
	     gtk_widget_get_name(widget), ", \"",
	     tooltips_data->tip_text, "\", NULL);\n");
      delete_line(line, pos_fct_begin);
      gtk_text_thaw(GTK_TEXT(epingle->edit_text));
      free(line);
    }
}


