/*
** code_gen_window.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Tue Jan 25 22:24:10 2000 Sebastien Thebert
** Last update Sat Apr  1 23:46:11 2000 Sebastien Thebert
*/
#include "main.h"

/*
** create window code
*/
void	create_window_code(GtkWidget *window)
{
  seek_before("}");
  color_line(3, "GtkWidget *", gtk_widget_get_name(window), ";\n");   
  coloration("GtkWidget *fixed;\n\n");
  coloration("fixed = gtk_fixed_new();\n");
  coloration("gtk_widget_show(fixed);\n");
  if (GTK_WINDOW(window)->type == GTK_WINDOW_TOPLEVEL)
    color_line(2, gtk_widget_get_name(window),
	       " = gtk_window_new(GTK_WINDOW_TOPLEVEL);\n");  
  else if (GTK_WINDOW(window)->type == GTK_WINDOW_DIALOG)
    color_line(2, gtk_widget_get_name(window),
	       " = gtk_window_new(GTK_WINDOW_DIALOG);\n");  
  else if (GTK_WINDOW(window)->type == GTK_WINDOW_POPUP)
    color_line(2, gtk_widget_get_name(window),
	       " = gtk_window_new(GTK_WINDOW_POPUP);\n");  
  if (GTK_WINDOW(window)->position == GTK_WIN_POS_NONE)
    color_line(3, "gtk_window_set_position(GTK_WINDOW(",
	       gtk_widget_get_name(window), "), GTK_WIN_POS_NONE);\n");
  else if (GTK_WINDOW(window)->position == GTK_WIN_POS_CENTER)
    color_line(3, "gtk_window_set_position(GTK_WINDOW(",
	       gtk_widget_get_name(window), "), GTK_WIN_POS_CENTER);\n");
  else if (GTK_WINDOW(window)->position == GTK_WIN_POS_MOUSE)
    color_line(3, "gtk_window_set_position(GTK_WINDOW(",
	       gtk_widget_get_name(window),"), GTK_WIN_POS_MOUSE);\n");
  color_line(5, "gtk_window_set_title(GTK_WINDOW(",
	     gtk_widget_get_name(window), "), \"",
	     GTK_WINDOW(window)->title, "\");\n");
  if (!GTK_WIDGET_SENSITIVE(window))
    color_line(3, "gtk_widget_sensitive(", gtk_widget_get_name(window),
	       ", FALSE);\n");
  color_line(3, "gtk_container_add(GTK_CONTAINER(",
	     gtk_widget_get_name(window), "), fixed);\n"); 
  if (GTK_WIDGET_VISIBLE(window))
    color_line(3, "gtk_widget_show(", gtk_widget_get_name(window), ");\n");
  else
    color_line(3, "gtk_widget_realize(", gtk_widget_get_name(window), ");\n");
}


/***********************************************************/
void	refresh_window_code(GtkWidget *window)
{
  char	*line;
  gint	pos_fct_begin, pos, pos2;
  
  if (GTK_IS_FILE_SELECTION(window))
    refresh_file_selector_code(window);
  else if (GTK_IS_COLOR_SELECTION_DIALOG(window))
    refresh_color_selector_code(window);
  else if (GTK_IS_FONT_SELECTION_DIALOG(window))
    refresh_font_selector_code(window);
  else
    {
      line = xmalloc(sizeof (char) * FN_LENGTH);
      freeze_edit_text(gtk_widget_get_name(window));
      concat(&line, 2, "void create_", gtk_widget_get_name(window));
      pos_fct_begin = search_string(line, 0);
      concat(&line, 2, gtk_widget_get_name(window), " = gtk_window_new(");
      pos = search_string(line, pos_fct_begin);
      concat(&line, 2, "gtk_container_add(GTK_CONTAINER(",
	     gtk_widget_get_name(window));
      pos2 = search_string(line, pos);
      gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
      gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
      delete_line(line, pos);
      
      if (GTK_WINDOW(window)->type == GTK_WINDOW_TOPLEVEL)
	color_line(2, gtk_widget_get_name(window),
		   " = gtk_window_new(GTK_WINDOW_TOPLEVEL);\n");  
      else if (GTK_WINDOW(window)->type == GTK_WINDOW_DIALOG)
	color_line(2, gtk_widget_get_name(window),
		   " = gtk_window_new(GTK_WINDOW_DIALOG);\n");  
      else if (GTK_WINDOW(window)->type == GTK_WINDOW_POPUP)
	color_line(2, gtk_widget_get_name(window),
		   " = gtk_window_new(GTK_WINDOW_POPUP);\n");  
      if (GTK_WINDOW(window)->position == GTK_WIN_POS_NONE)
	color_line(3, "gtk_window_set_position(GTK_WINDOW(",
		   gtk_widget_get_name(window), "), GTK_WIN_POS_NONE);\n");
      else if (GTK_WINDOW(window)->position == GTK_WIN_POS_CENTER)
	color_line(3, "gtk_window_set_position(GTK_WINDOW(",
		   gtk_widget_get_name(window), "), GTK_WIN_POS_CENTER);\n");
      else if (GTK_WINDOW(window)->position == GTK_WIN_POS_MOUSE)
	color_line(3, "gtk_window_set_position(GTK_WINDOW(",
		   gtk_widget_get_name(window), "), GTK_WIN_POS_MOUSE);\n");
      color_line(5, "gtk_window_set_title(GTK_WINDOW(",
		 gtk_widget_get_name(window), "), \"",
		 GTK_WINDOW(window)->title, "\");\n");
      if (!GTK_WIDGET_SENSITIVE(window))
	color_line(3, "gtk_widget_sensitive(", gtk_widget_get_name(window),
		   ", FALSE);\n");
      color_line(3, "gtk_container_add(GTK_CONTAINER(",
		 gtk_widget_get_name(window), "), fixed);\n"); 
      concat(&line, 3, "gtk_widget_show(", gtk_widget_get_name(window),");\n");
      if (search_string(line, pos) == -1)
	concat(&line, 3, "gtk_widget_realize(", gtk_widget_get_name(window),
	       ");\n");
      delete_line(line, pos);
      if (GTK_WIDGET_VISIBLE(window))
	color_line(3, "gtk_widget_show(", gtk_widget_get_name(window),");\n");
      else
	color_line(3, "gtk_widget_realize(", gtk_widget_get_name(window),
		   ");\n");
      gtk_text_thaw(GTK_TEXT(epingle->edit_text));
      free(line);
    }
}
