/*
** code_generator.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Thu Mar 18 16:13:12 1999 sebastien thebert
** Last update Tue Apr  4 18:07:14 2000 Sebastien Thebert
*/
#include "main.h"
#include "code_gen_window.h"

/***********************************************************/
void		create_widget_code(GtkWidget *widget)
{
  GtkWidget	*win_parent;
  
  win_parent = widget;
  while (!GTK_IS_WINDOW(win_parent))
    win_parent = win_parent->parent;
  if (GTK_IS_RADIO_BUTTON(widget))
    ;
  else if (GTK_IS_CHECK_BUTTON(widget))
    create_button_code(gtk_widget_get_name(win_parent),
		       widget, CHECK_BUTTON);
  else if (GTK_IS_TOGGLE_BUTTON(widget))
    create_button_code(gtk_widget_get_name(win_parent),
		       widget, TOGGLE_BUTTON);
  else if (GTK_IS_BUTTON(widget))
    create_button_code(gtk_widget_get_name(win_parent),
		       widget, BUTTON);
  if (GTK_IS_LABEL(widget))
    create_label_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_ENTRY(widget))
    create_entry_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_COMBO(widget))
    create_combo_box_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_TEXT(widget))
    create_gtktext_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_DRAWING_AREA(widget))
    create_drawing_area_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_OPTION_MENU(widget))
    create_option_menu_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_PROGRESS_BAR(widget))
    create_progress_bar_code(gtk_widget_get_name(win_parent), widget);
}

/***********************************************************/
void		refresh_widget_code(GtkWidget *widget)
{
  GtkWidget	*win_parent;
  GList		*list = NULL;
  
  if (epingle->widget_clicked != NULL)
    {
      win_parent = widget;
      while (!GTK_IS_WINDOW(win_parent))
	win_parent = win_parent->parent;
      
      if (GTK_IS_FIXED(widget))
	widget = epingle->widget_clicked;
      
      if (GTK_IS_EVENT_BOX(widget))
	{
	  list = gtk_container_children(GTK_CONTAINER(widget));
	  widget = g_list_first(list)->data;
	}
      if (GTK_IS_RADIO_BUTTON(widget))
	;
      else if (GTK_IS_CHECK_BUTTON(widget))
	refresh_button_code(gtk_widget_get_name(win_parent),
			    widget, CHECK_BUTTON);
      else if (GTK_IS_TOGGLE_BUTTON(widget))
	refresh_button_code(gtk_widget_get_name(win_parent),
			    widget, TOGGLE_BUTTON);
      else if (GTK_IS_BUTTON(widget))
	refresh_button_code(gtk_widget_get_name(win_parent),
			    widget, BUTTON);
      if (GTK_IS_LABEL(widget))
	refresh_label_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_ENTRY(widget))
	refresh_entry_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_COMBO(widget))
	refresh_combo_box_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_TEXT(widget))
	refresh_gtktext_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_DRAWING_AREA(widget))
	refresh_drawing_area_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_FRAME(widget))
	refresh_frame_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_NOTEBOOK(widget))
	refresh_notebook_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_TABLE(widget))
	refresh_table_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_OPTION_MENU(widget))
	refresh_option_menu_code(gtk_widget_get_name(win_parent), widget);
      if (GTK_IS_PROGRESS_BAR(widget))
	refresh_progress_bar_code(gtk_widget_get_name(win_parent), widget);
    }
}

void		refresh_widget_code_from_properties(GtkWidget *widget)
{
  GtkWidget	*old_widget;
  
  old_widget = epingle->widget_clicked;
  epingle->widget_clicked = widget;
  refresh_widget_code(widget);
  epingle->widget_clicked = old_widget;
}

/***********************************************************/
void		delete_widget_code(GtkWidget *widget)
{
  GtkWidget	*win_parent;
  
  win_parent = widget;
  while(!GTK_IS_WINDOW(win_parent))
    win_parent = win_parent->parent;
  
  if (GTK_IS_RADIO_BUTTON(widget)) ;
  else if (GTK_IS_CHECK_BUTTON(widget))
    delete_button_code(gtk_widget_get_name(win_parent),
		       widget, CHECK_BUTTON);
  else if (GTK_IS_TOGGLE_BUTTON(widget))
    delete_button_code(gtk_widget_get_name(win_parent),
		       widget, TOGGLE_BUTTON);
  else if (GTK_IS_BUTTON(widget))
    delete_button_code(gtk_widget_get_name(win_parent),
		       widget, BUTTON); 
  if (GTK_IS_LABEL(widget))
    delete_label_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_ENTRY(widget))
    delete_entry_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_COMBO(widget))
    delete_combo_box_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_TEXT(widget))
    delete_gtktext_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_DRAWING_AREA(widget))
    delete_drawing_area_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_FRAME(widget))
    delete_frame_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_NOTEBOOK(widget))
    delete_notebook_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_TABLE(widget))
    delete_table_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_OPTION_MENU(widget))
    delete_option_menu_code(gtk_widget_get_name(win_parent), widget);
  if (GTK_IS_PROGRESS_BAR(widget))
    delete_progress_bar_code(gtk_widget_get_name(win_parent), widget);
}

/***********************************************************/
GtkWidget	*get_container(GtkWidget *widget)
{
  GtkWidget	*fixed;
  
  if (GTK_IS_WINDOW(widget))
    return (widget);
  fixed = widget->parent;
  while ((!GTK_IS_FIXED(fixed)) && (!GTK_IS_TABLE(fixed))
	 && (!GTK_IS_NOTEBOOK(fixed)) && (!GTK_IS_FRAME(fixed)))
    fixed = fixed->parent;
  
  if (GTK_IS_FIXED(fixed))
    return (fixed->parent);
  else
    return (fixed);
}

char	*get_container_name(GtkWidget *widget)
{
  return (gtk_widget_get_name(get_container(widget)));
}

/***********************************************************/
void	get_container_last_line(char **str, GtkWidget *widget)
{
  if (GTK_IS_FRAME(get_container(widget)))
    {
      if (GTK_WIDGET_VISIBLE(get_container(widget)))
	strcpy(*str, "gtk_widget_show(frame);\n");
      else
	strcpy(*str, "gtk_widget_realize(frame);\n");
    }
  else if (GTK_IS_NOTEBOOK(get_container(widget)))
    {
      if (GTK_WIDGET_VISIBLE(get_container(widget)))
	strcpy(*str, "gtk_widget_show(notebook);\n");
      else
	strcpy(*str, "gtk_widget_realize(notebook);\n");
    }
  else if (GTK_IS_TABLE(get_container(widget)))
    {
      if (GTK_WIDGET_VISIBLE(get_container(widget)))
	strcpy(*str, "gtk_widget_show(table);\n");
      else
	strcpy(*str, "gtk_widget_realize(table);\n");
    }
  else
    {
      if (GTK_WIDGET_VISIBLE(get_container(widget)))
	concat(str, 3, "gtk_widget_show(", get_container_name(widget), ");\n");
      else
	concat(str, 3, "gtk_widget_realize(",
	       get_container_name(widget), ");\n");
    }
}

/*
** create edit page
*/
GtkWidget	*create_edit_page(char *name_win)
{
  GtkWidget	*text;
  GtkWidget	*label;
  GtkWidget	*vscrollbar;
  GtkWidget	*hbox;
  char		*name_text;
  
  name_text = xmalloc(sizeof (char) * LENGTH);
  concat(&name_text, 2, "text_", name_win);
  hbox = gtk_hbox_new(FALSE, 0);
  text = gtk_text_new(NULL, NULL);
  gtk_text_set_editable(GTK_TEXT(text), TRUE);
  gtk_box_pack_start(GTK_BOX(hbox), text, TRUE, TRUE, 0);
  gtk_widget_show(text);
  vscrollbar = gtk_vscrollbar_new(GTK_TEXT(text)->vadj);
  gtk_box_pack_start(GTK_BOX(hbox), vscrollbar, FALSE, FALSE, 0);
  gtk_widget_show(vscrollbar);
  label = gtk_label_new(name_win);
  gtk_notebook_append_page(GTK_NOTEBOOK(epingle->editor_notebook),
			   hbox, label);
  gtk_widget_show(hbox);
  gtk_object_set_data(GTK_OBJECT(epingle->editor_notebook), name_text, text);
  epingle->edit_text = text;
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  return (text);
}

/*
** freeze edit text
*/
void	freeze_edit_text(char *name_win)
{
  char	*name_text;
  
  name_text = xmalloc(sizeof (char) * LENGTH);
  concat(&name_text, 2, "text_", name_win);
  epingle->edit_text = gtk_object_get_data(GTK_OBJECT
					   (epingle->editor_notebook),
					   name_text);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  free(name_text);
}

/*
** write window declaration
*/
void	write_window_declaration(GtkWidget *window)
{
  freeze_edit_text(epingle->project_name);
  seek_before("gtk_main();\n");
  color_line(3, "create_", gtk_widget_get_name(window), "();\n");
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
}

/*
** write window sensitive and show
*/
void	write_window_sensitive_and_show(GtkWidget *window)
{
  if (!GTK_WIDGET_SENSITIVE(window))
    color_line(3, "gtk_widget_sensitive(", gtk_widget_get_name(window),
	       ", FALSE);\n");
  if (GTK_WIDGET_VISIBLE(window))
    color_line(3, "gtk_widget_show(", gtk_widget_get_name(window), ");\n}\n");
  else
    color_line(3, "gtk_widget_realize(", gtk_widget_get_name(window),
	       ");\n}\n");
}

/*
** write widget declaration
*/
void	write_widget_declaration(GtkWidget *widget, char *fct_line)
{
  concat(&fct_line, 2, "void create_", get_container_name(widget));
  seek_in_fct_after(fct_line, "fixed;\n");
  color_line(3, "GtkWidget *", gtk_widget_get_name(widget), ";\n");
}

/*
** write widget set size
*/
void	write_widget_set_size(GtkWidget *widget)
{
  char	*str1, *str2;
  
  str1 = int_to_str(widget->allocation.width);
  str2 = int_to_str(widget->allocation.height);
  color_line(7, "gtk_widget_set_usize(", gtk_widget_get_name(widget), ",", 
	     str1, ",", str2, ");\n");
  free(str1);
  free(str2);
}

/*
** write widget show
*/
void	write_widget_show(GtkWidget *widget)
{
  if (GTK_WIDGET_VISIBLE(widget))
    color_line(3, "gtk_widget_show(", gtk_widget_get_name(widget), ");\n");
  else
    color_line(3, "gtk_widget_realize(",
	       gtk_widget_get_name(widget), ");\n");  
}

/*
** write widget put
*/
void	write_widget_put(GtkWidget *widget)
{
  char	*str1, *str2;
  
  str1 = int_to_str(widget->allocation.x);
  str2 = int_to_str(widget->allocation.y);
  color_line(7, "gtk_fixed_put(GTK_FIXED(fixed),", gtk_widget_get_name(widget),
	     ",", str1, ",", str2, ");\n");
  free(str1);
  free(str2);
}

/*
** write widget sensitive show and put
*/
void	write_widget_sensitive_show_and_put(GtkWidget *widget)
{
  if (!GTK_WIDGET_SENSITIVE(widget))
    color_line(3, "gtk_widget_sensitive(", gtk_widget_get_name(widget),
	       ", FALSE);\n");
  write_widget_show(widget);
  write_widget_put(widget);
}

/***********************************************************/
void		create_window_file_code(GtkWidget *window)
{
  char		*line;
  
  line = xmalloc(sizeof (char) * FN_LENGTH); 
  freeze_edit_text(epingle->project_name);  
  seek_before("gtk_main();\n");
  color_line(3, "create_", gtk_widget_get_name(window), "();\n"); 
  concat(&line, 3, "create_", gtk_widget_get_name(window), "();\n");  
  add_to_widget_list(gtk_widget_get_name(window), WINDOW);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  create_edit_page(gtk_widget_get_name(window));
  color_line(3, "#include \"", gtk_widget_get_name(window), ".h\"\n\n"); 
  coloration("extern GtkWidget *bt_storage;\n");
  coloration("extern GtkTooltips *tooltips;\n\n");
  color_line(3, "void create_", gtk_widget_get_name(window), "(void)\n{\n}\n");
  create_window_code(window);
  gtk_text_thaw(GTK_TEXT(epingle->edit_text)); 
  free(line);
}

/***********************************************************/
void		delete_window_file_code(GtkWidget *window)
{
  char		*name_text, *line;
  gint		num_page;
  GtkWidget	*page, *label;
  GtkWidget	*edit_tmp;
  GList		*children;
  char		*str;
  gint		i;
  
  num_page = -1;
  name_text = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  concat(&name_text, 2, "text_", gtk_widget_get_name(window));
  edit_tmp =
    gtk_object_get_data(GTK_OBJECT(epingle->editor_notebook), name_text);  
  children = gtk_container_children(GTK_CONTAINER(epingle->editor_notebook));
  for (i = 0; i < g_list_length(children); i++)
    {
      page = gtk_notebook_get_nth_page(GTK_NOTEBOOK
				       (epingle->editor_notebook), i);
      label = gtk_notebook_get_tab_label(GTK_NOTEBOOK
					 (epingle->editor_notebook), page);
      gtk_label_get(GTK_LABEL(label), &str);
      if (strcmp(str, gtk_widget_get_name(window)) == 0)
	{
	  num_page = i;
	  break;
	}
    }
  gtk_notebook_remove_page(GTK_NOTEBOOK(epingle->editor_notebook), num_page);
  gtk_widget_show(GTK_WIDGET(epingle->editor_notebook));
  concat(&name_text, 2, "text_", epingle->project_name);
  epingle->edit_text =
    gtk_object_get_data(GTK_OBJECT(epingle->editor_notebook), name_text);
  concat(&line, 3, "create_", gtk_widget_get_name(window), "();\n");
  delete_line(line, 0);
  free(line);
  free(name_text);
}








