/*
** code_generator_events.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Sat Jun  5 02:19:53 1999 sebastien thebert
** Last update Sat Apr  1 23:47:48 2000 Sebastien Thebert
*/
#include "main.h"

void	write_signal_connect(GtkWidget *widget, char *name_fct, char *event)
{
  if (GTK_IS_NOTEBOOK(widget))
    color_line(5, "gtk_signal_connect(GTK_OBJECT(notebook), \"", event,
	       "\", GTK_SIGNAL_FUNC(", name_fct, "), NULL);\n");
  else
    color_line(7, "gtk_signal_connect(GTK_OBJECT(",
	       gtk_widget_get_name(widget), "), \"", event,
	       "\", GTK_SIGNAL_FUNC(", name_fct, "), NULL);\n"); 
}

/***********************************************************/
void		create_line_event_code(char *name_fct,
				       char *old_name_fct,
				       char *event)
{
  GtkWidget	*widget;
  char		*line_tag;
  gint		pos;
  
  line_tag = xmalloc(sizeof (char) * FN_LENGTH);
  widget = get_current_widget();
  freeze_edit_text(gtk_widget_get_name(get_win_parent(widget)));
  if (old_name_fct)
    {
      concat(&line_tag, 3, "void ", old_name_fct,
	     "(GtkWidget *sender, GdkEventButton *event, gpointer data)\n");
      delete_line(line_tag, 0);
      color_line(3, "void ", name_fct,
		 "(GtkWidget *sender, GdkEventButton *event, gpointer data)\n");
      if (GTK_IS_NOTEBOOK(widget))
	concat(&line_tag, 5, "gtk_signal_connect(GTK_OBJECT(notebook), \"",
	       event, "\", GTK_SIGNAL_FUNC(", old_name_fct, "), NULL);\n");
      else
	concat(&line_tag, 7, "gtk_signal_connect(GTK_OBJECT(",
	       gtk_widget_get_name(widget), "), \"", event,
	       "\", GTK_SIGNAL_FUNC(", old_name_fct, "), NULL);\n"); 
      delete_line(line_tag, 0);
      write_signal_connect(widget, name_fct, event);
    }
  else
    {
      concat(&line_tag, 2, "void create_", get_container_name(widget));
      seek_before(line_tag);
      color_line(3, "void ", name_fct,
		 "(GtkWidget *sender, GdkEventButton *event, gpointer data)\n"); 
      coloration("{\n}\n\n");
      concat(&line_tag, 2, "void create_", gtk_widget_get_name(widget));
      pos = search_string(line_tag, 0);
      if (GTK_IS_NOTEBOOK(widget))
	strcpy(line_tag,
	       "gtk_fixed_put(GTK_FIXED(fixed_parent), notebook, x, y);\n");
      else
	concat(&line_tag, 3, "gtk_widget_show(",
	       gtk_widget_get_name(widget), ");\n"); 
      /*      seek_after(line_tag);*/
      pos = search_string(line_tag, pos);
      gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
      write_signal_connect(widget, name_fct, event);
    }
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line_tag);
}

/***********************************************************/
void	create_event_code(GtkWidget *entry, char *old_name_fct, char *event)
{
  gchar	*name_fct;
  
  name_fct = gtk_entry_get_text(GTK_ENTRY(entry));
  create_line_event_code(name_fct, old_name_fct, event);
}


