#include "main.h"

static void	cb_change_update_policy(GtkWidget *entry, GtkWidget *widget)
{
  GtkUpdateType	policy;  
  gchar		*text;
  
  text = gtk_entry_get_text(GTK_ENTRY(entry));
  policy = GTK_UPDATE_CONTINUOUS;
  if (!strcmp(text, "discontinuous"))
    policy = GTK_UPDATE_DISCONTINUOUS;
  else
    if (!strcmp(text, "delayed"))
      policy = GTK_UPDATE_DELAYED;
  gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION(widget), policy);
  refresh_window_code(widget->parent);
}

void		GtkColorSelectionDialog_properties(GtkWidget *widget)
{
  GtkWidget	*property;
  GtkWidget	*table;
  GList		*list;
  gchar		*text;
  
  table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
			      "properties"); 
  AddWindowProperties(widget); 
  AddPropertyLabel(table, NB_WIN_PROP + 1, "Update policy",
		   "Update policy of the color selection");
  list = colorsel_policies();
  property = AddComboProperty(table, NB_WIN_PROP+1, list);
  text = GtkUpdateTypeText(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG
					       (widget)->colorsel)->policy);
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(property)->entry), text); 
  gtk_signal_connect(GTK_OBJECT(GTK_COMBO(property)->entry),
		     "changed", GTK_SIGNAL_FUNC(cb_change_update_policy),
		     GTK_COLOR_SELECTION_DIALOG(widget)->colorsel);	
}
