/*
** compilation.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Thu Mar 25 14:57:04 1999 sebastien thebert
** Last update Tue Apr  4 00:55:08 2000 Sebastien Thebert
*/
#include "main.h"

GdkColor	msg_color, msg_bgcolor;

/***********************************************************/
/* Destroy the compilation window */
void	end_compil(GtkWidget *sender)
{
  gtk_widget_destroy(sender->parent->parent);
}

/***********************************************************/
GtkWidget	*window_compilation(void)
{
  GtkWidget	*window;
  GtkWidget	*vbox, *hbox, *vscrollbar;
  GtkWidget	*bt;
  GtkWidget	*text;
  
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Compilation");
  gtk_widget_set_usize(window, 500, 200);
  vbox = gtk_vbox_new(FALSE, 0);
  hbox = gtk_hbox_new(FALSE, 0);
  text = gtk_text_new(NULL, NULL);
  gtk_text_set_editable(GTK_TEXT(text), FALSE);
  gtk_box_pack_start(GTK_BOX(hbox), text, TRUE, TRUE, 0);
  gtk_widget_show(text); 
  vscrollbar = gtk_vscrollbar_new(GTK_TEXT(text)->vadj);
  gtk_box_pack_start(GTK_BOX(hbox), vscrollbar, FALSE, FALSE, 0);
  gtk_widget_show(vscrollbar);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);
  gtk_widget_show(hbox);
  bt = gtk_button_new_with_label("OK");
  gtk_widget_show(bt);
  gtk_widget_set_usize(bt, 80, 20);
  gtk_box_pack_start(GTK_BOX(vbox), bt, TRUE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(bt), "clicked",
		     GTK_SIGNAL_FUNC(end_compil), NULL);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(vbox);
  gtk_widget_show(window);
  gtk_main_iteration();
  return (text);
}

/***********************************************************/
void	set_msg_color(GdkColor cl)
{
  msg_color.red = cl.red;
  msg_color.green = cl.green;
  msg_color.blue = cl.blue;
  if (!gdk_color_alloc(epingle->colormap, &msg_color)) 
    g_error("couldn't allocate color\n");
}

/***********************************************************/
void	set_msg_bgcolor(GdkColor cl)
{
  msg_bgcolor.red = cl.red;
  msg_bgcolor.green = cl.green;
  msg_bgcolor.blue = cl.blue;
  if (!gdk_color_alloc(epingle->colormap, &msg_bgcolor)) 
    g_error("couldn't allocate color\n");
}

/***********************************************************/
void	msg_coloration(char *line, GtkWidget *text)
{
  char	*temp;
  
  temp = xmalloc(sizeof (char) * FN_LENGTH);
  gtk_text_freeze(GTK_TEXT(text));
  strcpy(temp,line);
  temp = strtok(temp,":");
  set_msg_bgcolor(color->background);
  set_msg_color(color->normal);    
  while (temp != NULL)
    {
      if (strcmp(" warning", temp) == 0)
  	set_msg_color(color->warning_compil);
      if (strcmp(" error", temp) == 0)
  	set_msg_color(color->error_compil);
      
      gtk_text_insert(GTK_TEXT(text), NULL, &msg_color,
		      &msg_bgcolor, temp, -1);
      gtk_text_insert(GTK_TEXT(text), NULL, &msg_color,
  		      &msg_bgcolor, ":", -1);
      temp = strtok(NULL, ":");
    }
  gtk_text_backward_delete(GTK_TEXT(text), 1); 
  gtk_text_thaw(GTK_TEXT(text));
  free(temp);
}

/***********************************************************/
void		read_line(int tube, GtkWidget *compil_text)
{
  static int	tmp_pos, old_pos;
  static char	tmp[302];
  char		*file_str;
  int		nb_read;
  int		pos;
  
  
  file_str = xmalloc(sizeof (char) * FN_LENGTH);
  nb_read = read(tube, file_str, FN_LENGTH);
  if ((nb_read != 0) && (nb_read != old_pos))
    {
      pos = old_pos;
      while ((*(file_str + pos)) && (pos < FN_LENGTH))
  	tmp[tmp_pos + pos] = *(file_str + tmp_pos+(pos++));
      tmp[tmp_pos + pos] = 0;
      if (pos != FN_LENGTH)
  	{
	  msg_coloration(file_str, compil_text);
	  old_pos = pos;
	  tmp_pos = 0;
  	}
      else
  	{
  	  tmp_pos = pos - old_pos;
  	  old_pos = 0;
  	}
    }
  free(file_str);
}

/*
** execute
*/
int	execute(char *command_line, GtkWidget *text)
{
  int	sys_ret = 0;
  
  sys_ret = system(command_line);
  strcat(command_line, "\n");
  msg_coloration(command_line, text);
  return (sys_ret);
}

/*
** compilation
*/
short		compilation(void)
{
  GtkWidget	*compil_text;
  char		*old_path;  
  int		tube[2];
  int		fin;
  int	status;
  
  if (!epingle->project_path)
    {
      save_as(NULL, NULL);
      while (!epingle->project_path)
	gtk_main_iteration();
    }
  if (epingle->project_path)
    {
      old_path = xmalloc(sizeof (char) * FN_LENGTH);
      old_path = getcwd(old_path, FN_LENGTH);
      chdir(epingle->project_path);
      generate_makefile();
      create_headers_and_files();
      compil_text = window_compilation();
      pipe(tube);
      fin = 0;
      if (!fork())
	{
	  if (!fork())
	    {
	      close(tube[0]);
	      dup2(tube[1], 1);
	      execlp("make", "make", "-f", "Makefile_tmp", NULL);
	    }
	  else
	    {
	      close(tube[1]);
	      read_line(tube[0], compil_text);
	      gtk_main_iteration();
	      wait(0);
	    }
	  gtk_main_iteration();
	}
      else
	wait(&status);
      chdir(old_path);
      free(old_path);
      return (1);
    }
  return (0);
}

/*
** execution (if compilation succeed !)
*/
void	execution(void)
{
  char	*line;
  char	*old_path;
  
  if (compilation())
    {
      old_path = xmalloc(sizeof (char) * FN_LENGTH);
      old_path = getcwd(old_path, FN_LENGTH);
      chdir(epingle->project_path);
      line = xmalloc(sizeof (char) * LENGTH);
      strcpy(line, "");
      strcat(line, epingle->project_name);
      strcat(line, " &\n");
      system(line);
      chdir(old_path);
      free(old_path);
      free(line);
    }
}

