/*
** completion.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Mon Apr 12 21:25:13 1999 sebastien thebert
** Last update Tue Apr  4 17:34:29 2000 Sebastien Thebert
*/
#include "main.h"

extern GtkWidget	*edit_info_entry;

GList	*completion_list;
char	*completion_result;

void add_to_completion_list(char *str);

/*
** init_completion_list
*/
void	init_completion_list()
{
  FILE	*file;
  char	*tmp_str, *file_str;
  int	i;
  
  completion_list = NULL;
  tmp_str = xmalloc(sizeof (char) * FN_LENGTH);
  if ((file = fopen("./EPIngle_completion.cfg","r")) != NULL)
    {
      while (!feof(file))
	{
	  fgets(tmp_str, FN_LENGTH, file);
	  i = 0;
	  while((tmp_str[i] != '\n') && (tmp_str[i] != '\0'))
	    i++;
	  tmp_str[i] = '\0';
	  file_str = xmalloc(sizeof (char) * strlen(tmp_str) + 1);
	  strcpy(file_str, tmp_str);
	  add_to_completion_list(file_str);
	}
      fclose(file);
    }
  else
    printf("Unable to open Completion File !\n");
  free(tmp_str);
}

/*
** destroy_completion_list
*/
void	destroy_completion_list()
{
  g_list_free(completion_list);
}

/*
** add_to_completion_list
*/
void	add_to_completion_list(char *str)
{
  GList *tmp;
  gint	i, already_present;
  short not_find;
  
  i = not_find = 1;
  already_present = 0;
  while ((i < g_list_length(completion_list)) && (not_find))
    {
      tmp = g_list_nth(completion_list, i);
      if (strcmp(str, tmp->data) < 0) 
	{
	  not_find = 0;
	  i--;
	}
      if (strcmp(str, tmp->data) == 0)
	{
	  not_find = 0;
	  already_present = 1;
	}
      i++;
    }
  if (!already_present)
    {
      if (i != g_list_length(completion_list))
	completion_list = g_list_insert(completion_list, str, i);
      else
	completion_list = g_list_append(completion_list, str);
    }
}

/*
** delete_in_completion_list
*/
void	delete_in_completion_list(char *str)
{
  completion_list = g_list_remove(completion_list, str);
}

/*
** replace
*/
void	replace(gint start, gint finish, char *str)
{
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), start);
  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), finish-start);
  coloration(str);
}

/*
** search_in_completion_list
*/
gint	search_in_completion_list(char *str, gint pos, gint end_pos)
{
  GList	*tmp;
  GList	*list;
  gint	i, fin, cpt, length;
  gint	same_completion;
  char	*str_complete;
  
  list = NULL;
  i = same_completion = 1;
  fin = cpt = 0;
  length = strlen(str);
  completion_result = xmalloc(sizeof (char) * FN_LENGTH);
  strcpy(completion_result, "");
  while ((i < g_list_length(completion_list)) && (!fin))
    {
      tmp = g_list_nth(completion_list, i);
      if (!(strncmp(str, tmp->data, length)))
	{
	  if (cpt > 0)
	    strcat(completion_result, "\t");
	  if ((strlen(completion_result)+strlen(tmp->data)) < FN_LENGTH)
	    {
	      strcat(completion_result, tmp->data);
	      list = g_list_append(list, tmp->data);
	      cpt++;
	    }
	}
      if (strncmp(str, tmp->data, length) < 0)
	fin = 1;
      i++;
    }
  if (cpt > 1)
    {
      str_complete = xmalloc(sizeof (char) * FN_LENGTH);
      tmp = g_list_nth(list, 1);
      strcpy(str_complete, tmp->data);
      length++;
      while (same_completion)
	{
	  i = 2;
	  tmp = g_list_nth(list, i);
	  while ((i < g_list_length(list)) && (same_completion))
	    {
	      tmp = g_list_nth(list, i);
	      if (strncmp(str_complete, tmp->data, length) != 0)
		same_completion = 0;
	      i++;
	    }
	  length++;
	}
      strncpy(str_complete, str_complete, length - 2);
      str_complete[length - 2] = '\0';
      replace(pos, end_pos, str_complete);
    }
  g_list_free(list);
  return(cpt);
}

/*
** completion
*/
void	completion()
{
  gint	i, end_pos, pos, length, res;
  char	*str;
  
  set_edit_text();
  end_pos = gtk_text_get_point(GTK_TEXT(epingle->edit_text));
  pos = end_pos-1;
  while((GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ' ')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '\n')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '(')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ')')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ','))
    pos--;
  pos++;
  length = end_pos - pos;
  str = xmalloc(sizeof (char) * (length + 1));
  i = 0;
  while (i < length)
    {
      str[i] = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos+i);
      i++;
    }
  str[i] = '\0';
  if (strcmp(str, "") != 0)
    {
      res = search_in_completion_list(str, pos, end_pos);
      if (!res)
	gtk_entry_set_text(GTK_ENTRY(edit_info_entry), "No completion");
      else if (res == 1)
	{
	  replace(pos, end_pos, completion_result);
	  gtk_entry_set_text(GTK_ENTRY(edit_info_entry), "");
	}
      else
	gtk_entry_set_text(GTK_ENTRY(edit_info_entry), completion_result);
    }
}

