/*
** create_buttons.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Wed Mar 22 18:00:37 2000 Sebastien Thebert
** Last update Tue Apr  4 16:32:35 2000 Sebastien Thebert
*/
#include "main.h"

/*
** Create a classic button
*/
GtkWidget	*create_button(GtkWidget *fixed, gint x, gint y,
			       gint width, gint height, gchar *label)
{
  GtkWidget	*bt;
  
  bt = gtk_button_new_with_label(label);
  set_widget_events(bt);
  dragndrop_set_src(bt);
  gtk_widget_set_usize(bt, width, height);
  gtk_widget_show(bt);
  gtk_fixed_put(GTK_FIXED(fixed), bt, x, y);
  set_widget_coordinates(bt, x, y, width, height); 
  return (bt);
}

/*
** Create a toggle button
*/
GtkWidget	*create_toggle_button(GtkWidget *fixed, gint x, gint y,
				      gint width, gint height,
				      gchar *label, gint state)
{
  GtkWidget	*bt;
  
  bt = gtk_toggle_button_new_with_label(label);
  set_widget_events(bt);
  dragndrop_set_src(bt);
  gtk_widget_set_usize(bt, width, height);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bt), state);
  gtk_widget_show(bt);
  gtk_fixed_put(GTK_FIXED(fixed), bt, x, y);
  set_widget_coordinates(bt, x, y, width, height); 
  return (bt);
}

/*
** Create a check button
*/
GtkWidget	*create_check_button(GtkWidget *fixed, gint x, gint y,
				     gint width, gint height,
				     gchar *label, gint state)
{
  GtkWidget	*bt;
/*  GtkWidget	*eventbox;*/
  
/*  eventbox = gtk_event_box_new();*/
  /*  gtk_widget_show(eventbox); */
  bt = gtk_check_button_new_with_label(label);
  gtk_widget_show(bt);
  set_widget_events(bt);
  dragndrop_set_src(bt);
  gtk_fixed_put(GTK_FIXED(fixed), bt, x, y);
  /*  gtk_container_add(GTK_CONTAINER(eventbox), bt);*/
  /*  set_widget_events(eventbox);*/
  /*  dragndrop_set_src(eventbox);*/
  /*  gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);*/
  set_widget_coordinates(bt, x, y, width, height);
  /*  set_widget_coordinates(eventbox, x, y, width, height);*/
  return (bt);
}

/*
** Create a radio button
*/
GtkWidget	*create_radio_button(GtkWidget *fixed, gint x, gint y,
				     gint width, gint height,
				     gchar *label ,gint state,
				     GtkRadioButton *radio_bt)
{
  GtkWidget	*bt;
  
  if (radio_bt == NULL)
    bt = gtk_radio_button_new_with_label(NULL, label);
  else
    bt = gtk_radio_button_new_with_label(gtk_radio_button_group
					 (radio_bt), label);  
  gtk_widget_set_usize(bt, width, height);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bt), state);
  set_widget_events(bt);
  dragndrop_set_src(bt);
  gtk_widget_show(bt);
  gtk_fixed_put(GTK_FIXED(fixed), bt, x, y);
  set_widget_coordinates(bt, x, y, width, height);  
  return (bt);
}

/*
** Create a spin button
*/
GtkWidget	*create_spin_button(GtkWidget *fixed, gint x, gint y,
				    gint width, gint height,
				    GtkAdjustment *adj)
{
  GtkWidget	*spin_button;
  
  spin_button = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 1, 0);
  set_widget_events(spin_button);
  dragndrop_set_src(spin_button);
  gtk_widget_set_usize(spin_button, width, height);
  gtk_widget_show(spin_button);
  gtk_fixed_put(GTK_FIXED(fixed), spin_button, x, y);
  set_widget_coordinates(spin_button, x, y, width, height);
  return (spin_button);
}













