/*
** create_containers.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Tue Apr  4 17:03:01 2000 Sebastien Thebert
** Last update Tue Apr  4 17:05:54 2000 Sebastien Thebert
*/
#include "main.h"

/*
** Create a frame
*/
GtkWidget	*create_frame(GtkWidget *fixed, gint x, gint y,
			      gint width, gint height, gchar *label)
{
  GtkWidget	*frame;
  GtkWidget	*eventbox;
  GtkWidget	*fixed_frame;
  
  eventbox = gtk_event_box_new();
  frame = gtk_frame_new(label);
  gtk_widget_show(frame);
  fixed_frame = gtk_fixed_new();
  gtk_widget_show(fixed_frame);
  gtk_container_add(GTK_CONTAINER(frame), fixed_frame);
  dragndrop_set_dest(fixed_frame);
  set_fixed_frame_events(fixed_frame);
  set_eventbox_frame_events(eventbox);
  gtk_widget_set_usize(frame, width, height);
  gtk_widget_show(eventbox);
  gtk_container_add(GTK_CONTAINER(eventbox), frame);
  gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);
  set_widget_coordinates(frame, x, y, width, height);
  set_widget_coordinates(eventbox, x, y, width, height);
  return (frame);
}

/*
** Create a notebook
*/
GtkWidget	*create_notebook(GtkWidget *fixed, gint x, gint y,
				 gint width, gint height)
{
  GtkWidget	*notebook;
  GtkWidget	*page_fixed;
  GtkWidget	*label_page;
  GtkWidget	*eventbox;
  
  eventbox = gtk_event_box_new();
  notebook = gtk_notebook_new();
  gtk_widget_show(notebook);

  page_fixed = gtk_fixed_new();
  gtk_widget_show(page_fixed);
  dragndrop_set_dest(page_fixed);
  set_fixed_notebookpage_events(page_fixed);
  gtk_widget_set_usize(page_fixed, width, height);
  label_page = gtk_label_new("Page 1");
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook), page_fixed, label_page);

  page_fixed = gtk_fixed_new();
  gtk_widget_show(page_fixed);
  dragndrop_set_dest(page_fixed);
  set_fixed_notebookpage_events(page_fixed);
  gtk_widget_set_usize(page_fixed, width, height);
  label_page = gtk_label_new("Page 2");
  gtk_notebook_append_page(GTK_NOTEBOOK(notebook), page_fixed, label_page);

  set_eventbox_notebook_events(eventbox);
  gtk_container_add(GTK_CONTAINER(eventbox), notebook);
  gtk_widget_show(eventbox);
  gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);
  set_widget_coordinates(notebook, x, y, width, height);
  set_widget_coordinates(eventbox, x, y, width, height);
  return (notebook); 
}  
  
  
