/*
** create_gfx.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Thu Mar 23 01:23:03 2000 Sebastien Thebert
** Last update Fri Mar 31 19:46:12 2000 Sebastien Thebert
*/
#include "main.h"


/*
** create_drawing_area
*/
GtkWidget	*create_drawing_area(GtkWidget *fixed, gint x, gint y,
				     gint width, gint height,
				     GdkColor *cl)
{
  GtkWidget	*drawing_area;
  /*  GtkWidget	*eventbox;*/
  
  /*  eventbox = gtk_event_box_new();*/
  /*  gtk_widget_show(eventbox);*/
  drawing_area = gtk_drawing_area_new();
  gtk_drawing_area_size(GTK_DRAWING_AREA(drawing_area), width, height);
  /*  gtk_container_add(GTK_CONTAINER(eventbox), drawing_area);*/
  set_widget_events(/*eventbox*/drawing_area);
  dragndrop_set_src(/*eventbox*/drawing_area);
  gtk_widget_show(drawing_area);
  gtk_fixed_put(GTK_FIXED(fixed), /*eventbox*/drawing_area, x, y);
  set_widget_coordinates(/*eventbox*/ drawing_area, x, y, width, height);
  
  gtk_object_set_data(GTK_OBJECT(drawing_area), "color", cl);
  if (!gdk_color_alloc(epingle->colormap, cl)) 
    g_error("Couldn't allocate color for Drawing Area\n");
  else
    gdk_window_set_background(drawing_area->window, cl);
  return (drawing_area); 
}

/*
** create_pixmap
*/
GtkWidget	*create_pixmap(GtkWidget *fixed, gint x, gint y,
			       gint width, gint height, char *filename)
{
  GdkBitmap	*mask = NULL;
  GtkStyle	*style;
  GdkGC		*gc;
  GtkWidget	*win, *pixmap;
  GdkPixmap	*gdk_pixmap;
  GtkWidget	*eventbox;
  
  eventbox = gtk_event_box_new();
  gtk_widget_show(eventbox);
  win = get_win_parent(fixed);
  style = gtk_widget_get_style(win);
  gc = style->black_gc;
  gdk_pixmap = gdk_pixmap_create_from_xpm(win->window, &mask,
					  &style->bg[GTK_STATE_NORMAL],
					  filename);
  pixmap = gtk_pixmap_new(gdk_pixmap, mask);
  if (pixmap != NULL)
    {
      gtk_widget_show(pixmap);
      gtk_container_add(GTK_CONTAINER(eventbox), pixmap);
      set_widget_events(eventbox);
      dragndrop_set_src(eventbox);
      gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);
      set_widget_coordinates(pixmap, x, y, width, height);
      set_widget_coordinates(eventbox, x, y, width, height); 
      return (pixmap);
    }
  else
    {
      printf("Invalid Pixmap Filename !\n");
      return (NULL);
    }
}
