/*
** create_texts.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Wed Mar 22 18:05:05 2000 Sebastien Thebert
** Last update Tue Mar 28 23:53:03 2000 Sebastien Thebert
*/
#include "main.h"

/*
** Create a label
*/
GtkWidget	*create_label(GtkWidget *fixed, gint x, gint y,
			      gint width, gint height, gchar *label_str)
{
  GtkWidget	*label;
  GtkWidget	*eventbox;
  
  eventbox = gtk_event_box_new();
  gtk_widget_show(eventbox);
  label = gtk_label_new(label_str);
  if ((width != -1) && (height != -1))
    gtk_widget_set_usize(label, width, height);
  gtk_widget_show(label);
  gtk_container_add(GTK_CONTAINER(eventbox), label);
  set_widget_events(eventbox);
  dragndrop_set_src(eventbox);
  gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);
  set_widget_coordinates(label, x, y, width, height);
  set_widget_coordinates(eventbox, x, y, width, height);
  return (label);
}

/*
** Create an entry
*/
GtkWidget	*create_entry(GtkWidget *fixed, gint x, gint y,
			      gint width, gint height, gchar *text,
			      gint max_length, gboolean editable,
			      gboolean visibility)
{
  GtkWidget	*eventbox;
  GtkWidget	*entry;
  
  eventbox = gtk_event_box_new();
  gtk_widget_show(eventbox);
  entry = gtk_entry_new();
  gtk_widget_set_usize(entry, width, height);
  gtk_entry_set_max_length(GTK_ENTRY(entry), max_length);
  if (!editable)
    gtk_entry_set_editable(GTK_ENTRY(entry), FALSE);
  if (!visibility)
    gtk_entry_set_visibility(GTK_ENTRY(entry), FALSE);
  gtk_entry_set_text(GTK_ENTRY(entry), text);
  gtk_widget_show(entry);
  gtk_container_add(GTK_CONTAINER(eventbox), entry);
  set_widget_events(eventbox);
  dragndrop_set_src(eventbox);
  gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);
  set_widget_coordinates(entry, x, y, width, height);
  set_widget_coordinates(eventbox, x, y, width, height);  
  return (entry);
}

/*
** Create a combobox
*/
GtkWidget	*create_combo(GtkWidget *fixed, gint x, gint y,
			      gint width, gint height, GList *list)
{
  GtkWidget	*eventbox;
  GtkWidget	*combo;
  
  eventbox = gtk_event_box_new();
  gtk_widget_show(eventbox);
  combo = gtk_combo_new();
  gtk_widget_set_usize(combo, width, height);
  if (list)
    gtk_combo_set_popdown_strings(GTK_COMBO(combo), list);
  gtk_widget_show(combo);
  gtk_container_add(GTK_CONTAINER(eventbox), combo);
  set_widget_events(eventbox);
  dragndrop_set_src(eventbox);
  gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);
  set_widget_coordinates(combo, x, y, width, height);
  set_widget_coordinates(eventbox, x, y, width, height);
  return (combo);
}

/*
** Create a text
*/
GtkWidget	*create_text(GtkWidget *fixed, gint x, gint y,
			     gint width, gint height, gint editable)
{
  GtkWidget	*eventbox;
  GtkWidget	*text;
  
  eventbox = gtk_event_box_new();
  gtk_widget_show(eventbox);
  text = gtk_text_new(NULL, NULL);
  gtk_text_set_editable(GTK_TEXT(text), editable);
  gtk_widget_set_usize(text, width, height);
  gtk_widget_show(text);
  gtk_container_add(GTK_CONTAINER(eventbox), text);
  set_widget_events(eventbox);
  dragndrop_set_src(eventbox);
  gtk_fixed_put(GTK_FIXED(fixed), eventbox, x, y);
  set_widget_coordinates(text, x, y, width, height);  
  set_widget_coordinates(eventbox, x, y, width, height);
  return (text); 
}

