/*
** data_linkage.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Thu Jun  3 03:15:25 1999 sebastien thebert
** Last update Tue Apr  4 17:01:26 2000 Sebastien Thebert
*/
#include "main.h"

GList	*widget_list;

struct widget_hlp
{
  char *name;
  gint type;
};

/***********************************************************/
char	*get_widget_to_link()
{
  gint	i, end_pos, pos, length;
  char	*str;
  
  set_edit_text();
  end_pos = gtk_text_get_point(GTK_TEXT(epingle->edit_text));
  pos = end_pos-1;
  while((GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ' ')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '\n')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '(')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ')')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ','))
    pos--;
  pos++;
  length = end_pos-pos;
  pos = end_pos;
  while((GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ' ')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '\n')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '(')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ')')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ','))
    pos++;
  length += (pos - end_pos);
  pos -= length;
  str = xmalloc(sizeof (char) * (length + 1));
  i = 0;
  while (i < length)
    {
      str[i] = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos + i);
      i++;
    }
  str[i] = '\0';
  return(str);
}

/***********************************************************/
void		data_linkage()
{
  GtkWidget     *tree_item, *window;
  gint		pos, pos_fct_begin, i;
  char		*str;
  char		*line;
  char		*name_text;
  
  name_text = xmalloc(sizeof (char) * LENGTH);
  line = xmalloc(sizeof (char) * FN_LENGTH);
  str = get_widget_to_link();
  printf("DATA LINKAGE\n");
  printf("widget_to_link: %s\n", str);
  pos = search_string(str, 0);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
  color_line(4, str, " = gtk_object_get_data(GTK_OBJECT(bt_storage), \"",
	     str, "\");\n");
  concat(&line, 3, "gtk_widget_show(", str, ");\n");
  pos_fct_begin = pos;
  while (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos_fct_begin) != '{')
    pos_fct_begin--;
  pos_fct_begin += 2;
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos_fct_begin);
  color_line(3, "GtkWidget *", str, ";\n");
  for (i = 0; i < g_list_length(epingle->window_list); i++)
    {
      tree_item = g_list_nth(epingle->window_list, i)->data;
      window = gtk_object_get_user_data(GTK_OBJECT(tree_item));
      name_text = xmalloc(sizeof (char) * LENGTH);
      concat(&name_text, 2, "text_", gtk_widget_get_name(window));
      epingle->edit_text = gtk_object_get_data(GTK_OBJECT
					       (epingle->editor_notebook),
					       name_text);
      pos = search_string(line, 0);
      gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
      if (pos != -1)
	color_line(6, "gtk_object_set_data(GTK_OBJECT(bt_storage), ",
		   "\"", str, "\", ", str, ");\n");
    }
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(name_text);
  free(line);
  free(str);
}

/***********************************************************/
void	init_widget_list()
{
  widget_list = NULL;
}

/***********************************************************/
void			add_to_widget_list(char *str, gint type)
{
  gint			i, already_present;
  short			not_find;
  struct widget_hlp	*tmp, *widget;
  
  i = not_find = 1;
  already_present = 0;
  while ((i < g_list_length(widget_list)) && (not_find))
    {
      tmp = (struct widget_hlp *)(g_list_nth(widget_list, i)->data);
      if (strcmp(str, tmp->name) < 0) 
	{
	  not_find = 0;
	  i--;
	}
      if (strcmp(str, tmp->name) == 0)
	{
	  not_find = 0;
	  already_present = 1;
	}
      i++;
    }
  if (!already_present)
    {
      widget = xmalloc(sizeof (struct widget_hlp));
      widget->name = xmalloc(sizeof (char) * (strlen(str) + 1));
      strcpy(widget->name, str);
      widget->type = type;
      if (i != g_list_length(widget_list))
	widget_list = g_list_insert(widget_list, widget, i);
      else
	widget_list = g_list_append(widget_list, widget);
    }
}

/***********************************************************/
void			delete_in_widget_list(char *str)
{
  struct widget_hlp	*wdgt_del, *tmp;
  gint			i, not_find;
  
  i = not_find = 1;
  wdgt_del = xmalloc(sizeof (struct widget_hlp));
  wdgt_del->name = xmalloc(sizeof (char) * (strlen(str) + 1));
  strcpy(wdgt_del->name, str);
  while ((i < g_list_length(widget_list)) && (not_find))
    {
      tmp = (struct widget_hlp *)(g_list_nth(widget_list, i)->data);
      if (strcmp(wdgt_del->name, tmp->name) < 0) 
	{
	  not_find = 0;
	  i--;
	}
      if (strcmp(wdgt_del->name, tmp->name) == 0)
	{
	  not_find = 0;
	  widget_list = g_list_remove(widget_list, tmp);
	}
      i++;
    }
}

gint			search_in_widget_list(char *str)
{
  struct widget_hlp	*tmp;
  gint			i;
  gint			fin; 
  
  i = 1;
  fin = 0;
  while ((i < g_list_length(widget_list)) && (!fin))
    {
      tmp = (struct widget_hlp *)(g_list_nth(widget_list, i)->data);
      if (strcmp(str, tmp->name) == 0)
	return(tmp->type);
      if (strcmp(str, tmp->name) < 0)
	fin = 1;
      i++;
    }
  return (-1);
}

