/*
** drag&drop.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Fri May  7 17:04:01 1999 sebastien thebert
** Last update Tue Apr  4 00:00:51 2000 Maxime Vernier
*/
#include "main.h"

GtkWidget	*dnd_widget;

enum
{
  TARGET_STRING,
  TARGET_ROOTWIN
};

static GtkTargetEntry target_table[] =
{
  { "STRING",     0, TARGET_STRING },
  { "text/plain", 0, TARGET_STRING },
  { "application/x-rootwin-drop", 0, TARGET_ROOTWIN }
};

static guint n_targets = sizeof(target_table) / sizeof(target_table[0]);


/***********************************************************/
void		fixed_drag_data_received(GtkWidget *widget,
					 GdkDragContext *context,
					 gint x, gint y,
					 GtkSelectionData *data,
					 guint info, guint time)
{
  GtkWidget	*parent_tree_item;
  GtkWidget	*tree_item;
  GList		*list;
  
  if ((data->length >= 0) && (data->format == 8) && (dnd_widget != NULL))
    {
      delete_widget_code(dnd_widget);
      gtk_widget_reparent(dnd_widget, widget);
      gtk_fixed_move(GTK_FIXED(widget), dnd_widget, x, y);
      create_widget_code(dnd_widget);
      edit_properties_of_widget(dnd_widget);
      parent_tree_item =
	gtk_object_get_user_data(GTK_OBJECT(dnd_widget->parent->parent));      
      if (GTK_IS_EVENT_BOX(dnd_widget))
	{
	  list = gtk_container_children(GTK_CONTAINER(dnd_widget));
	  tree_item =
	    gtk_object_get_user_data(GTK_OBJECT((g_list_first(list))->data));
	  edit_properties_of_widget((g_list_first(list))->data);
	}
      else
	{
	  tree_item = gtk_object_get_user_data(GTK_OBJECT(dnd_widget));
	  edit_properties_of_widget(dnd_widget);
	}
      hierarchy_move(dnd_widget);
      dnd_widget = NULL;
      gtk_drag_finish(context, TRUE, FALSE, time);
      return;
    }
  gtk_drag_finish (context, FALSE, FALSE, time);
}

/***********************************************************/
void	src_drag_data_get(GtkWidget *widget, GdkDragContext *context,
			  GtkSelectionData *selection_data,
			  guint info, guint time, gpointer data)
{
  gtk_selection_data_set(selection_data, selection_data->target,
			 8, "EPINGLE", 7);
  dnd_widget = widget;
}

/***********************************************************/
void	dragndrop_set_dest(GtkWidget *fixed)
{
  gtk_drag_dest_set(fixed, GTK_DEST_DEFAULT_ALL, target_table,
		    n_targets - 1, GDK_ACTION_COPY | GDK_ACTION_MOVE);
  gtk_signal_connect(GTK_OBJECT(fixed), "drag_data_received",
		     GTK_SIGNAL_FUNC(fixed_drag_data_received), NULL);
}

/***********************************************************/
void	dragndrop_set_src(GtkWidget *widget)
{
  gtk_drag_source_set(widget, GDK_BUTTON2_MASK, target_table, n_targets, 
		      GDK_ACTION_COPY | GDK_ACTION_MOVE);
  gtk_signal_connect(GTK_OBJECT(widget), "drag_data_get",
		     GTK_SIGNAL_FUNC(src_drag_data_get), NULL);
}
