/*
** drawing_area.c
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Wed May 19 14:08:45 1999 Maxime VERNIER
** Last update Sat Apr  1 23:52:43 2000 Sebastien Thebert
*/
#include "main.h"

void	OkButtonClicked(GtkWidget *button,  GtkWidget *csd)
{
  gtk_widget_destroy(csd);
}

void		ColorSelectionChanged(GtkColorSelection	*cs,
				      GtkWidget		*drawing_area) 
{ 
  GtkWidget	*widget; 
  gdouble	color[4]; 
  GdkColor	*gdk_color;
  
  widget = get_current_widget();
  gtk_color_selection_get_color(cs, color);
  gdk_color = gtk_object_get_data(GTK_OBJECT(widget), "color");
  gdk_color->red = (guint16)(color[0]*65535.0);
  gdk_color->green = (guint16)(color[1]*65535.0);
  gdk_color->blue = (guint16)(color[2]*65535.0);
  gdk_color_alloc(epingle->colormap, gdk_color);
  gdk_window_set_background(widget->window, gdk_color);
  gdk_window_set_background(drawing_area->window, gdk_color);
  gtk_widget_hide(widget);
  gtk_widget_show(widget);
  gtk_widget_hide(drawing_area); 
  gtk_widget_show(drawing_area);
}

void		change_color(GtkWidget *eb, gpointer data,
			     GtkWidget *da_property)
{
  GtkWidget	*cs_dialog;
  GtkWidget	*cs;
  gdouble	color[4];
  GdkColor	*gdk_color;
  GtkWidget	*widget;
  
  cs_dialog =
    gtk_color_selection_dialog_new("Background color of Drawing Area");
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG
				(cs_dialog)->ok_button), "clicked",
		     GTK_SIGNAL_FUNC(OkButtonClicked), cs_dialog);
  gtk_signal_connect_object(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG
				       (cs_dialog)->cancel_button), "clicked",
			    GTK_SIGNAL_FUNC(gtk_widget_destroy),
			    GTK_OBJECT(cs_dialog));
  gtk_signal_connect(GTK_OBJECT(GTK_COLOR_SELECTION_DIALOG
				(cs_dialog)->colorsel), "color_changed",
    		     GTK_SIGNAL_FUNC(ColorSelectionChanged), da_property );
  gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION
					(GTK_COLOR_SELECTION_DIALOG
					 (cs_dialog)->colorsel),
					GTK_UPDATE_CONTINUOUS);
  gtk_widget_destroy(GTK_COLOR_SELECTION_DIALOG(cs_dialog)->help_button);
  cs = GTK_COLOR_SELECTION_DIALOG(cs_dialog)->colorsel;
  widget = get_current_widget();
  gdk_color = gtk_object_get_data(GTK_OBJECT(widget), "color");
  color[0] = (gdk_color->red) / 65535.0;
  color[1] = (gdk_color->green) / 65535.0;
  color[2] = (gdk_color->blue) / 65535.0;
  gtk_color_selection_set_color(GTK_COLOR_SELECTION(cs), color);
  gtk_widget_show(cs_dialog);
}

void		GtkDrawingArea_properties(GtkWidget *widget, gint row)
{
  GtkWidget	*label;
  GtkTooltips	*tooltips;
  GtkWidget	*event_box;
  GtkWidget	*table;
  GtkWidget	*drawing_area;
  
  table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
			      "properties");    
  event_box = gtk_event_box_new();
  drawing_area = gtk_drawing_area_new();
  gtk_object_set_data(GTK_OBJECT(epingle->win_properties),
		      "drawing_area", drawing_area);
  gtk_container_add(GTK_CONTAINER(event_box), drawing_area);
  gtk_table_attach_defaults(GTK_TABLE(table), event_box, 1, 2, row-1, row);    
  gtk_widget_show(drawing_area);
  gtk_widget_show(event_box);
  gtk_signal_connect(GTK_OBJECT(event_box), "button_press_event",
		     GTK_SIGNAL_FUNC(change_color), drawing_area);
  event_box = gtk_event_box_new();
  label = gtk_label_new("Color");
  gtk_container_add(GTK_CONTAINER(event_box), label);
  gtk_widget_show(label);
  tooltips = gtk_tooltips_new();
  gtk_tooltips_set_tip(tooltips, event_box,
		       "Background color of drawing area", NULL);
  gtk_signal_connect(GTK_OBJECT(event_box), "button_press_event",
		     GTK_SIGNAL_FUNC(change_color), drawing_area);
  gtk_table_attach_defaults(GTK_TABLE(table), event_box, 0, 1, row-1, row);    
  gtk_widget_show(event_box);
}

void		GtkDrawingArea_save(FILE *fp, int tab,
				    GtkWidget *drawing_area)
{
  GdkColor	*color;
  gint		i;
  
  color = gtk_object_get_data(GTK_OBJECT(drawing_area), "color");
  for(i = 1; i <= tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<RED>\t\t%hu\n", color->red);
  for(i = 1; i <= tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<GREEN>\t\t%hu\n", color->green);
  for(i = 1; i <= tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<BLUE>\t\t%hu\n", color->blue);
  /*  for(i=1; i<=tab; i++)*/
  /*    fprintf(fp, "\t");*/
  /*  fprintf(fp, "<PIXEL>\t\t%lu\n", color->pixel);*/
}

GtkWidget	*GtkDrawingArea_restore(FILE *fp, int tab)
{
  GtkWidget	*drawing_area;
  GdkColor	*color;
  gint		i;
  
  drawing_area = gtk_drawing_area_new(); 
  color = xmalloc(sizeof (*color));
  gtk_object_set_data(GTK_OBJECT(drawing_area), "color", color);
  for(i = 1; i <= tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%*s\t%hu\n", &color->red);
  for(i = 1; i <= tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%*s\t%hu\n", &color->green);
  for(i = 1; i <= tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%*s\t%hu\n", &color->blue);
  for(i = 1; i <= tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%*s\t%lu\n", &color->pixel);
  return drawing_area;
}


