/*
** editor.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Tue Apr  6 14:21:33 1999 sebastien thebert
** Last update Tue Apr  4 17:35:24 2000 Sebastien Thebert
*/
#include "main.h"

extern GtkWidget	*edit_info_entry;

GdkColor		fgcolor, bgcolor;

/***********************************************************/
void	setcolor(GdkColor cl)
{
  fgcolor.red = cl.red;
  fgcolor.green = cl.green;
  fgcolor.blue = cl.blue;
  if (!gdk_color_alloc(epingle->colormap, &fgcolor)) 
    g_error("EPingle ERROR: Couldn't allocate foreground color\n");
}

/***********************************************************/
void	setbgcolor(GdkColor cl)
{
  bgcolor.red = cl.red;
  bgcolor.green = cl.green;
  bgcolor.blue = cl.blue;
  if (!gdk_color_alloc(epingle->colormap, &bgcolor)) 
    g_error("EPingle ERROR: Couldn't allocate background color\n");
}
/***********************************************************/
short	is_type(char *s)
{
  if ((strcmp(s,"int") == 0) || (strcmp(s,"short") == 0)
      || (strcmp(s,"long") == 0) || (strcmp(s,"unsigned") == 0)
      || (strcmp(s,"char") == 0) || (strcmp(s,"static") == 0)
      || (strcmp(s,"float") == 0) || (strcmp(s,"double") == 0)
      || (strcmp(s,"struct") == 0) || (strcmp(s,"FILE") == 0)
      || (strcmp(s,"void") == 0))
    return (1);
  else
    return (0);
}

/*************************************************/
short	is_gtk_type(char *s)
{
  if ((strcmp(s,"GtkWidget") == 0) || (strcmp(s,"GtkTooltips") == 0)
      || (strcmp(s,"GdkColor") == 0) || (strcmp(s,"GdkCursor") == 0)
      || (strcmp(s,"gint") == 0) || (strcmp(s,"gfloat") == 0)
      || (strcmp(s,"gchar") == 0) || (strcmp(s,"GList") == 0))
    return (1);
  else
    return (0);
}

/*************************************************/
short	is_reserved_word(char *s)
{
  if ((strcmp(s, "if") == 0) || (strcmp(s, "else") == 0)
      || (strcmp(s, "do") == 0) || (strcmp(s, "break") == 0)
      || (strcmp(s, "switch") == 0) || (strcmp(s, "case") == 0)
      || (strcmp(s, "default") == 0) || (strcmp(s, "return") == 0)
      || (strcmp(s, "while") == 0) || (strcmp(s, "new") == 0)
      || (strcmp(s, "main") == 0))
    return (1);
  else
    return (0);  
}

/***********************************************************/
char	*str_cut(char *str, int first, int i)
{
  int	cpt = 0;
  char	*temp;
  
  temp = xmalloc(sizeof (char) * FN_LENGTH);
  while ((cpt + first) < (i + 1))
    {
      temp[cpt] = str[cpt + first];
      cpt++;
    }
  temp[cpt - 1] = '\0';
  return(temp);
}

/***********************************************************/
void		advanced_coloration(char *line)
{
  static short	string_line = 0;
  char		*temp = NULL;
  int		i = 0, first = 0;
  
  while (i < strlen(line))
    {
      if (line[i] == '(')
	{
	  temp = str_cut(line, first, i);
	  first = i+1;
	  if (is_type(temp) == 1)
	    setcolor(color->type);
	  else if (is_gtk_type(temp) == 1)
	    setcolor(color->gtktype);
	  else if (is_reserved_word(temp) == 1)
	    setcolor(color->reserved_word);
	  gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
			  &bgcolor, temp, -1);
	  setcolor(color->normal);  
	  gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
			  &bgcolor, "(", -1);
	}
      if ((line[i] == '\"') && (string_line == 1))
	{
	  temp = str_cut(line, first, i);
	  first = i + 1;
	  string_line = 0;
	  setcolor(color->string);
	  gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
			  &bgcolor, temp, -1);
	  gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
			  &bgcolor, "\"", -1);
	  setcolor(color->normal);
	}
      else if ((line[i] == '\"') && (string_line == 0))
	{
	  temp = str_cut(line, first, i);
	  first = i + 1;
	  string_line = 1;
	  gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
			  &bgcolor, temp, -1);
	  setcolor(color->string);  
	  gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
			  &bgcolor, "\"", -1);
	}
      i++;
    }
  temp = str_cut(line, first, i);
  
  if (is_type(temp) == 1)
    setcolor(color->type);
  else if (is_gtk_type(temp) == 1)
    setcolor(color->gtktype);
  else if (is_reserved_word(temp) == 1)
    setcolor(color->reserved_word);
  gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL,
		  &fgcolor, &bgcolor, temp, -1);
  free(temp);
}

/***********************************************************/
void	coloration(char *line)
{
  char	*temp;
  short include_line = 0, define_line = 0;
  short	advanced;
  
  temp = xmalloc(sizeof (char) * FN_LENGTH);
  strcpy(temp, line);
  temp = strtok(temp," ");
  setbgcolor(color->background);
  while (temp != NULL)
    {
      setcolor(color->normal);     
      advanced = 0;
      if (strcmp("#include", temp) == 0)
	{
	  include_line = 1;
	  setcolor(color->include);
	}
      else if (strcmp("#define", temp) == 0)
	{
	  define_line = 1;
	  setcolor(color->define);
	}
      else if (define_line == 1)
	setcolor(color->define);
      else if (include_line == 1)
	setcolor(color->include);
      else if ((strcmp("{", temp) == 0) || (strcmp("}", temp) == 0))
	setcolor(color->reserved_word);
      else if (is_type(temp) == 1)
	setcolor(color->type);
      else if (is_gtk_type(temp) == 1)
	setcolor(color->gtktype);
      else if (is_reserved_word(temp) == 1)
	setcolor(color->reserved_word);
      else
	{
	  advanced_coloration(temp);
	  advanced = 1;
	}
      if (advanced == 0)
	gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
			&bgcolor, temp, -1);
      gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
		      &bgcolor, " ", -1);
      temp = strtok(NULL, " ");
    }
  gtk_text_backward_delete(GTK_TEXT(epingle->edit_text), 1); 
  free(temp);
}

/***********************************************************/
void	refresh_file(char *text_name)
{
  char	*line;
  char	c;
  gint	pos_start, pos, length_text, i;
  
  line = xmalloc(sizeof (char) * FN_LENGTH);
  epingle->edit_text = gtk_object_get_data(GTK_OBJECT
					   (epingle->editor_notebook),
					   text_name);
  gtk_text_freeze(GTK_TEXT(epingle->edit_text));
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), 0);
  length_text = gtk_text_get_length(GTK_TEXT(epingle->edit_text));
  pos = pos_start = i = 0;
  while (pos < length_text) 
    {
      c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos);
      line[i] = c;
      if (c == '\n')
	{
	  line[i + 1] = '\0';
	  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos_start);
	  gtk_text_forward_delete(GTK_TEXT(epingle->edit_text),
				  pos - pos_start + 1);
	  coloration(line);
	  pos_start = pos + 1;
	  i = -1;
	}
      i++;
      pos++;
    }
  gtk_text_thaw(GTK_TEXT(epingle->edit_text));
  free(line); 
}

/***********************************************************/
void		refresh_all_text(void)
{
  GtkWidget     *widget;
  char          *window_name;
  char		*text_name;
  int		i;
  
  text_name = xmalloc(sizeof (char) * LENGTH);
  for (i = 1; i < g_list_length(epingle->window_list); i++)
    {
      widget = g_list_nth(epingle->window_list, i)->data;
      window_name = gtk_widget_get_name(widget);
      strcpy(text_name, "text_");
      strcat(text_name, window_name);
      refresh_file(text_name);
    }
  strcpy(text_name, "text_");
  strcat(text_name, epingle->project_name);
  refresh_file(text_name);
  free(text_name);
}

/***********************************************************/
void		set_edit_text(void)
{
  GtkWidget	*label;
  gchar		*str_label;
  char		*text_label;
  
  text_label = xmalloc(sizeof (char) * LENGTH);
  label =
    GTK_WIDGET(GTK_NOTEBOOK(epingle->editor_notebook)->cur_page->tab_label);
  gtk_label_get(GTK_LABEL(label), &str_label);
  strcpy(text_label,"text_");
  strcat(text_label, str_label);
  epingle->edit_text =
    gtk_object_get_data(GTK_OBJECT(epingle->editor_notebook), text_label);
  free(text_label);
}

/***********************************************************/
int	search_string(char *str, gint start_pos)
{
  gint	pos, old_pos, i;
  gint	length_str, length_text;
  char	*tmp;
  char	c;
  
  tmp = str;
  length_str = strlen(str);
  length_text = gtk_text_get_length(GTK_TEXT(epingle->edit_text));
  old_pos = gtk_text_get_point(GTK_TEXT(epingle->edit_text));
  for (pos = start_pos; pos <= length_text; pos++)
    {
      c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos);
      if (c == *str)
	{
	  i = 0;
	  while ((c == *str) && (i < length_str))
	    {
	      i++;
	      str++;
	      c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos + i);
	    }
	  if (i == length_str)
	    {
	      gtk_text_set_point(GTK_TEXT(epingle->edit_text), old_pos);
	      return(pos);
	    }
	  str = tmp;
	}
    }
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), old_pos);
  return (-1);
}

/***********************************************************/
void		search_in_edit_text(GtkWidget *sender, GtkWidget *edit_entry)
{
  static gint	pos = 0;
  char		*info;
  gint		i;
  gint		num_line;
  char		c;
  char		*str;
  
  i = num_line = 1;
  if (!GTK_IS_BUTTON(sender))
    pos = 0;
  else
    {
      set_edit_text();
      info = xmalloc(sizeof (char) * LENGTH);
      pos = search_string(gtk_entry_get_text(GTK_ENTRY(edit_entry)), pos);
      while (i < pos) 
	{
	  c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), i);
	  if (c == '\n')
	    num_line++;
	  i++;
	}
      strcpy(info, gtk_entry_get_text(GTK_ENTRY(edit_entry)));
      if (pos != -1)
	{
	  strcat(info, " at line ");
	  str = int_to_str(num_line);
	  strcat(info, str);
	  free(str);
	  strcat(info, "  position ");
	  str = int_to_str(pos);
	  strcat(info, str);
	  free(str);
	}
      else
	strcat(info, " not found !");
      gtk_entry_set_text(GTK_ENTRY(edit_info_entry), info);
      pos++;
      free(info);
    }
}

/***********************************************************/
void	go_to_line(GtkWidget *sender, GtkWidget *edit_entry)
{
  gint	pos = 0, i = 1, length_text;
  gint	num_line;
  char	c;
  
  set_edit_text();
  length_text = gtk_text_get_length(GTK_TEXT(epingle->edit_text));
  num_line = atoi(gtk_entry_get_text(GTK_ENTRY(edit_entry)));
  while ((i < num_line) && (pos < length_text)) 
    {
      c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos);
      if (c == '\n')
	i++;
      pos++;
    }
  if (num_line != 0)
    {
      gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
      gtk_text_insert(GTK_TEXT(epingle->edit_text), NULL, &fgcolor,
		      &bgcolor, "GO TO", -1);
    }
  else
    gtk_entry_set_text(GTK_ENTRY(edit_info_entry), "Invalid Entry !");
}

