/*
** editor_functions.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Tue Apr  4 18:04:31 2000 Sebastien Thebert
** Last update Tue Apr  4 18:07:07 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
void		concat(char **str, int nb, ...)
{
  va_list	list;
  int		i;
  char		*tmp;
  
  tmp = xmalloc(sizeof (char) * 300);
  va_start(list, nb);
  i = 1;
  strcpy(tmp, "");
  while (i < (nb + 1))
    {
      strcat(tmp, va_arg(list, char*));
      i++;
    }
  strcpy(*str, tmp);
  free(tmp);
  va_end(list);
}

/***********************************************************/
void		color_line(int nb, ...)
{
  va_list	list;
  int		i;
  char		*tmp;
  
  tmp = xmalloc(sizeof (char) * 300);
  va_start(list, nb);
  i = 1;
  strcpy(tmp, "");
  while (i < nb+1)
    {
      strcat(tmp, va_arg(list, char*));
      i++;
    }
  coloration(tmp);
  free(tmp);
  va_end(list);
}


/***********************************************************/
void	delete_line(char *str, gint start_pos)
{
  gint	pos, pos2;
  char	c;
  
  pos = search_string(str, start_pos);
  if (pos != -1)
    {
      gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
      pos2 = pos;
      c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos2);
      while (c != '\n')
	{
	  c = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos2);
	  pos2++;
	}
      gtk_text_forward_delete(GTK_TEXT(epingle->edit_text), pos2-pos);
      gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
    }
  else
    g_error("EPingle ERROR: function delete_line: String not found !\n");
}

/***********************************************************/
void	seek_before(char *str)
{
  gint	pos;
  
  pos = search_string(str, 0);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
}

/***********************************************************/
void	seek_in_fct_before(char *fct, char *str)
{
  gint	pos;
  
  pos = search_string(fct, 0);
  pos = search_string(str, pos);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
}


/***********************************************************/
void	seek_after(char *str)
{
  gint	pos;
  
  pos = search_string(str, 0);
  pos += strlen(str);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
}

/***********************************************************/
void	seek_in_fct_after(char *fct, char *str)
{
  gint	pos;
  
  pos = search_string(fct, 0);
  pos = search_string(str, pos);
  pos += strlen(str);
  gtk_text_set_point(GTK_TEXT(epingle->edit_text), pos);
}
