/*
** enums.c
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Wed Jun  9 23:31:53 1999 Maxime VERNIER
** Last update Thu Jun 17 16:52:00 1999 maxime vernier
*/

#include <gtk/gtk.h>

GList *
GtkJustificationList()
{
  GList *list = NULL;
  
  list = g_list_append(list, "left");
  list = g_list_append(list, "right");
  list = g_list_append(list, "center");
  list = g_list_append(list, "fill");
  return list;
}

gchar *
GtkJustificationText(GtkJustification Justification)
{
  gchar *text = NULL;

  switch(Justification)
    {
    case GTK_JUSTIFY_LEFT:
      text = "left";
      break;
    case GTK_JUSTIFY_RIGHT:
      text = "right";
      break;
    case GTK_JUSTIFY_CENTER:
      text = "center";
      break;
    case GTK_JUSTIFY_FILL:
      text = "fill";
      break;
    }
  return text;
}

GList *
GtkOrientationList()
{
  GList *list = NULL;
  
  list = g_list_append(list, "horizontal");
  list = g_list_append(list, "vertical");
  return list;
}

GList *
GtkReliefStyleList()
{
  GList *list = NULL;
  
  list = g_list_append(list, "normal");
  list = g_list_append(list, "half");
  list = g_list_append(list, "none");
  return list;
}

GList *
GtkSelectionModeList()
{
  GList *list = NULL;
  
  list = g_list_append(list, "single");
  list = g_list_append(list, "browse");
  list = g_list_append(list, "multiple");
  list = g_list_append(list, "extended");
  return list;
}

gchar *
GtkSelectionModeText(GtkSelectionMode selection_mode)
{
  gchar *text = NULL;

  switch(selection_mode)
    {
    case GTK_SELECTION_SINGLE:
      text = "single";
      break;
    case GTK_SELECTION_BROWSE:
      text = "browse";
      break;
    case GTK_SELECTION_MULTIPLE:
      text = "multiple";
      break;
    case GTK_SELECTION_EXTENDED:
      text = "extended";
      break;
    }
  return text;
}

GList *
GtkShadowTypeList()
{
  GList *list = NULL;
  
  list = g_list_append(list, "none");
  list = g_list_append(list, "in");
  list = g_list_append(list, "out");
  list = g_list_append(list, "etched in");
  list = g_list_append(list, "etched out");
  return list;
}

gchar *
GtkShadowTypeText(GtkShadowType shadow_type)
{
  gchar *text = NULL;
  
  switch(shadow_type)
    {
    case GTK_SHADOW_NONE:
      text = "none";
      break;
    case GTK_SHADOW_IN:
      text = "in";
      break;
    case GTK_SHADOW_OUT:
      text = "out";
      break;
    case GTK_SHADOW_ETCHED_IN:
      text = "etched in";
      break;
    case GTK_SHADOW_ETCHED_OUT:
      text = "etched out";
      break;
    }
  return text;
}

GtkShadowType 
get_shadow_type(gchar *text)
{
  GtkShadowType shadow_type;

  if(!strcmp(text, "none"))
    shadow_type = GTK_SHADOW_NONE;
  else
     if(!strcmp(text, "in"))
       shadow_type = GTK_SHADOW_IN;
     else
        if(!strcmp(text, "out"))
	  shadow_type = GTK_SHADOW_OUT;
	else
	  if(!strcmp(text, "etched in"))
	    shadow_type = GTK_SHADOW_ETCHED_IN;
	  else
	    shadow_type = GTK_SHADOW_ETCHED_OUT;
  return shadow_type;
}

gchar *
GtkUpdateTypeText(GtkUpdateType update_type)
{
  gchar *text;

  switch(update_type)
    {
    case GTK_UPDATE_CONTINUOUS:
      text = "continuous";
      break;
    case GTK_UPDATE_DISCONTINUOUS:
      text = "discontinuous";
      break;
    case GTK_UPDATE_DELAYED:
      text = "delayed";
      break;
    }
  return text;
}

GList *
gtk_position_types()
{
  GList *list = NULL;
  
  list = g_list_append(list, "left");
  list = g_list_append(list, "right");
  list = g_list_append(list, "top");
  list = g_list_append(list, "bottom");
  return list;
}

GList *
colorsel_policies()
{
  GList *list = NULL;
  
  list = g_list_append(list, "continuous");
  list = g_list_append(list, "discontinuous");
  list = g_list_append(list, "delayed");
  return list;
}

GtkOrientation
get_orientation(gchar *text)
{
  GtkOrientation orientation;

  if(!strcmp(text, "horizontal"))
    orientation = GTK_ORIENTATION_HORIZONTAL;
  else
    orientation = GTK_ORIENTATION_VERTICAL;
  return orientation;
}

gchar *
get_text_orientation(GtkOrientation orientation)
{
  gchar *text = NULL;

  switch(orientation)
    {
    case GTK_ORIENTATION_HORIZONTAL:
      text = "horizontal";
      break;
    case GTK_ORIENTATION_VERTICAL:
      text = "vertical";
      break;
    }
  return text;
}

GtkReliefStyle
get_relief_style(gchar *text)
{
  GtkReliefStyle relief_style;
  
  if(!strcmp(text, "normal"))
    relief_style = GTK_RELIEF_NORMAL;
  else
    if(!strcmp(text, "half"))
      relief_style = GTK_RELIEF_HALF;
    else
      relief_style = GTK_RELIEF_NONE;
  return relief_style;
}


gchar *
get_text_relief_style(GtkReliefStyle relief_style)
{
  gchar *text = NULL;
  
  switch(relief_style)
    {
    case GTK_RELIEF_NORMAL:
      text = "normal";
      break;
    case GTK_RELIEF_HALF:
      text = "half";
      break;
    case GTK_RELIEF_NONE:
      text = "none";
      break;
    }
  return text;
}



