/*
** epingle_widget_get_label.c for EPingle in 
** 
** Made by maxime vernier
** Login   <vernie_m@epita.fr>
** 
** Started on  Mon Feb 28 10:45:32 2000 maxime vernier
** Last update Mon Apr  3 23:34:33 2000 Maxime Vernier
*/

#include "main.h"

GtkWidget	*epingle_widget_get_parent(GtkWidget *widget)
{
  GtkWidget	*parent;
  
  parent = widget->parent;
  while (GTK_IS_EVENT_BOX(parent) ||
	 GTK_IS_FIXED(parent))
    parent = parent->parent;
  return parent;
}

GtkCTreeNode	*epingle_widget_get_parent_hierarchy_node(GtkWidget *widget)
{
  GtkWidget	*parent;
  GtkCTreeNode	*parent_node;

  parent = epingle_widget_get_parent(widget);
  if (parent)
    parent_node = gtk_object_get_data(GTK_OBJECT(parent), "hierarchy_node");
  else
    parent_node = NULL;
  return parent_node;
}

gchar		*epingle_widget_get_label(GtkWidget	*widget)
{
  gchar		*label;

  if (GTK_IS_WINDOW(widget))
    label = epingle_window_get_title(GTK_WINDOW(widget));
  else
    if (GTK_IS_BUTTON(widget))
      label = epingle_button_get_label(GTK_BUTTON(widget));
    else
      if (GTK_IS_LABEL(widget))
	gtk_label_get(GTK_LABEL(widget), &label);
    else
      label = NULL;
  return label;
}
