/*
** events.h
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Tue May  4 14:54:18 1999 Maxime VERNIER
** Last update Fri Jun 18 00:56:00 1999 maxime vernier
*/

#include "global.h"

#ifndef   __EVENTS_H__
#define   __EVENTS_H__

#define NB_WIDGET_EV		11
#define NB_WIN_EV		NB_WIDGET_EV+1
#define NB_EDIT_EV		NB_WIDGET_EV+5

#define GtkWidget_show			1
#define GtkWidget_hide			2
#define GtkWidget_button_press_event	3
#define GtkWidget_button_release_event	4
#define GtkWidget_motion_notify_event	5
#define GtkWidget_destroy_event		6
#define GtkWidget_key_press_event	7
#define GtkWidget_key_release_event	8
#define GtkWidget_enter_notify_event	9
#define GtkWidget_leave_notify_event	10
#define GtkWidget_drag_drop		11

#define GtkEditable_changed		60
#define GtkEditable_insert_text		61
#define GtkEditable_delete_text		62
#define GtkEditable_activate		63
#define GtkEditable_set_editable	64

#define GtkWindow_set_focus		21

#define GtkButton_pressed		30
#define GtkButton_released		31
#define GtkButton_clicked		32
#define GtkButton_enter			33
#define GtkButton_leave			34
#define GtkToggleButton_toggled		35

#define GtkEntry_set_text		43

#define GtkColorSelection_color_changed 50

#define GtkCList_select_row		70
#define GtkCList_unselect_row		71
#define GtkCList_click_column		72


void init_events(gint events_nb);
void add_common_widget_events(GtkWidget *table, GtkWidget *widget);
void add_window_events(GtkWidget *table, GtkWidget *widget);
void add_button_events(GtkWidget *table, GtkWidget *widget);
void add_toggle_button_events(GtkWidget *table, GtkWidget *widget);
void add_entry_events(GtkWidget *table, GtkWidget *widget);

void GtkColorSelectionDialog_events(GtkWidget *table, GtkWidget *widget);
void GtkCList_events(GtkWidget *table, GtkWidget *widget);

#endif /* __EVENTS_H__ */
