/*
** frame_events.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Thu Mar 23 00:09:38 2000 Sebastien Thebert
** Last update Wed Apr  5 01:39:38 2000 Sebastien Thebert
*/
#include "main.h"

/*
** set_fixed_frame_events
*/
void	set_fixed_frame_events(GtkWidget *fixed_frame)
{
  gtk_widget_set_events(fixed_frame, GDK_BUTTON_PRESS_MASK
			| GDK_BUTTON_MOTION_MASK | GDK_POINTER_MOTION_MASK
			| GDK_POINTER_MOTION_HINT_MASK);
  gtk_signal_connect(GTK_OBJECT(fixed_frame), "button_press_event",
		     GTK_SIGNAL_FUNC(action_on_frame), NULL);
  gtk_signal_connect(GTK_OBJECT(fixed_frame), "motion_notify_event",
		     GTK_SIGNAL_FUNC(motion_on_window), NULL);
}

/*
** set_eventbox_frame_events
*/
void	set_eventbox_frame_events(GtkWidget *eventbox)
{
  gtk_widget_set_events(eventbox, GDK_BUTTON_PRESS_MASK
			| GDK_BUTTON_RELEASE_MASK
			| GDK_ENTER_NOTIFY | GDK_LEAVE_NOTIFY);
  gtk_signal_connect(GTK_OBJECT(eventbox), "button_press_event",
		     GTK_SIGNAL_FUNC(action_on_widget), NULL);
  gtk_signal_connect(GTK_OBJECT(eventbox), "button_release_event",
		     GTK_SIGNAL_FUNC(button_release), NULL);
  gtk_signal_connect(GTK_OBJECT(eventbox), "enter_notify_event",
		     GTK_SIGNAL_FUNC(enter_eventbox), NULL);
  gtk_signal_connect(GTK_OBJECT(eventbox), "leave_notify_event",
		     GTK_SIGNAL_FUNC(leave_eventbox), NULL);
}
