/*
** global.c
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Mon Feb  1 14:06:24 1999 Maxime VERNIER
** Last update Fri Mar 31 18:54:01 2000 Sebastien Thebert
*/

#include "main.h"

GtkWidget	*widget_get_parent(GtkWidget *widget)
{
  GtkWidget	*parent;
  
  if(GTK_WIDGET_NO_WINDOW(widget))
    parent = widget->parent->parent;
  else 
    parent = widget->parent;
  return parent;
}

void	set_window_type(GtkWidget *widget, gchar *text)
{ 
  if (!strcmp(text, "toplevel"))
    GTK_WINDOW(widget)->type = GTK_WINDOW_TOPLEVEL;
  else 
    if (!strcmp(text, "dialog"))
      GTK_WINDOW(widget)->type = GTK_WINDOW_DIALOG;
    else 
      if (!strcmp(text, "popup"))
	GTK_WINDOW(widget)->type = GTK_WINDOW_POPUP;
}

void	set_window_position(GtkWidget *widget, gchar *text)
{
  if (!strcmp(text, "none"))
    gtk_window_position(GTK_WINDOW(widget), GTK_WIN_POS_NONE);
  else 
    if (!strcmp(text, "center"))
      gtk_window_position(GTK_WINDOW(widget), GTK_WIN_POS_CENTER);
    else 
      if (!strcmp(text, "mouse"))
	gtk_window_position(GTK_WINDOW(widget), GTK_WIN_POS_MOUSE);
}

void		set_current_widget(GtkWidget *widget)
{
  GtkWidget	*tree_item;
  GtkWidget	*wid;
  
  wid = get_current_widget();
  if (wid)
    {
      tree_item = gtk_object_get_user_data(GTK_OBJECT(wid));
      if(tree_item)
	gtk_tree_item_deselect(GTK_TREE_ITEM(tree_item));
    }
  gtk_object_set_data(GTK_OBJECT(epingle->main_window), "current", widget);
  if ((tree_item = gtk_object_get_user_data(GTK_OBJECT(widget))))
    gtk_tree_item_select(GTK_TREE_ITEM(tree_item));
}

GtkWidget	*get_current_widget()
{
  return gtk_object_get_data(GTK_OBJECT(epingle->main_window), "current");
}

gint	get_widget_type(GtkWidget *widget)
{
  if(GTK_IS_CLIST(widget))
    return CLIST;
  if(GTK_IS_TOOLBAR(widget))
    return TOOLBAR;
  if(GTK_IS_OPTION_MENU(widget))
    return OPTION_MENU;
  if(GTK_IS_TEXT(widget))
    return TEXT;
  if(GTK_IS_COMBO(widget))
    return COMBO;
  if(GTK_IS_DRAWING_AREA(widget))
    return DRAWING_AREA;
  if(GTK_IS_NOTEBOOK(widget))
    return NOTEBOOK;
  if(GTK_IS_PROGRESS_BAR(widget))
    return PROGRESS_BAR;
  if(GTK_IS_LABEL(widget))
    return LABEL;
  if(GTK_IS_ENTRY(widget))
    return ENTRY;
  if(GTK_IS_FRAME(widget))
    return FRAME;
  if(GTK_IS_LABEL(widget))
    return LABEL;
  if(GTK_IS_CHECK_BUTTON(widget))
    return CHECK_BUTTON;
  if(GTK_IS_TOGGLE_BUTTON(widget))
    return TOGGLE_BUTTON;
  if(GTK_IS_BUTTON(widget))
    return BUTTON;
  if(GTK_IS_DIALOG(widget))
    return DIALOG;
  if(GTK_IS_COLOR_SELECTION_DIALOG(widget))
    return COLOR_SELECTION_DIALOG;
  if(GTK_IS_FILE_SELECTION(widget))
    return FILE_SELECTOR;
  if(GTK_IS_FONT_SELECTION_DIALOG(widget))
    return FONT_SELECTION_DIALOG;
  if(GTK_IS_WINDOW(widget))
    return WINDOW;
  return NONE;
}






