#include "global.h"
#include "help.h"

GtkWidget	*create_help_window(GtkWidget *label1, GtkWidget *label2)
{
  GtkWidget	*window;
  GtkWidget	*vbox;
  
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_events(window, GDK_BUTTON_PRESS_MASK);
  gtk_signal_connect_object(GTK_OBJECT(window), "button_press_event",
			    GTK_SIGNAL_FUNC(gtk_widget_destroy),
			    GTK_OBJECT(window));
  gtk_window_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
  gtk_container_border_width(GTK_CONTAINER(window), 10);
  vbox = gtk_vbox_new(FALSE, 10);
  gtk_box_pack_start(GTK_BOX(vbox), label1, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), label2, FALSE, FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(window);
  return window;
}

void		about(GtkWidget *widget, gpointer data)
{
  GtkWidget *window;
  GtkWidget *label1;
  GtkWidget *label2;
  
  label1 = gtk_label_new(EPINGLE_VERSION);
  gtk_widget_show(label1);
  label2 = gtk_label_new("\nCopyright (c) 1999-2000\n
S. Thebert, M. Vernier & B. Morisseau\n\nBy:\n Sebastien Thebert (theber_s@epita.fr)
Maxime Vernier (vernie_m@epita.fr)
and Bertrand Morisseau (moriss_b@epita.fr)
\nThis program is covered by the terms of \nthe GNU General Public License (GPL)\nand is distributed in the hope that it will be useful.\n
Homepage:\nhttp://www.epita.fr/~theber_s/epingle\n"); 
  gtk_widget_show(label2);
  window = create_help_window(label1, label2);
  gtk_window_set_title(GTK_WINDOW(window), "About EPIngle...");
}

void		legal(GtkWidget *widget, gpointer data)
{
  GtkWidget	*window;
  GtkWidget	*label1;
  GtkWidget	*label2;
  
  label1 = gtk_label_new("\n\tEPIngle is free software;
you can redistribute it and/or modify it
under the terms of the GNU General Public License
as published by the Free Software Foundation;
either version 2 of the License,
or (at your option) any later version.");
  gtk_widget_show(label1);
  label2 = gtk_label_new("\tEPIngle is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

\t You should have received a copy of the GNU General Public
License along with this program;
if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.\n");
  gtk_widget_show(label2);
  window = create_help_window(label1, label2);
  gtk_window_set_title(GTK_WINDOW(window), "Legal");
}



