/*
** hierarchy.c for EPingle
** 
** Made by maxime vernier
** Login   <vernie_m@epita.fr>
** 
** Started on  Fri Feb 18 15:52:58 2000 maxime vernier
** Last update Tue Apr  4 16:19:10 2000 Sebastien Thebert
*/
#include "main.h"

gboolean	found_in_hierarchy;

static void	cb_ctree_select_row(GtkCTree		*ctree,
				    GtkCTreeNode	*ctree_node, 
				    gint		column,
				    gpointer		data)
{
  GtkWidget	*widget;

  widget = gtk_ctree_node_get_row_data(ctree, ctree_node);
  edit_properties_of_widget(widget);
}

void		hierarchy_new()
{
  GtkWidget	*window;
  GtkWidget	*scrolled_win;
  gchar		*titles[] = { "Name", "Title" };
  
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_uposition(window, 450, 0);
  gtk_container_set_border_width (GTK_CONTAINER(window), 5);
  gtk_window_set_title(GTK_WINDOW(window), "Hierarchy");
  scrolled_win = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win),
				 GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_widget_set_usize(scrolled_win, 150, 200);
  gtk_container_add(GTK_CONTAINER(window), scrolled_win);
  gtk_widget_show(scrolled_win);
  epingle->hierarchy = gtk_ctree_new_with_titles(2, 0, titles);
  gtk_signal_connect(GTK_OBJECT(epingle->hierarchy), "tree_select_row",
		     GTK_SIGNAL_FUNC(cb_ctree_select_row), NULL);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_win),
					epingle->hierarchy);
  gtk_widget_show(epingle->hierarchy);
  gtk_widget_show(window);
}

void		hierarchy_add(GtkWidget	*widget)
{
  gchar		*titles[2];
  GtkCTreeNode	*node;
  GtkCTreeNode	*parent_node;
  gint		widget_type;
  
  if (GTK_IS_WINDOW(widget))
    epingle->window_list = g_list_append(epingle->window_list, widget);
  parent_node = epingle_widget_get_parent_hierarchy_node(widget);
  titles[0] = gtk_widget_get_name(widget);
  titles[1] = epingle_widget_get_label(widget);
  widget_type = get_widget_type(widget);
  node = gtk_ctree_insert_node(GTK_CTREE(epingle->hierarchy), 
			       parent_node, NULL, titles, 200,
			       NULL, NULL, NULL, NULL, FALSE, TRUE);
  gtk_ctree_node_set_row_data(GTK_CTREE(epingle->hierarchy), node, widget);
  gtk_object_set_data(GTK_OBJECT(widget), HIERARCHY_KEY, node);
}

void		hierarchy_remove(GtkWidget *widget)
{
  GtkCTreeNode	*node;
  
  if (GTK_IS_WINDOW(widget))
    epingle->window_list = g_list_remove(epingle->window_list, widget);
  node = gtk_object_get_data(GTK_OBJECT(widget), HIERARCHY_KEY);
  gtk_ctree_remove_node(GTK_CTREE(epingle->hierarchy), node);
}

void		FindFunc(GtkCTree *ctree, GtkCTreeNode *node, gpointer data)
{
  GtkWidget	*widget;
  gchar		*widget_name;
  gchar		*name;

  name = (gchar *)data;
  widget = gtk_ctree_node_get_row_data(ctree, node);
  widget_name = gtk_widget_get_name(widget);
  if (!strcmp(widget_name, name))
    found_in_hierarchy = TRUE;
}

int		hierarchy_find_by_name(gchar *name)
{
  found_in_hierarchy = FALSE;
  gtk_ctree_pre_recursive(GTK_CTREE(epingle->hierarchy), NULL, FindFunc, name);
  return (found_in_hierarchy);
}

void		hierarchy_move(GtkWidget *widget)
{
  GtkCTreeNode	*node;
  GtkCTreeNode	*parent_node;
  GList		*children;

  if (GTK_IS_EVENT_BOX(widget))
    {
      children = gtk_container_children(GTK_CONTAINER(widget));
      widget = g_list_first(children)->data;
    }
  node = gtk_object_get_data(GTK_OBJECT(widget), HIERARCHY_KEY);
  parent_node = epingle_widget_get_parent_hierarchy_node(widget);
  gtk_ctree_move(GTK_CTREE(epingle->hierarchy), node, parent_node, NULL);
}








