/*
** main.h
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Sat Feb 13 17:06:43 1999 sebastien thebert
** Last update Wed Apr  5 13:15:26 2000 Sebastien Thebert
*/
#ifndef   __MAIN_H__
#define   __MAIN_H__

#define EPINGLE_VERSION "EPIngle 0.4.9"
#define	LENGTH		80
#define	FN_LENGTH	300
#define WIDTH		60
#define HEIGHT		25

#define UP		1
#define DOWN		2
#define LEFT		3
#define LEFTUP		31
#define LEFTDOWN	32
#define RIGHT		4
#define RIGHTUP		41
#define RIGHTDOWN	42

#define WINDOW		1
#define BUTTON		2
#define TOGGLE_BUTTON	3 
#define CHECK_BUTTON	4
#define RADIO_BUTTON	5

#define LABEL		10
#define ENTRY      	11
#define SPIN_BUTTON	12
#define COMBO		13
#define TEXT		14

#define FRAME		20
#define NOTEBOOK	21
#define TABLE		22

#define MENU		30
#define OPTION_MENU	31
#define PROGRESS_BAR	32
#define STATUSBAR	33
#define TOOLBAR		34
#define CLIST		35

#define DRAWING_AREA	40
#define PIXMAP		41

#define DIALOG			50
#define FILE_SELECTOR		51
#define COLOR_SELECTION_DIALOG	52
#define FONT_SELECTION_DIALOG	53

#define LEFT_ALIGN	101
#define RIGHT_ALIGN	102
#define TOP_ALIGN	103
#define BOTTOM_ALIGN	104
#define WIDTH_ALIGN	105
#define HEIGHT_ALIGN	106

#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "code_generator.h"
#include "code_generator_events.h"
#include "code_gen_c_file.h"
#include "compilation.h"
#include "compilation_options.h"
#include "completion.h"

#include "create_widget.h"
#include "create_windows.h"
#include "create_buttons.h"
#include "create_texts.h"
#include "create_gfx.h"
#include "create_containers.h"

#include "data_linkage.h"
#include "dragndrop.h"
#include "editor.h"
#include "editor_functions.h"
#include "generate_makefile.h"
#include "main_edit_window.h"
#include "main_window.h"
#include "menu.h"
#include "name_generation.h"
#include "preferences_editor.h"
#include "put_widget.h"
#include "resize_widget.h"
#include "table.h"

#include "widget_events.h"
#include "frame_events.h"
#include "notebook_events.h"
#include "table_events.h"

#include "widget_help.h"

#include "file.h"
#include "save.h"
#include "save_events.h"
#include "restore.h"
#include "restore_events.h"
#include "help.h"
#include "global.h"
#include "properties.h"
#include "tree.h"
#include "events.h"
#include "New.h"
#include "enums.h"
#include "write_properties.h"

#include "widget.h"
#include "window.h"
#include "file_selection.h"
#include "color_selection_dialog.h"
#include "font_selection.h"
#include "button.h"
#include "toggle_button.h"
#include "check_button.h"
#include "label.h"
#include "entry.h"
#include "combo.h"
#include "text.h"
#include "drawing_area.h"
#include "frame.h"
#include "notebook.h"
#include "option_menu.h"
#include "progress_bar.h"
#include "toolbar.h"
#include "clist.h"
#include "menu_bar.h"

#include "hierarchy.h"
#include "epingle_widget.h"
#include "epingle_window.h"
#include "epingle_button.h"

struct		epingle_info
{
  GtkWidget	*main_window;
  GtkWidget	*hierarchy;
  GtkWidget	*win_properties;
  GtkWidget	*edit_text;
  GtkWidget	*editor_notebook;
  GList		*window_list;
  GtkWidget	*widget_clicked;
  gint		widget_moving;
  gint		widget_resizing;
  GdkColormap	*colormap;
  char		*project_path;
  char		*project_name;
};

struct		epingle_color
{
  GdkColor	background;
  GdkColor	include;
  GdkColor	define;
  GdkColor	normal;
  GdkColor	reserved_word;
  GdkColor	type;
  GdkColor	string;
  GdkColor	gtktype;
  GdkColor	warning_compil;
  GdkColor	error_compil;
};

#ifdef	MAIN
struct epingle_info	*epingle;
struct epingle_color	*color;
#else
extern struct epingle_info	*epingle;
extern struct epingle_color	*color;
#endif

struct alignment
{
  int pos;
  int coord;
};

void	*xmalloc(int size);
char	*int_to_str(int n);

#endif /* __MAIN_H__ */


