/*
** main_edit_window.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Fri Jan 21 00:06:21 2000 Sebastien Thebert
** Last update Sat Apr  1 03:20:19 2000 Sebastien Thebert
*/
#define	EDITOR

#include "main.h"

/*
** Create Editor Window's shortcuts
*/
void		create_editor_shortcuts(GtkWidget *window)
{
  GtkWidget	*completion_menu;
  GtkWidget	*data_linkage_menu;
  GtkWidget	*widget_help_menu;
  GtkAccelGroup	*editor_accel_group;
  
  editor_accel_group = gtk_accel_group_new();
  gtk_accel_group_attach(editor_accel_group, GTK_OBJECT(window));
  completion_menu = gtk_menu_item_new_with_label("completion");
  gtk_signal_connect(GTK_OBJECT(completion_menu), "activate",
		     GTK_SIGNAL_FUNC(completion), NULL);
  gtk_widget_add_accelerator(completion_menu, "activate", editor_accel_group,
			     GDK_slash, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
  gtk_widget_show(completion_menu);
  data_linkage_menu = gtk_menu_item_new_with_label("data linkage");
  gtk_signal_connect(GTK_OBJECT(data_linkage_menu), "activate",
		     GTK_SIGNAL_FUNC(data_linkage), NULL);
  gtk_widget_add_accelerator(data_linkage_menu, "activate", editor_accel_group,
			     GDK_L, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
  gtk_widget_show(data_linkage_menu);
  widget_help_menu = gtk_menu_item_new_with_label("widget_help");
  gtk_signal_connect(GTK_OBJECT(widget_help_menu), "activate",
		     GTK_SIGNAL_FUNC(show_widget_help), NULL);
  gtk_widget_add_accelerator(widget_help_menu, "activate", editor_accel_group,
			     GDK_H, GDK_MOD1_MASK, GTK_ACCEL_VISIBLE);
  gtk_widget_show(widget_help_menu);
}

/*
** Create the Editor Window's buttons
*/
void		create_editor_buttons(GtkWidget *vbox)
{
  GtkWidget	*hbox;
  GtkWidget	*bt;
  GtkWidget	*edit_entry;
  
  hbox = gtk_hbox_new(FALSE, 0);
  edit_entry = gtk_entry_new();
  gtk_widget_show(edit_entry);
  gtk_entry_set_text(GTK_ENTRY(edit_entry), "");
  bt = gtk_button_new_with_label("Search");
  gtk_widget_show(bt);
  gtk_widget_set_usize(bt, 80, 20);
  gtk_box_pack_start(GTK_BOX(hbox), bt, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(bt), "clicked",
		     GTK_SIGNAL_FUNC(search_in_edit_text), GTK_WIDGET(edit_entry));  
  bt = gtk_button_new_with_label("Go to line");
  gtk_widget_show(bt);
  gtk_widget_set_usize(bt, 80, 20);
  gtk_box_pack_start(GTK_BOX(hbox), bt, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(bt), "clicked",
		     GTK_SIGNAL_FUNC(go_to_line), GTK_WIDGET(edit_entry));
  gtk_box_pack_start(GTK_BOX(hbox), edit_entry, TRUE, TRUE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
}

/*
********************************
** Create the Editor's Window **
********************************
*/
void		create_edit_window(void)
{
  GtkWidget	*window;
  GtkWidget	*table;
  GtkWidget	*vbox;
  
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "Epingle Editor");
  gtk_widget_set_usize(window, 400, 400);
  create_editor_shortcuts(window);
  vbox = gtk_vbox_new(FALSE,0);
  table = gtk_table_new(1, 10, TRUE);
  gtk_widget_show(table);
  gtk_box_pack_start(GTK_BOX(vbox), table, TRUE, TRUE, 2);
  epingle->editor_notebook = gtk_notebook_new();
  gtk_table_attach(GTK_TABLE(table), epingle->editor_notebook, 0, 10, 0, 1,
		   GTK_EXPAND | GTK_FILL | GTK_SHRINK,
		   GTK_EXPAND | GTK_FILL | GTK_SHRINK, 0, 0);
  gtk_widget_show(epingle->editor_notebook);
  create_editor_buttons(vbox);
  edit_info_entry = gtk_entry_new();
  gtk_entry_set_editable(GTK_ENTRY(edit_info_entry), FALSE);
  gtk_widget_show(edit_info_entry);
  gtk_box_pack_start(GTK_BOX(vbox), edit_info_entry, FALSE, FALSE, 3);
  gtk_widget_show(vbox);
  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(window);
}
