/*
** menu.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Tue Dec  1 08:47:51 1998 sebastien thebert
** Last update Tue Apr  4 00:20:16 2000 Sebastien Thebert
*/
#include "main.h"


void win_edit_menu(GtkWidget *menu_item, gint no_cancel);
void add_pop_up(GtkWidget *menu_item);


/*************************************************/
void		add_before(GtkWidget *pop_up_item, GtkWidget *pop_up)
{
  GtkWidget	*m_item;
  GtkWidget	*child;
  GtkWidget	*widget;
  GList		*children;
  GtkMenu	*parent_menu;
  gint		pos = 1;
  
  m_item = gtk_menu_item_new_with_label("New");
  widget = GTK_WIDGET(GTK_MENU(pop_up)->parent_menu_item);
  parent_menu = GTK_MENU(widget->parent); 
  children = GTK_MENU_SHELL(parent_menu)->children;
  while(children)
    {
      child = children->data;
      if (child == GTK_MENU(pop_up)->parent_menu_item)
	break;
      children = children->next; 
      pos++;
    }
  gtk_menu_insert(parent_menu, m_item, pos-1);
  win_edit_menu(m_item, 0);
  add_pop_up(m_item); 
  gtk_widget_show(m_item);
}

/*************************************************/
void		add_after(GtkWidget *pop_up_item, GtkWidget *pop_up)
{
  GtkWidget	*m_item;
  GtkWidget	*child;
  GtkWidget	*widget;
  GList		*children;
  GtkMenu	*parent_menu;
  gint		pos = 1;
  
  m_item = gtk_menu_item_new_with_label("New");
  widget = GTK_WIDGET(GTK_MENU(pop_up)->parent_menu_item);
  parent_menu = GTK_MENU(widget->parent);
  children = GTK_MENU_SHELL(parent_menu)->children;
  while (children)
    {
      child = children->data;
      if (child == GTK_MENU(pop_up)->parent_menu_item)
	break;
      children = children->next; 
      pos++;
    }
  gtk_menu_insert(parent_menu,m_item,pos);
  win_edit_menu(m_item,0);
  add_pop_up(m_item); 
  gtk_widget_show(m_item);
}

/*************************************************/
void	edit_properties(GtkWidget *pop_up_item, GtkWidget *pop_up)
{
  win_edit_menu(GTK_MENU(pop_up)->parent_menu_item, 1);
  gtk_widget_show(GTK_MENU(pop_up)->parent_menu_item);
}

/*************************************************/
void		add_sub_menu(GtkWidget *pop_up_item, GtkWidget *pop_up)
{
  GtkWidget	*m_item;
  GtkMenuItem	*menu_item;
  GtkWidget	*menu;
  
  menu = gtk_menu_new();
  m_item = gtk_menu_item_new_with_label("New");
  gtk_menu_append(GTK_MENU(menu),m_item);
  gtk_widget_show(m_item);
  menu_item = GTK_MENU_ITEM(GTK_MENU(pop_up)->parent_menu_item);
  gtk_menu_item_set_submenu(menu_item,menu);
  win_edit_menu(m_item, 1);
  add_pop_up(m_item);
  gtk_widget_show(m_item);
}

/*************************************************/
void		delete_menu_item(GtkWidget *item_pop_up, GtkWidget *pop_up)
{
  GtkMenu	*parent_menu;
  GtkWidget	*great_parent_menu_item = NULL;
  GtkWidget	*widget;
  GList		*gl;
  gint		need_pop_up = 0;
  
  widget = GTK_WIDGET(GTK_MENU(pop_up)->parent_menu_item);
  parent_menu = GTK_MENU(widget->parent);
  
  gl = GTK_MENU_SHELL(parent_menu)->children;
  if (g_list_length(gl) == 1)
    {
      need_pop_up = 1;
      great_parent_menu_item = parent_menu->parent_menu_item;
    }
  if (great_parent_menu_item != NULL)
    {
      gtk_container_remove(GTK_CONTAINER(parent_menu),
			   GTK_MENU(pop_up)->parent_menu_item);
      /*      gtk_container_need_resize(GTK_CONTAINER(parent_menu));*/
    }
  if (need_pop_up == 1) 
    add_pop_up(great_parent_menu_item);
}

/*************************************************/
void		add_pop_up(GtkWidget *menu_item)
{
  GtkWidget	*pop_up;
  GtkWidget	*m_item;
  
  pop_up = gtk_menu_new();
  m_item = gtk_menu_item_new_with_label("<Add before>");
  gtk_menu_append(GTK_MENU(pop_up),m_item);
  gtk_signal_connect(GTK_OBJECT(m_item),"activate",
		     (GtkSignalFunc) add_before, pop_up);
  gtk_widget_show(m_item);
  m_item = gtk_menu_item_new_with_label("<Add after>");
  gtk_menu_append(GTK_MENU(pop_up),m_item);
  gtk_signal_connect(GTK_OBJECT(m_item),"activate",
		     (GtkSignalFunc) add_after, pop_up);
  gtk_widget_show(m_item);
  m_item = gtk_menu_item_new_with_label("<Edit properties>");
  gtk_menu_append(GTK_MENU(pop_up),m_item);
  gtk_signal_connect(GTK_OBJECT(m_item),"activate",
		     (GtkSignalFunc) edit_properties, pop_up);
  gtk_widget_show(m_item);
  m_item = gtk_menu_item_new_with_label("<Delete>");
  gtk_menu_append(GTK_MENU(pop_up),m_item);
  gtk_signal_connect(GTK_OBJECT(m_item),"activate",
		     (GtkSignalFunc) delete_menu_item, pop_up);
  gtk_widget_show(m_item);
  m_item = gtk_menu_item_new_with_label("<Add submenu>");
  gtk_menu_append(GTK_MENU(pop_up),m_item);
  gtk_signal_connect(GTK_OBJECT(m_item),"activate",
		     (GtkSignalFunc) add_sub_menu, pop_up);
  gtk_widget_show(m_item);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(menu_item), pop_up);
}


/*************************************************/
void		change_menu_title(GtkWidget *entry, GtkWidget *menu_item)
{
  GList		*gl;
  GtkLabel	*label;
  
  gl = gtk_container_children(GTK_CONTAINER(menu_item));
  label = GTK_LABEL(g_list_first(gl)->data);
  gtk_label_set(label, gtk_entry_get_text(GTK_ENTRY(entry)));
}

void	change_menu_function(GtkWidget *widget, GtkWidget *menu_item)
{
  printf("function\n");
}

void	change_menu_shortcut(GtkWidget *widget, GtkWidget *menu_item)
{
  printf("shortcut\n");
}

/*************************************************/
void	bt_ok_menu_edition(GtkWidget *widget)
{
  gtk_widget_destroy(widget->parent->parent->parent);
}

void		bt_cancel_menu_edition(GtkWidget *widget, GtkWidget *menu_item)
{
  GtkMenu	*parent_menu;
  GtkWidget	*great_parent_menu_item = NULL;
  GList		*gl;
  gint		need_pop_up = 0;
  
  
  gtk_widget_destroy(widget->parent->parent->parent);
  parent_menu = GTK_MENU(GTK_WIDGET(menu_item)->parent);
  gl = GTK_MENU_SHELL(parent_menu)->children;
  if (g_list_length(gl) == 1)
    {
      need_pop_up = 1;
      great_parent_menu_item = parent_menu->parent_menu_item;
    }
  if (great_parent_menu_item != NULL)
    {
      gtk_container_remove(GTK_CONTAINER(parent_menu),menu_item);
      /*      gtk_container_need_resize(GTK_CONTAINER(parent_menu));*/
    }
  if (need_pop_up == 1)
    add_pop_up(great_parent_menu_item);
}

void		bt_next_menu_edition(GtkWidget *widget, GtkWidget *menu_item)
{
  GtkWidget	*m_item;
  GtkWidget	*child;
  GList		*children;
  GtkMenu	*parent_menu;
  gint		pos = 1;
  
  gtk_widget_destroy(widget->parent->parent->parent);
  m_item = gtk_menu_item_new_with_label("New");
  parent_menu = GTK_MENU(GTK_WIDGET(menu_item)->parent);
  children = GTK_MENU_SHELL(parent_menu)->children;
  while (children)
    {
      child = children->data;
      if (child == menu_item)
	break;
      children = children->next; 
      pos++;
    }
  gtk_menu_insert(parent_menu,m_item,pos);
  win_edit_menu(m_item,0);
  add_pop_up(m_item); 
  gtk_widget_show(m_item);
}

/*************************************************/
void		win_edit_menu(GtkWidget *menu_item, gint no_cancel)
{ 
  GtkWidget	*win;
  GtkWidget	*box, *box2;
  GtkWidget	*label_title, *label_function, *label_shortcut;
  GtkWidget	*entry_title, *entry_function, *entry_shortcut;
  GtkWidget	*bt_ok, *bt_cancel, *bt_next;
  GtkWidget	*separator;
  GList		*gl;
  GtkLabel	*label;
  
  win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(win), "Edit Menu Properties");
  gtk_container_border_width(GTK_CONTAINER(win), 5);
  box = gtk_vbox_new(FALSE,5);
  
  /* TITLE */
  label_title = gtk_label_new("Title:");
  gtk_misc_set_alignment(GTK_MISC(label_title), 0, 0);
  gtk_box_pack_start(GTK_BOX(box), label_title, FALSE, FALSE, 0);
  gtk_widget_show(label_title);
  entry_title = gtk_entry_new();
  
  gl = gtk_container_children(GTK_CONTAINER(menu_item));
  label = GTK_LABEL(g_list_first(gl)->data);
  gtk_entry_set_text(GTK_ENTRY(entry_title), label->label);
  
  gtk_box_pack_start(GTK_BOX(box), entry_title, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(entry_title), "changed",
		     GTK_SIGNAL_FUNC(change_menu_title), menu_item);
  gtk_widget_show(entry_title);
  separator = gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(box), separator, FALSE, FALSE,0);
  gtk_widget_show(separator);
  /* FUNCTION */
  label_function = gtk_label_new("Function:");
  gtk_misc_set_alignment(GTK_MISC(label_function), 0, 0);
  gtk_box_pack_start(GTK_BOX(box), label_function, FALSE, FALSE, 0);
  gtk_widget_show(label_function);
  entry_function = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(box),entry_function, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(entry_function), "changed",
		     GTK_SIGNAL_FUNC(change_menu_function), menu_item);
  gtk_widget_show(entry_function);
  separator = gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(box), separator, FALSE, FALSE, 0);
  gtk_widget_show(separator);
  /* SHORTCUT */
  label_shortcut = gtk_label_new("Shortcut:");
  gtk_misc_set_alignment(GTK_MISC(label_shortcut), 0, 0);
  gtk_box_pack_start(GTK_BOX(box), label_shortcut, FALSE, FALSE, 0);
  gtk_widget_show(label_shortcut);
  entry_shortcut = gtk_entry_new();
  gtk_box_pack_start(GTK_BOX(box),entry_shortcut,FALSE,FALSE,0);
  gtk_signal_connect(GTK_OBJECT(entry_shortcut),"changed",
		     GTK_SIGNAL_FUNC(change_menu_shortcut),menu_item);
  gtk_widget_show(entry_shortcut);
  separator = gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(box),separator,FALSE,FALSE,0);
  gtk_widget_show(separator);
  
  /* creation des bt Ok, Cancel et Next */
  box2 = gtk_hbox_new(TRUE,10);
  bt_ok = gtk_button_new_with_label("Ok");
  gtk_box_pack_start(GTK_BOX(box2),bt_ok,TRUE,TRUE,0);
  gtk_signal_connect(GTK_OBJECT(bt_ok),"pressed",
		     GTK_SIGNAL_FUNC(bt_ok_menu_edition),win);
  gtk_widget_show(bt_ok);  
  if (no_cancel == 0)
    {
      bt_cancel = gtk_button_new_with_label("Cancel");
      gtk_box_pack_start(GTK_BOX(box2),bt_cancel,TRUE,TRUE,0);
      gtk_signal_connect(GTK_OBJECT(bt_cancel),"pressed",
			 GTK_SIGNAL_FUNC(bt_cancel_menu_edition),menu_item);
      gtk_widget_show(bt_cancel);
    }
  bt_next = gtk_button_new_with_label("Next");
  gtk_box_pack_start(GTK_BOX(box2),bt_next,TRUE,TRUE,0);
  gtk_signal_connect(GTK_OBJECT(bt_next),"pressed",
		     GTK_SIGNAL_FUNC(bt_next_menu_edition),menu_item);
  gtk_widget_show(bt_next);
  gtk_widget_show(box2);
  gtk_box_pack_start(GTK_BOX(box),box2,FALSE,FALSE,0);
  gtk_widget_show(box);
  
  gtk_container_add(GTK_CONTAINER(win),box);
  gtk_widget_show(win); 
}


/*************************************************/
void		create_menu(GtkWidget *fixed)
{
  GtkWidget	*menu_bar, *root_menu, *menu;
  GtkWidget	*vbox;
   
  menu = gtk_menu_new();
  root_menu = gtk_menu_item_new_with_label("File");
  gtk_widget_show(root_menu);
  vbox = gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(fixed), vbox);
  gtk_widget_show(vbox);
  menu_bar = gtk_menu_bar_new();
  gtk_box_pack_start(GTK_BOX(vbox), menu_bar, FALSE, FALSE, 2);
  gtk_widget_show(menu_bar);
  gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu); 
  add_pop_up(root_menu);  
  name_generation(menu_bar, MENU);
  hierarchy_add(menu_bar);
}






