/*
** name_generation.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Mon Mar 15 12:09:00 1999 sebastien thebert
** Last update Sat Apr  1 19:35:11 2000 Sebastien Thebert
*/
#define	NAME_WIDGET

#include "main.h"

/*
** set the type for the widget's name
*/
char		*set_type_widget_name(int type)
{
  t_name_widget	*wdgt_name;
  int		wdgt_not_find;
  char		*type_name;
  
  type_name = xmalloc(sizeof (char) * LENGTH);
  wdgt_name = &name_widget_array[0];
  wdgt_not_find = 1;
  while ((wdgt_name) && (wdgt_not_find))
    {
      if (wdgt_name->widget == type)
	{
	  strcpy(type_name, wdgt_name->name);
	  wdgt_not_find = 0;
	}
      wdgt_name++;
    }
  return (type_name);
}

/*
** set the number for the widget's name
*/
void	set_widget_number(char *new_name, char *type_name)
{
  int	i;
  int	end;
  char	*str;
  
  i = 1;
  end = 0;
  while (!end)
    {
      strcpy(new_name, type_name);
      str = int_to_str(i);
      strcat(new_name, str);
      free(str);
      end = !(hierarchy_find_by_name(new_name));
      i++;
    }
}

/*
** set widget's label with the creation name
*/
void		set_widget_label(GtkWidget *widget, int type, char *new_name)
{
  GtkWidget	*bt_label;
  
  switch (type)
    {
    case WINDOW:
      gtk_window_set_title(GTK_WINDOW(widget), new_name);
      break;  
    case BUTTON:
    case TOGGLE_BUTTON:
    case CHECK_BUTTON:
    case RADIO_BUTTON:
      bt_label = GTK_WIDGET(g_list_first(gtk_container_children
					 (GTK_CONTAINER(widget)))->data);
      gtk_label_set(GTK_LABEL(bt_label), new_name);
      break;
    }
}

/*
** Generate name for each widget created
*/
void		name_generation(GtkWidget *widget, int type)
{
  char		*new_name;
  char		*type_name;
  
  type_name = set_type_widget_name(type);
  new_name = xmalloc(sizeof (char) * (strlen(type_name) + 3));
  set_widget_number(new_name, type_name);
  gtk_widget_set_name(widget, new_name);
  set_widget_label(widget, type, new_name);
  free(new_name);
  free(type_name);
}





