/*
** option_menu.c
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Tue Jun  8 22:18:00 1999 Maxime VERNIER
** Last update Sat Apr  1 02:51:05 2000 Sebastien Thebert
*/
#include "main.h"
#include "restore.h"
#include "list_manager.h"

void		GtkOptionMenu_properties(GtkWidget *widget)
{
  GtkWidget	*notebook;
  GtkWidget	*label;
  GtkWidget	*frame;
  
  g_return_if_fail(GTK_IS_OPTION_MENU(widget));
  notebook = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				 "notebook");
  frame = list_manager_new();
  gtk_widget_show(frame); 
  label = gtk_label_new("Items");
  gtk_notebook_insert_page(GTK_NOTEBOOK(notebook),frame,label,1);
}

void		GtkOptionMenu_save(FILE *fp, int tab, GtkWidget *widget)
{
  GtkWidget	*menu;
  gint		i;
  GList		*children;
  GList		*node;
  
  for(i = 1; i <= tab; i++)
    fprintf(fp, "\t");
  menu = gtk_option_menu_get_menu(GTK_OPTION_MENU(widget));
  children = GTK_MENU_SHELL(menu)->children;
  fprintf(fp, "<NB_ITEMS>\t%d\n", g_list_length(children));
  for(node = children; node; node = node->next) 
    {
      GtkWidget	*label_widget;
      gchar	*label;
      
      for(i = 1; i <= tab; i++)
	fprintf(fp, "\t");
      label_widget = g_list_first(gtk_container_children
				  (GTK_CONTAINER(node->data)))->data;
      gtk_label_get(GTK_LABEL(label_widget),&label);
      fprintf(fp, "<ITEM>\t\t%s\n", label);
    }
}
