/** properties.c
 ** 
 ** Made by (Maxime VERNIER)
 ** Login   <vernie_m@epita.fr>
 ** 
 ** Started on  Tue Jan 26 14:09:37 1999 Maxime VERNIER
** Last update Tue Apr  4 23:55:35 2000 Sebastien Thebert
quit */
#include "main.h"

void		init_properties(gint properties_nb)
{
  GtkWidget	*widget;
  GtkWidget	*table;
  GtkWidget     *notebook;
  GtkWidget     *label;
  gchar		title[TEXT_LENGTH];
  gchar		*window_title = title;
  gchar		*widget_name;
  gint		i;
  
  if (!epingle->win_properties)
    {
      epingle->win_properties = gtk_window_new(GTK_WINDOW_TOPLEVEL);
      table = gtk_table_new(2, 2, FALSE);
      gtk_container_add (GTK_CONTAINER(epingle->win_properties), table);
      notebook = gtk_notebook_new();
      gtk_table_attach_defaults(GTK_TABLE(table), notebook, 0, 2, 0, 1);
      gtk_object_set_data(GTK_OBJECT(epingle->win_properties),
			  "notebook", notebook);
      gtk_widget_show(notebook);
      gtk_widget_show(table);
    }
  else
    {
      notebook = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				     "notebook"); 
      for(i = 0; i < g_list_length(gtk_container_children
				   (GTK_CONTAINER(notebook))); )
	gtk_notebook_remove_page(GTK_NOTEBOOK(notebook),i);
    }
  notebook = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				 "notebook"); 
  table = gtk_table_new(properties_nb, 2, FALSE);
  gtk_table_set_col_spacing(GTK_TABLE(table), 0, 10);
  gtk_object_set_data(GTK_OBJECT(epingle->win_properties),
		      "properties", table);
  gtk_widget_show(table);
  label = gtk_label_new("Widget");
  gtk_notebook_append_page (GTK_NOTEBOOK (notebook), table, label);
  widget = get_current_widget();
  widget_name = gtk_widget_get_name(widget); 
  sprintf(window_title, "%s properties", widget_name);
  gtk_window_set_title(GTK_WINDOW(epingle->win_properties), window_title);
}

GtkWidget	*AddPropertyLabel(GtkWidget *table, gint row,
				  gchar *label, gchar *tip)
{
  GtkWidget	*event_box;
  GtkWidget	*label_widget;
  GtkTooltips	*tooltips;
  
  event_box = gtk_event_box_new();
  label_widget = gtk_label_new(label);
  gtk_container_add(GTK_CONTAINER(event_box), label_widget);
  gtk_widget_show(label_widget);
  tooltips = gtk_tooltips_new();
  gtk_tooltips_set_tip(tooltips, event_box,
		       tip, NULL);
  gtk_table_attach(GTK_TABLE(table),
		   event_box, 0, 1, row-1, row, 
		   GTK_SHRINK|GTK_FILL|GTK_EXPAND, GTK_SHRINK|GTK_FILL, 0, 0);
  gtk_widget_show(event_box);
  return label_widget;
}

void		x_changed(GtkWidget *widget)
{
  GtkWidget	*entry;
  
  entry = gtk_object_get_data(GTK_OBJECT(epingle->win_properties), "X");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(entry), widget->allocation.x);
}

void		y_changed(GtkWidget *widget)
{
  GtkWidget	*entry;
  
  entry = gtk_object_get_data(GTK_OBJECT(epingle->win_properties), "Y");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(entry), widget->allocation.y);
}

void		height_changed(GtkWidget *widget)
{
  GtkWidget	*entry;
  
  entry = gtk_object_get_data(GTK_OBJECT(epingle->win_properties), "HEIGHT");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(entry), widget->allocation.height);
}

void		width_changed(GtkWidget *widget)
{
  GtkWidget	*entry;
  
  entry = gtk_object_get_data(GTK_OBJECT(epingle->win_properties), "WIDTH");
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(entry), widget->allocation.width);
}

GtkWidget	*AddEntryProperty(GtkWidget *table, gint row)
{
  GtkWidget	*entry;
  
  entry = gtk_entry_new();
  gtk_table_attach(GTK_TABLE(table), 
		   entry, 1, 2, row-1, row,
		   GTK_SHRINK|GTK_FILL|GTK_EXPAND, GTK_SHRINK|GTK_FILL, 0, 0);
  gtk_widget_show(entry); 
  return entry;
}

GtkWidget	*AddSpinProperty(GtkWidget *table, gint row,
				 gfloat value, gfloat lower, gfloat upper,
				 gfloat step_increment, gfloat page_increment,
				 gfloat page_size)
{
  GtkWidget	*entry;
  
  entry = NewSpinButton(value, lower, upper, step_increment,
			page_increment, page_size);
  gtk_table_attach(GTK_TABLE(table), entry, 1, 2, row-1, row,
  		   GTK_SHRINK|GTK_FILL|GTK_EXPAND, GTK_SHRINK|GTK_FILL, 0, 0);
  return entry;
}


GtkWidget	*AddToggleProperty(GtkWidget *table, gint row,
				   gboolean state, gchar *label)
{
  GtkWidget	*button;
  
  button = gtk_toggle_button_new_with_label(label);
  gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), state);
  gtk_table_attach(GTK_TABLE(table), button, 1, 2, row-1, row,
		   GTK_SHRINK|GTK_FILL|GTK_EXPAND, GTK_SHRINK|GTK_FILL, 0, 0);
  gtk_widget_show(button);
  return button;
}

GtkWidget	*AddComboProperty(GtkWidget *table, gint row, GList *list)
{
  GtkWidget	*combo;
  
  combo = gtk_combo_new();
  gtk_combo_set_popdown_strings(GTK_COMBO(combo), list);
  gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(combo)->entry), FALSE);
  gtk_table_attach(GTK_TABLE(table), combo, 1, 2, row-1, row,
		   GTK_SHRINK|GTK_FILL|GTK_EXPAND, GTK_SHRINK|GTK_FILL, 0, 0);
  gtk_widget_show(combo);
  return combo;
}

void		edit_properties_of_widget(GtkWidget *widget)
{
  gint		type;
  GtkWidget	*table;
  
  set_current_widget(widget);
  init_properties(10);
  add_common_widget_properties();
  type = get_widget_type(widget);
  switch(type)
    {
    case CLIST:
      init_events(NB_WIDGET_PROP + 3);
      GtkCList_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      GtkCList_events(table, widget);
      break;
    case DIALOG:
      AddWindowProperties(widget);
      break;
    case OPTION_MENU:
      GtkOptionMenu_properties(widget);
      break;
    case COMBO:
      GtkCombo_properties(widget);
      break;
    case LABEL:
      GtkLabel_properties(widget);
      break;
    case FRAME:
      GtkFrame_properties(widget);
      break;
    case COLOR_SELECTION_DIALOG:
      init_events(2);
      GtkColorSelectionDialog_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      GtkColorSelectionDialog_events(table, widget);
      break;
    case FONT_SELECTION_DIALOG:
      init_events(2);
      FontSelectionDialog_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      add_window_events(table, widget);
      break;
    case FILE_SELECTOR: 
      init_events(2);
      GtkFileSelection_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      GtkColorSelectionDialog_events(table, widget);
      break;
    case WINDOW:
      init_events(2);
      GtkWindow_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      add_window_events(table, widget);
      break;
    case BUTTON:
      init_events(5);
      GtkButton_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      add_button_events(table, widget);
      break;
    case TOGGLE_BUTTON:
      init_events(6);
      GtkToggleButton_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      add_toggle_button_events(table, widget);
      break;
    case CHECK_BUTTON:
      init_events(6);
      GtkCheckButton_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      add_toggle_button_events(table, widget);
      break;  
    case DRAWING_AREA:
      GtkDrawingArea_properties(widget, NB_WIDGET_PROP + 1);
      break;
    case NOTEBOOK:
      init_events(1);
      GtkNotebook_properties(NB_WIDGET_PROP + 1, widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      GtkNotebook_events(table, widget);
      break;
    case PROGRESS_BAR:
      GtkProgressBar_properties(NB_WIDGET_PROP + 1, widget);
      break;
    case ENTRY:
      init_events(5);
      GtkEntry_properties(6, widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      add_entry_events(table, widget);
      break;
    case TEXT:
      init_events(NB_EDIT_EV);
      GtkText_properties(widget);
      table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
				  "events");
      /*      GtkText_events(table, widget);*/
      break;
    case TOOLBAR:
      GtkToolbar_properties(widget);
      break;
    }
  gtk_widget_show(epingle->win_properties); 
  if(type == DRAWING_AREA)
    {
      GdkColor	*color;
      GtkWidget *drawing_area;
      
      drawing_area = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
					 "drawing_area");
      color = gtk_object_get_data(GTK_OBJECT(widget), "color");
      gdk_window_set_background(drawing_area->window, color); 
      gtk_widget_show(drawing_area);
    } 
  refresh_widget_code(widget);
}

void	change_gtk_position_type(GtkWidget *entry, GtkWidget *widget)
{
  gint	position, type;
  gchar	*text;
 
  text = gtk_entry_get_text(GTK_ENTRY(entry));
  position = GTK_POS_TOP;
  if (!strcmp(text, "left"))
    position = GTK_POS_LEFT;
  else
    if (!strcmp(text, "right"))
      position = GTK_POS_RIGHT;
    else
      if (!strcmp(text, "bottom"))
	position = GTK_POS_BOTTOM;
  type = get_widget_type(widget);
  switch(type)
    {
    case NOTEBOOK:
      gtk_notebook_set_tab_pos(GTK_NOTEBOOK(widget), position);
      break;
    }
}

void	move_properties(GtkWidget *widget)
{
  x_changed(widget);
  y_changed(widget);
}

void	resize_properties(GtkWidget *widget)
{
  width_changed(widget);
  height_changed(widget);
}

void	change_properties(GtkWidget *widget)
{
  move_properties(widget);
  resize_properties(widget);
}
