/*
** put_buttons.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Fri Jan 21 01:06:00 2000 Sebastien Thebert
** Last update Wed Mar 22 18:14:59 2000 Sebastien Thebert
*/

#include "main.h"

extern GtkRadioButton	*last_radio_button;

/*
** Put Button widget in a container
*/
void		put_button(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*bt;
  
  bt = create_button(fixed, event->x, event->y, WIDTH, HEIGHT, "Button");
  name_generation(bt, BUTTON);
  hierarchy_add(bt);
  edit_properties_of_widget(bt);
  create_button_code(gtk_widget_get_name(get_win_parent(bt)), bt, BUTTON);
}

/*
** Put ToggleButton widget in a container
*/
void		put_toggle_button(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*toggle_bt;
  
  toggle_bt = create_toggle_button(fixed, event->x, event->y,
				   WIDTH, HEIGHT, "Toggle", TRUE);
  name_generation(toggle_bt, TOGGLE_BUTTON);
  hierarchy_add(toggle_bt);
  edit_properties_of_widget(toggle_bt);
  create_button_code(gtk_widget_get_name(get_win_parent(toggle_bt)),
		     toggle_bt, TOGGLE_BUTTON);  
}

/*
** Put CheckButton widget in a container
*/
void		put_check_button(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*check_bt;
  
  check_bt = create_check_button(fixed, event->x, event->y,
				 WIDTH, HEIGHT, "Check", TRUE);
  name_generation(check_bt, CHECK_BUTTON);
  hierarchy_add(check_bt);
  edit_properties_of_widget(check_bt);
  create_button_code(gtk_widget_get_name(get_win_parent(check_bt)),
		     check_bt, CHECK_BUTTON);
}

/*
** Put RadioButton widget in a container
*/
void		put_radio_button(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*radio_bt;
  
  radio_bt = create_radio_button(fixed, event->x, event->y, WIDTH, HEIGHT,
				 "Radio", TRUE, last_radio_button);
  last_radio_button = GTK_RADIO_BUTTON(radio_bt);
  name_generation(radio_bt, RADIO_BUTTON);
  hierarchy_add(radio_bt);
  edit_properties_of_widget(radio_bt);
  /*  create_button_code(gtk_widget_get_name(get_win_parent(radio_bt)),*/
  /*		     radio_bt, RADIO_BUTTON);  */
}
