/*
** put_containers.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Fri Jan 21 15:15:57 2000 Sebastien Thebert
** Last update Mon Apr  3 23:31:50 2000 Sebastien Thebert
*/
#include "main.h"

/*
** Put Frame widget in a container
*/
void		put_frame(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*frame;
  
  frame = create_frame(fixed, event->x, event->y, 120, 80, "Frame");
  name_generation(frame, FRAME);
  hierarchy_add(frame);
  edit_properties_of_widget(frame);
  create_frame_code(gtk_widget_get_name(get_win_parent(frame)), frame);
}

/*
** Put Notebook widget in a container
*/
void		put_notebook(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*nb;
  
  nb = create_notebook(fixed, event->x, event->y, 100, 80);
  name_generation(nb, NOTEBOOK);
  hierarchy_add(nb);
  edit_properties_of_widget(nb);
  create_notebook_code(gtk_widget_get_name(get_win_parent(nb)), nb);
}

/*
** Put Table widget in a container
*/
void		put_table(GtkWidget *fixed, GdkEventButton *event)
{
  static int	x1 = -1;
  static int	y1 = -1;
  
  if ((x1 == -1) && (y1 == -1))
    {
      x1 = event->x;
      y1 = event->y;
    }
  else 
    {
      window_table(fixed, x1, y1, event->x, event->y);
      x1 = -1;
      y1 = -1;
    }
}
