/*
** put_gfx.c
** 
** Made by (Sebastien Thebert)
** Login   <king@epita.fr>
** 
** Started on  Fri Jan 21 14:53:48 2000 Sebastien Thebert
** Last update Sat Apr  1 19:33:38 2000 Sebastien Thebert
*/
#include "main.h"

struct pixmap_set
{
  GtkWidget	*fixed;
  GdkEventButton *event;
  GtkWidget	*filesel;
};

/*
** Put DrawingArea widget in a container
*/
void		put_drawing_area(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*drawing_area;
  GdkColor	*cl;
  
  cl = xmalloc(sizeof (*cl));
  cl->red = 65535;
  cl->green = 65535;
  cl->blue = 65535; 
  drawing_area =
    create_drawing_area(fixed, event->x, event->y, WIDTH, HEIGHT, cl);
  name_generation(drawing_area, DRAWING_AREA);
  hierarchy_add(drawing_area);
  edit_properties_of_widget(drawing_area);
  create_drawing_area_code(gtk_widget_get_name(get_win_parent(drawing_area)),
			   drawing_area); 
}

/*
** FileSelector for pixmap
*/
void		file_ok_select(GtkWidget *sender, struct pixmap_set *pix_set)
{
  char		*filename;
  GtkWidget	*pixmap;
  
  filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION
					     (pix_set->filesel));
  pixmap = create_pixmap(pix_set->fixed, pix_set->event->x, pix_set->event->y,
			 WIDTH, HEIGHT, filename);
  gtk_widget_destroy(pix_set->filesel);
  if (pixmap != NULL)
    {
      name_generation(pixmap, PIXMAP);
      hierarchy_add(pixmap);
      edit_properties_of_widget(pixmap);
      create_pixmap_code(gtk_widget_get_name(get_win_parent(pixmap)),
			 pixmap, filename); 
    }
}

/*
** Put Pixmap widget in a container
*/
void			put_pixmap(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget		*file_select;
  struct pixmap_set	*pix_set;
  
  pix_set = xmalloc(sizeof (struct pixmap_set));
  file_select = gtk_file_selection_new("Open Pixmap");
  /*  gtk_file_selection_complete(GTK_FILE_SELECTION(file_select),
      epingle->project_path);*/
  gtk_widget_show(file_select);
  pix_set->fixed = fixed;
  pix_set->event = event;
  pix_set->filesel = file_select;
  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(file_select)->ok_button),
		     "clicked", (GtkSignalFunc) file_ok_select, pix_set);
  gtk_signal_connect(GTK_OBJECT(file_select), "destroy",
		     (GtkSignalFunc) gtk_widget_destroy,
		     GTK_OBJECT(file_select));
  gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION
				       (file_select)->cancel_button),
			    "clicked", (GtkSignalFunc) gtk_widget_destroy,
			    GTK_OBJECT(file_select));
}



