/*
** put_texts.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Fri Jan 21 01:12:48 2000 Sebastien Thebert
** Last update Mon Apr  3 21:58:44 2000 Sebastien Thebert
*/
#include "main.h"

/*
** Put Label widget in a container
*/
void		put_label(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*label;
  
  label = create_label(fixed, event->x, event->y, WIDTH, HEIGHT, "Label");
  name_generation(label, LABEL);
  hierarchy_add(label);
  edit_properties_of_widget(label);
  create_label_code(gtk_widget_get_name(get_win_parent(label)), label);
}

/*
** Put Entry widget in a container
*/
void		put_entry(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*entry;
  
  entry = create_entry(fixed, event->x, event->y,
		       WIDTH, HEIGHT, "", 100, TRUE, TRUE);
  name_generation(entry, ENTRY);
  hierarchy_add(entry);
  edit_properties_of_widget(entry);
  create_entry_code(gtk_widget_get_name(get_win_parent(entry)), entry);
}

/*
** Put SpinButton widget in a container
*/
void		put_spin_button(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*spin_button;
  GtkAdjustment *adj;
  
  adj = (GtkAdjustment *)
    gtk_adjustment_new(1.0, 0.0, 100.0, 1.0, 5.0, 0.0);
  spin_button =
    create_spin_button(fixed, event->x, event->y, WIDTH, HEIGHT, adj);
  name_generation(spin_button, SPIN_BUTTON);
  hierarchy_add(spin_button);
  /*  edit_properties_of_widget(spin_button);*/
  /*  create_spin_button_code(gtk_widget_get_name*/
  /*			  (get_win_parent(spin_button)), spin_button);*/
}

/*
** Put ComboBox widget in a container
*/
void		put_combo(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*combo;
  
  combo = create_combo(fixed, event->x, event->y, WIDTH, HEIGHT, NULL);
  name_generation(combo, COMBO);
  hierarchy_add(combo);
  edit_properties_of_widget(combo);
  create_combo_box_code(gtk_widget_get_name(get_win_parent(combo)), combo);
}

/*
** Put Text widget in a container
*/
void		put_text(GtkWidget *fixed, GdkEventButton *event)
{
  GtkWidget	*text;
  
  text = create_text(fixed, event->x, event->y, WIDTH, HEIGHT, TRUE);
  name_generation(text, TEXT);
  hierarchy_add(text);
  edit_properties_of_widget(text);
  create_gtktext_code(gtk_widget_get_name(get_win_parent(text)), text); 
}



