/*
** put_widget.h
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Sat Feb 13 17:02:55 1999 sebastien thebert
** Last update Sun Apr  2 18:10:14 2000 Sebastien Thebert
*/
#ifndef   __PUT_WIDGET_H__
#define   __PUT_WIDGET_H__

/*
** put_windows.c
*/
void	put_window(GtkWidget *sender);
void	put_file_select(GtkWidget *sender);
void	put_color_select(GtkWidget *sender);
void	put_font_select(GtkWidget *sender);
void	put_dialog(GtkWidget *sender);   

/*
** put_buttons.c
*/
void	put_button(GtkWidget *fixed, GdkEventButton *event);
void	put_toggle_button(GtkWidget *fixed, GdkEventButton *event);
void	put_check_button(GtkWidget *fixed, GdkEventButton *event);
void	put_radio_button(GtkWidget *fixed, GdkEventButton *event);

/*
** put_texts.c
*/
void	put_label(GtkWidget *fixed, GdkEventButton *event);
void	put_entry(GtkWidget *fixed, GdkEventButton *event);
void	put_spin_button(GtkWidget *fixed, GdkEventButton *event);
void	put_combo(GtkWidget *fixed, GdkEventButton *event);
void	put_text(GtkWidget *fixed, GdkEventButton *event);

/*
** put_gfx.c
*/
void	put_drawing_area(GtkWidget *fixed, GdkEventButton *event);
void	put_pixmap(GtkWidget *fixed, GdkEventButton *event);

/*
** put_containers.c
*/
void	put_frame(GtkWidget *fixed, GdkEventButton *event);
void	put_notebook(GtkWidget *fixed, GdkEventButton *event);
void	put_table(GtkWidget *fixed, GdkEventButton *event);

/*
** put_others.c
*/
void	put_menu(GtkWidget *fixed, GdkEventButton *event);
void    put_option_menu(GtkWidget *fixed, GdkEventButton *event);
void	put_progress_bar(GtkWidget *fixed, GdkEventButton *event);
void	put_status_bar(GtkWidget *fixed, GdkEventButton *event);
void	put_toolbar(GtkWidget *fixed, GdkEventButton *event);
void	put_clist(GtkWidget *fixed, GdkEventButton *event);
void	put_tree(GtkWidget *fixed, GdkEventButton *event);

GtkWidget	*create_clist_popup(GtkWidget *clist);
void		action_on_window(GtkWidget *fixed, GdkEventButton *event);

typedef struct	s_put_fct
{
  char		widget;
  void		(*function)(GtkWidget *fixed, GdkEventButton *event);
  char		*msg;
}		t_put_fct;

#ifdef  PUT_FUNCTION
t_put_fct	put_fct_array[20] =
{ { BUTTON, put_button,
    "Click to put a button in a container" },
  { TOGGLE_BUTTON, put_toggle_button,
    "Click to put a toggle button in a container" },
  { CHECK_BUTTON, put_check_button,
    "Click to put a check button in a container" },
  { RADIO_BUTTON, put_radio_button,
    "Click to put a radio button in a container" },
  { LABEL, put_label,
    "Click to put a label in a container" },
  { ENTRY, put_entry,
    "Click to put an entry in a container" },
  { SPIN_BUTTON, put_spin_button,
    "Click to put a spin button in a container" },
  { COMBO, put_combo,
    "Click to put a combo in a container" },
  { TEXT, put_text,
    "Click to put a text in a container" },
  { DRAWING_AREA, put_drawing_area,
    "Click to put a drawing area in a container" },
  { PIXMAP, put_pixmap,
    "Click to put a pixmap in a container"},
  { FRAME, put_frame,
    "Click to put a frame in a container" },
  { NOTEBOOK, put_notebook,
    "Click to put a notebook in a container" },
  { TABLE, put_table,
    "1st click -> top left corner / 2nd click -> bottom right corner" },
  { MENU, put_menu,
    "Click to put a menu in a container" },
  { OPTION_MENU, put_option_menu,
    "Click to put an option menu in a container" },
  { PROGRESS_BAR, put_progress_bar,
    "Click to put a progress bar in a container" },
  { STATUSBAR, put_status_bar,
    "Click to put a status bar in a container" },
  { TOOLBAR, put_toolbar,
    "Click to put a toolbar in a container" },
  { CLIST, put_clist,
    "Click to put a clist in a container" } };
#else
extern t_put_fct	put_fct_array[];
#endif

#endif /* __PUT_WIDGET_H__ */
