/*
** put_windows.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Fri Jan 21 00:58:36 2000 Sebastien Thebert
** Last update Sat Apr  1 18:27:15 2000 Sebastien Thebert
*/
#include "main.h"

/*
** Put Window widget
*/
void		put_window(GtkWidget *sender)
{
  GtkWidget	*win;
  
  win = create_window("Window", 200, 200, GTK_WINDOW_TOPLEVEL,
		      GTK_WIN_POS_NONE);
  name_generation(win, WINDOW);
  hierarchy_add(win);
  edit_properties_of_widget(win);
  create_window_file_code(win);
}

/*
** Put FileSelector widget
*/
void		put_file_select(GtkWidget *sender)
{
  GtkWidget	*file_select;
  
  file_select = create_file_selection("Open File", "", TRUE);
  name_generation(file_select, FILE_SELECTOR);
  hierarchy_add(file_select);
  edit_properties_of_widget(file_select);
  create_file_selector_code(file_select);
}

/*
** Put ColorSelector widget
*/
void		put_color_select(GtkWidget *sender)
{
  GtkWidget	*color_select;
  
  color_select = create_color_selection("Color Selection",
					GTK_UPDATE_CONTINUOUS);
  name_generation(color_select, COLOR_SELECTION_DIALOG);
  hierarchy_add(color_select);
  edit_properties_of_widget(color_select);
  create_color_selector_code(color_select);
}

/*
** Put FontSelector widget
*/
void		put_font_select(GtkWidget *sender)
{
  GtkWidget	*font_select;
  
  font_select = create_font_selection("Font Selection");
  name_generation(font_select, FONT_SELECTION_DIALOG);
  hierarchy_add(font_select);
  edit_properties_of_widget(font_select);
  create_font_selector_code(font_select);
}

/***********************************************************/
static void cb_dialog_bt_click(GtkWidget *sender, gpointer data)
{
  edit_properties_of_widget(sender);
}

void		put_dialog(GtkWidget *sender)
{
  GtkWidget	*dialog;
  GtkWidget	*bt, *label;
  
  dialog = gtk_dialog_new();
  gtk_widget_show(dialog);
  bt = gtk_button_new_with_label("Ok");
  gtk_signal_connect(GTK_OBJECT(bt), "button_press_event", 
		     GTK_SIGNAL_FUNC(cb_dialog_bt_click), NULL);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		     bt, TRUE, TRUE, 0);
  gtk_widget_show(bt);
  
  label = gtk_label_new("Message");
  gtk_signal_connect(GTK_OBJECT(label), "button_press_event", 
		     GTK_SIGNAL_FUNC(cb_dialog_bt_click), NULL);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),
		     label, TRUE, TRUE, 0);
  gtk_widget_show(label);
  name_generation(dialog, DIALOG);
  hierarchy_add(dialog);
  edit_properties_of_widget(dialog);
  /*  create_dialog_code(dialog);*/
}
