/*
** resize_widget.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Tue Feb 16 21:02:41 1999 sebastien thebert
** Last update Sat Apr  1 18:13:40 2000 Sebastien Thebert
*/
#include "main.h"

/*
** Resize Widget from up edge
*/
void	resize_widget_up(GtkWidget *fixed, int y)
{
  if (((epingle->widget_clicked->allocation.y - y)
       + epingle->widget_clicked->allocation.height) > 20)
    {
      gtk_fixed_move(GTK_FIXED(fixed), epingle->widget_clicked,
		     epingle->widget_clicked->allocation.x, y);
      gtk_widget_set_usize(epingle->widget_clicked,
			   epingle->widget_clicked->allocation.width,
			   (epingle->widget_clicked->allocation.y - y)
			   + epingle->widget_clicked->allocation.height);
    } 
}

/*
** Resize Widget from down edge
*/
void	resize_widget_down(GtkWidget *fixed, int y)
{
  if ((y - epingle->widget_clicked->allocation.y) > 20)
    {
      gtk_widget_set_usize(epingle->widget_clicked,
			   epingle->widget_clicked->allocation.width,
			   y-epingle->widget_clicked->allocation.y);
    }
}

/*
** Resize Widget from left edge
*/
void	resize_widget_left(GtkWidget *fixed, int x)
{
  if (((epingle->widget_clicked->allocation.x - x)
       + epingle->widget_clicked->allocation.width) > 20)
    {
      gtk_fixed_move(GTK_FIXED(fixed), epingle->widget_clicked,
		     x, epingle->widget_clicked->allocation.y);
      gtk_widget_set_usize(epingle->widget_clicked,
			   (epingle->widget_clicked->allocation.x - x)
			   + epingle->widget_clicked->allocation.width,
			   epingle->widget_clicked->allocation.height);
    } 
}

/*
** Resize Widget from left-up corner
*/
void	resize_widget_leftup(GtkWidget *fixed, int x, int y)
{
  if ((((epingle->widget_clicked->allocation.x - x)
	+ epingle->widget_clicked->allocation.width) > 20)
      && (((epingle->widget_clicked->allocation.y - y)
	   + epingle->widget_clicked->allocation.height) > 20))
    {
      gtk_fixed_move(GTK_FIXED(fixed), epingle->widget_clicked, x, y);
      gtk_widget_set_usize(epingle->widget_clicked,
			   (epingle->widget_clicked->allocation.x - x)
			   + epingle->widget_clicked->allocation.width,
			   (epingle->widget_clicked->allocation.y - y)
			   + epingle->widget_clicked->allocation.height);
    }
}

/*
** Resize Widget from left-down corner
*/
void	resize_widget_leftdown(GtkWidget *fixed, int x, int y)
{
  if ((((epingle->widget_clicked->allocation.x - x)
	+ epingle->widget_clicked->allocation.width) > 20) &&
      ((y - epingle->widget_clicked->allocation.y) > 20))
    {
      gtk_fixed_move(GTK_FIXED(fixed), epingle->widget_clicked, x,
		     epingle->widget_clicked->allocation.y);
      gtk_widget_set_usize(epingle->widget_clicked,
			   (epingle->widget_clicked->allocation.x - x)
			   + epingle->widget_clicked->allocation.width,
			   y - epingle->widget_clicked->allocation.y);
    }
}

/*
** Resize Widget from right edge
*/
void	resize_widget_right(GtkWidget *fixed, int x)
{
  if ((x - epingle->widget_clicked->allocation.x) > 20)
    gtk_widget_set_usize(epingle->widget_clicked,
			 x - epingle->widget_clicked->allocation.x,
			 epingle->widget_clicked->allocation.height);
}

/*
** Resize Widget from right-up corner
*/
void	resize_widget_rightup(GtkWidget *fixed, int x, int y)
{
  if (((x - epingle->widget_clicked->allocation.x) > 20)
      && (((epingle->widget_clicked->allocation.y - y)
	   + epingle->widget_clicked->allocation.height) > 20))
    {
      gtk_fixed_move(GTK_FIXED(fixed), epingle->widget_clicked,
		     epingle->widget_clicked->allocation.x, y);
      gtk_widget_set_usize(epingle->widget_clicked,
			   x - epingle->widget_clicked->allocation.x,
			   (epingle->widget_clicked->allocation.y - y)
			   + epingle->widget_clicked->allocation.height);
    }
}

/*
** Resize Widget from right-down corner
*/
void	resize_widget_rightdown(GtkWidget *fixed, int x, int y)
{
  if (((x - epingle->widget_clicked->allocation.x) > 20) &&
      ((y - epingle->widget_clicked->allocation.y) > 20))
    gtk_widget_set_usize(epingle->widget_clicked,
			 x - epingle->widget_clicked->allocation.x,
			 y - epingle->widget_clicked->allocation.y);
}

/*
** Resize Widget
*/
void	resize_widget(GtkWidget *fixed, int x, int y)
{
  switch (epingle->widget_resizing)
    {
    case UP :		resize_widget_up(fixed, y);
      break;
    case DOWN :		resize_widget_down(fixed, y);
      break;
    case LEFT :		resize_widget_left(fixed, x);
      break;
    case LEFTUP :	resize_widget_leftup(fixed, x, y);
      break;
    case LEFTDOWN :	resize_widget_leftdown(fixed, x, y);
      break;
    case RIGHT :	resize_widget_right(fixed, x);
      break;
    case RIGHTUP :	resize_widget_rightup(fixed, x, y);
      break;
    case RIGHTDOWN :	resize_widget_rightdown(fixed, x, y);
      break;
    }
  change_properties(epingle->widget_clicked);
}



