/*  EPIngle - Gtk+ User Interface Builder
 *  Copyright (C) 1999  Maxime Vernier
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "main.h"

text_property	*get_property(FILE *fp, int nb_tab)
{
  gchar		*line;
  gchar		*temp;
  gchar		*ptr;
  text_property *property;
  
  line = xmalloc(TEXT_LENGTH * sizeof (*line));
  temp = xmalloc(TEXT_LENGTH * sizeof (*temp));
  property = xmalloc(sizeof (*property));
  property->text = xmalloc(TEXT_LENGTH * sizeof (*property->text));
  property->name = xmalloc(TEXT_LENGTH * sizeof (*property->name));
  fgets(line, 10 * TEXT_LENGTH, fp); 
  strcpy(temp, line);
  if (strcpy(property->name, strtok(temp, "<>")) && (*property->name != '/'))
    { 
      strcpy(line, strrchr(line, '\t') + 1);
      if (strchr(line, ' '))
	{
	  strcpy(temp, strchr(line, ' '));
	  ptr = temp;
	  while (*++ptr == ' ');
	  while (strchr(ptr,' '))
	    {
	      strcpy(ptr, strchr(ptr, ' '));
	      while(*ptr++ == ' ');
	      strcat(line, " ");
	      strcat(line, ptr);
	    }
	}
      if (strchr(line, '\n'))
	*strchr(line, '\n') = '\0';
      strcpy(property->text,line);
    }
  else 
    {
      free(property->name); 	 
      property->name = NULL;
      free(property->text);
      property->text = NULL;
    }
  free(temp);
  free(line);
  return (property);
}

gchar		*get_text_property(FILE *fp, gint nb_tab)
{
  text_property	*property;
  gchar		*result;
  
  property = get_property(fp, nb_tab);
  result = xmalloc(10 * TEXT_LENGTH * sizeof (*result));
  strcpy(result,property->text);
  free(property);
  return (result);
}

gint	get_num_property(FILE *fp, int tab, gboolean twice)
{
  gint	i, result;
  
  for(i = 1; i <= tab; i++)
    fscanf(fp, "\t");
  if (twice)
    fscanf(fp, "%*s\t\t%d\n", &result);
  else
    fscanf(fp, "%*s\t%d\n", &result);
  return (result);
}

gfloat		get_float_property(FILE *fp, gint tab)
{
  guint		i;
  gfloat	result;
  
  for(i = 1; i <= tab; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%*s\t\t%f\n", &result);
  return (result);
}

void		file_selection_entry_changed(GtkWidget *entry, gpointer data)
{
  GtkWidget	*table;
  GtkWidget	*property_entry;
  gchar		*filename;
  
  table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
			      "properties");
  property_entry = gtk_object_get_data(GTK_OBJECT(table), "FILENAME");
  filename = gtk_entry_get_text(GTK_ENTRY(entry));
  gtk_entry_set_text(GTK_ENTRY(property_entry),filename);
}

void	check_name(char *name, GtkWidget *widget)
{
  /*  if(search_in_tree(main_tree, name))*/
  /*    {*/
  /*      int type = get_widget_type(widget);*/
  /*      name_generation(widget, type);*/
  /*    }  */
}

GtkWidget	*restore_widget(FILE *fp, gint nb_tab,
				GtkWidget *container, GtkWidget *father)
{
  GtkWidget	*widget = NULL;
  GtkWidget	*fixed = NULL;
  text_property *property = NULL;
  gchar		*name;
  gchar		*text, *tooltips_text, *label;
  gchar		*sensitive, *visible;
  gint		type, x, y, width, height, delay;
  gint		i;
  GdkColor	*color;
  GtkProgressBarOrientation orientation;
  GtkProgressBarStyle style;
  gfloat	percentage;
  gint		editable;
  gint		show_text;
  GList		*list = NULL;
  gint		nb_items;
  /* CList  */
  GtkSelectionMode selection_mode;
  GtkShadowType shadow_type;
  GtkWindowPosition	window_position;
  GtkWindowType		window_type;
  gint		show_title;
  gint		active;
  gint length, visibility;
  gint state;
  gchar		*title;
  gchar		*wintype;
  gchar		*winpos;
  
  name = xmalloc(TEXT_LENGTH * sizeof (*name));
  text = xmalloc(TEXT_LENGTH * sizeof (*text));
  tooltips_text = xmalloc(TEXT_LENGTH * sizeof(*tooltips_text));
  sensitive = xmalloc(TEXT_LENGTH * sizeof(*sensitive));
  visible = xmalloc(TEXT_LENGTH * sizeof(*visible));
  for (i = 1; i <= nb_tab; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%s\n", name);
  name = strtok(name, "<>");
  for (i = 1; i <= nb_tab+1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%s\t\t%d\n", text, &type);
  for (i = 1; i <= nb_tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%s\t\t%d\n", text, &x);
  for (i = 1; i <= nb_tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%s\t\t%d\n", text, &y);
  for (i = 1; i <= nb_tab+1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%s\t\t%d\n", text, &width);
  for (i = 1; i <= nb_tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%s\t\t%d\n", text, &height);
  strcpy(sensitive, get_text_property(fp, nb_tab));
  strcpy(visible, get_text_property(fp, nb_tab));
  strcpy(tooltips_text, get_text_property(fp, nb_tab));
  for (i = 1; i <= nb_tab + 1; i++)
    fscanf(fp, "\t");
  fscanf(fp, "%s\t\t%d\n", text, &delay);
  switch (type)
    {
    case CLIST:
      selection_mode = get_num_property(fp, nb_tab, FALSE);
      shadow_type = get_num_property(fp, nb_tab, FALSE);
      show_title = get_num_property(fp, nb_tab, FALSE);
      active = get_num_property(fp, nb_tab, FALSE);
      /*      widget = create_clist(container, x, y, width, height, 
	      NULL, selection_mode, shadow_type);*/
      break;
    case WINDOW:
      title = get_text_property(fp, nb_tab);
      wintype = get_text_property(fp, nb_tab);
      winpos = get_text_property(fp, nb_tab);
      if (!strcmp(wintype, "toplevel"))
	window_type = GTK_WINDOW_TOPLEVEL;
      else 
	if (!strcmp(wintype, "dialog"))
	  window_type = GTK_WINDOW_DIALOG;
	else
	  if (!strcmp(wintype, "popup"))
	    window_type = GTK_WINDOW_POPUP;
      if (!strcmp(winpos, "none"))
	window_position = GTK_WIN_POS_NONE;
      else 
	if (!strcmp(winpos, "center"))
	  window_position = GTK_WIN_POS_CENTER;
	else
	  if (!strcmp(winpos, "mouse"))
	    window_position = GTK_WIN_POS_MOUSE;
      widget = create_window(title, width, height, 
			     window_type, window_position);
      restore_window_events(fp, nb_tab,widget);
      gtk_widget_set_name(widget, name); 
      check_name(name, widget);
      break;
    case FONT_SELECTION_DIALOG:
      widget = FontSelectionDialog_restore(fp, nb_tab);
      gtk_widget_set_name(widget, name);                           
      break;
    case FILE_SELECTOR:
      widget = GtkFileSelection_restore(fp, nb_tab);
      restore_window_events(fp,nb_tab,widget);
      gtk_widget_set_name(widget, name);                               
      break;
    case COLOR_SELECTION_DIALOG:
      property = get_property(fp, nb_tab);
      widget = gtk_color_selection_dialog_new(property->text);
      property = get_property(fp,nb_tab);
      if (!strcmp(property->text, "continuous"))
	gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(widget)->colorsel), GTK_UPDATE_CONTINUOUS);
      else 
	if (!strcmp(property->text, "discontinuous"))
	  gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(widget)->colorsel), GTK_UPDATE_DISCONTINUOUS);
	else 
	  if (!strcmp(property->text, "delayed"))
	    gtk_color_selection_set_update_policy(GTK_COLOR_SELECTION(GTK_COLOR_SELECTION_DIALOG(widget)->colorsel), GTK_UPDATE_DELAYED);
      GtkColorSelectionDialog_restore_events(fp,nb_tab,widget);
      gtk_widget_set_name(widget, name);
      break;
    case TOGGLE_BUTTON:
      label = get_text_property(fp,nb_tab);
      state = get_num_property(fp, nb_tab, TRUE);
      widget = create_toggle_button(container, x, y, width, height,
				    label, state);
      restore_toggle_button_events(fp, nb_tab, widget);
      break;
    case CHECK_BUTTON:
      label = get_text_property(fp,nb_tab);
      if(!strcmp(get_text_property(fp,nb_tab),"ON"))
	widget = create_check_button(container, x, y, width, height,
				     label, TRUE);
      else
	widget = create_check_button(container, x, y, width, height,
				     label, FALSE);
      break;
    case BUTTON:
      text = get_text_property(fp, nb_tab);
      widget = create_button(container, x, y, width, height, text);
      restore_button_events(fp, nb_tab, widget);
      break;
    case ENTRY:
      length = get_num_property(fp, nb_tab, FALSE);
      text = get_text_property(fp, nb_tab);
      editable = get_num_property(fp, nb_tab, FALSE);
      visibility = get_num_property(fp, nb_tab, FALSE);
      widget = create_entry(container, x, y, width, height, text, length,
			    editable, visibility);
      restore_entry_events(fp, nb_tab, widget);
      break;
    case FRAME:
      widget = create_frame(container, x, y, width, height,
			    get_text_property(fp, nb_tab));
      break;
    case LABEL:
      for (i = 1; i <= nb_tab + 1; i++)
	fscanf(fp, "\t");
      widget = create_label(container, x, y, width, height,
			    get_text_property(fp,nb_tab));
      break;
    case COMBO:
      widget = GtkCombo_restore(fp, nb_tab);
      break;
    case DRAWING_AREA:
      color = xmalloc(sizeof (*color));
      for(i = 1; i <= nb_tab; i++)
	fscanf(fp, "\t");
      fscanf(fp, "%hu\n", &color->red);
      for(i = 1; i <= nb_tab; i++)
	fscanf(fp, "\t");
      fscanf(fp, "%hu\n", &color->green);
      for(i=1; i<=nb_tab; i++)
	fscanf(fp, "\t");
      fscanf(fp, "%hu\n", &color->blue);
      /*      for(i=1; i<=nb_tab; i++)*/
      /*	fscanf(fp, "\t");*/
      /*      fscanf(fp, "%lu\n", &color->pixel);*/
      widget = create_drawing_area(container, x, y, width, height, color);
      break;
    case NOTEBOOK:
      widget = create_notebook(container, x, y, width, height);
      break;
    case OPTION_MENU:
      for(i = 1; i <= nb_tab + 1; i++)
	fscanf(fp, "\t");
      fscanf(fp, "%*s\t%d\n", &nb_items);
      for (i = 0; i < nb_items; i++)
	{
	  gint	j;
	  gchar	*label;
	  
	  for (j = 1; j <= nb_tab + 1; j++)
	    fscanf(fp, "\t");
	  label = get_text_property(fp, nb_tab);
	  list = g_list_append(list, label);
	}
      /*      widget = create_option_menu(container, x, y, width, height, list);*/
      break;
    case PROGRESS_BAR:
      percentage = get_float_property(fp, nb_tab);
      style = get_num_property(fp, nb_tab, TRUE);
      orientation = get_num_property(fp, nb_tab, FALSE);
      show_text = get_num_property(fp, nb_tab, FALSE);
      widget = create_progress_bar(container, x, y, width, height,
				   orientation, style, show_text, percentage);
      break;
    case TEXT:
      editable = get_num_property(fp, nb_tab, TRUE);
      widget = create_text(container, x, y, width, height, editable); 
      break;
    }
  if (!GTK_IS_WINDOW(widget))
    gtk_widget_set_name(widget, name);
  if (!strcmp(sensitive, "FALSE"))
    gtk_widget_set_sensitive(widget, FALSE); 
  else
    gtk_widget_set_sensitive(widget, TRUE); 
  free(sensitive);
  if (!strcmp(visible, "FALSE"))
    {
      gtk_widget_realize(widget);
      gtk_widget_hide(widget);
    }
  else
    gtk_widget_show(widget);
  free(visible);
  if (strcmp(tooltips_text, ""))
    {  
      GtkTooltips	*tooltips;
      
      tooltips = gtk_tooltips_new();
      gtk_tooltips_set_delay(tooltips, delay);
      if (GTK_WIDGET_NO_WINDOW(widget))
	gtk_tooltips_set_tip(tooltips, widget->parent, tooltips_text, NULL);
      else
	gtk_tooltips_set_tip(tooltips, widget, tooltips_text, NULL);
    }
  hierarchy_add(widget);
  fgets(name, TEXT_LENGTH, fp);
  if (type == WINDOW || type == FRAME)
    {
      GList	*children;
      
      children = gtk_container_children(GTK_CONTAINER(widget));
      fixed = g_list_first(children)->data;
    }
  else
    fixed = NULL;
  while (*name == '\n')
    {
      GtkWidget *wid;
      
      wid = restore_widget(fp,nb_tab+1,fixed,widget);
      fgets(name, 10*TEXT_LENGTH, fp);
    } 
  free(name);
  free(text);
  return widget;
}

GtkWidget	*restore_from_file(char *filename)
{
  FILE		*fp;
  GtkWidget	*widget;
  
  if (!(fp = fopen(filename, "r")))
    return NULL;
  widget = restore_widget(fp, 0, NULL, NULL);
  fclose(fp);
  open_c_file(gtk_widget_get_name(widget));
  return widget;
}

int		restore_project(char *filename)
{
  FILE		*fp;
  char		*name;
  char		*path;
  char		*window_name;
  char		*project_name;
  GtkWidget     *widget;
  size_t size;
  
  if(!(fp = fopen(filename, "r")))
    return -1;
  new_project(NULL, NULL);
  delete_old_project();
  window_name = xmalloc(TEXT_LENGTH * sizeof (*window_name));
  project_name = xmalloc(TEXT_LENGTH * sizeof (*project_name));
  name = xmalloc(TEXT_LENGTH * sizeof (*name));
  path = xmalloc(TEXT_LENGTH * sizeof (*path));
  size = strlen(filename)-strlen(strrchr(filename, '/')); 
  strncpy(path, filename, size);
  path[size] = '\0';  
  strncpy(project_name, strrchr(filename, '/')+1,
	  strlen(strrchr(filename, '/')+1)-strlen(".epingle"));
  project_name[size] = '\0';
  open_c_file(project_name);
  while (!feof(fp))
    {
      fscanf(fp, "%s\n", name);
      sprintf(window_name, "%s/%s.xml", path, name);
      widget = restore_from_file(window_name);
    }
  free(window_name);
  free(project_name);
  free(name);
  free(path);
  fclose(fp); 
  return 0;
}






