/*
** restore_events.c
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Sat May  8 00:29:30 1999 Maxime VERNIER
** Last update Fri Jun 18 05:03:59 1999 maxime vernier
*/

#include "global.h"
#include "restore.h"
#include "events.h"

void
restore_widget_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  
  g_return_if_fail(GTK_IS_WIDGET(widget));
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_show),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_hide),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_button_press_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_button_release_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_motion_notify_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_destroy_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_key_press_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_key_release_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_enter_notify_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_leave_notify_event),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWidget_drag_drop),
		      text);
}

void
restore_window_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  
  g_return_if_fail(GTK_IS_WINDOW(widget));
  restore_widget_events(fp,nb_tab,widget);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkWindow_set_focus),
		      text);
}

void
GtkColorSelectionDialog_restore_events(FILE *fp, int tab, GtkWidget *widget)
{
  gchar		*text;
  
  g_return_if_fail(GTK_IS_COLOR_SELECTION_DIALOG(widget));
  restore_window_events(fp,tab,widget);
  text = get_text_property(fp,tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkColorSelection_color_changed),
		      text);
}

void
restore_button_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  
  g_return_if_fail(GTK_IS_BUTTON(widget));
  restore_widget_events(fp,nb_tab,widget);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkButton_pressed),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkButton_released),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkButton_clicked),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkButton_enter),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkButton_leave),
		      text);
}

void
restore_toggle_button_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  
  g_return_if_fail(GTK_IS_TOGGLE_BUTTON(widget));
  restore_button_events(fp,nb_tab,widget);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkToggleButton_toggled),
		      text);
}

void
restore_check_button_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  g_return_if_fail(GTK_IS_CHECK_BUTTON(widget));
  restore_toggle_button_events(fp, nb_tab, widget);
}

void
restore_entry_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  
  g_return_if_fail(GTK_IS_ENTRY(widget));
  restore_widget_events(fp,nb_tab,widget);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkEditable_insert_text),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkEditable_delete_text),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkEditable_changed),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkEditable_activate),
		      text);
  text = get_text_property(fp,nb_tab);
  if(!strcmp(text, "(null)"))
    text = NULL;
  gtk_object_set_data(GTK_OBJECT(widget),
		      int_to_str(GtkEditable_set_editable),
		      text);
}

     
