/*
** save.c for EPingle 
** 
** Made by Maxime Vernier
** Login   <Maxime Vernier@epita.fr>
** 
** Started on  Sat Apr  1 18:15:20 2000 Maxime Vernier
** Last update Tue Apr  4 01:18:39 2000 Maxime Vernier
*/

#include "main.h"

void		write_window_file(GtkWidget *window)
{
  FILE		*fp;
  gchar		*filename;
  gchar		*name;
  GtkWidget	*child;
  GList		*children_list;
  gint		i;
  gint		type;
  int		len;
  
  name = gtk_widget_get_name(window);
  create_c_file(name);
  len = strlen(epingle->project_path) + strlen(name) + 6;
  filename = xmalloc(sizeof (gchar) * len);
  sprintf(filename, "%s/%s.xml", epingle->project_path, name);
  fp = fopen(filename, "w");
  fprintf(fp, "<%s>\n", name);
  write_common_properties(fp, window, 1);
  write_window_properties(fp, window, 1);
  type = get_widget_type(window);
  switch (type)
    {
    case FILE_SELECTOR:
      GtkFileSelection_save(fp, window, 1);
      break;
    case COLOR_SELECTION_DIALOG:
      write_colorselector_properties(fp,window,1);
      break;
    }
  switch (type)
    {
    case COLOR_SELECTION_DIALOG:
      GtkColorSelectionDialog_save_events(fp, 1, window);
      break;
    default:
      save_window_events(fp, 1, window);
      break;
    }
  children_list = epingle_window_children(GTK_WINDOW(window));
  len = g_list_length(children_list);
  for (i = 0; i < len; i++)
    {
      fprintf(fp, "\n");
      child = g_list_nth_data(children_list, i);
      write_widget_properties(fp, child, 1); 
    }
  fprintf(fp, "</%s>", name);
  free(filename);
  fclose(fp);
}

int		save_project()
{
  FILE		*fp;
  GtkWidget     *widget;
  char		*filename;
  char		*name;
  int		i;
  gint		len;
  
  mkdir(epingle->project_path, S_IRWXU | S_IXGRP | S_IXOTH);
  name = xmalloc(sizeof (char) * TEXT_LENGTH);
  strcpy(name, strrchr(epingle->project_path, '/') + 1);
  filename = xmalloc(sizeof (char) * TEXT_LENGTH);
  sprintf(filename, "%s/%s.epingle", epingle->project_path, name);
  if (!(fp = fopen(filename, "w")))
    return (-1);
  len = g_list_length(epingle->window_list);
  for (i = 0; i < len; i++)
    {
      widget = g_list_nth_data(epingle->window_list, i);
      name = gtk_widget_get_name(widget);
      fprintf(fp, "%s\n", name);
      write_window_file(widget);
    }
  free(filename);
  free(name);
  fclose(fp);
  return (0);
}












