/*
** save_events.c
** 
** Made by (Maxime VERNIER)
** Login   <vernie_m@epita.fr>
** 
** Started on  Thu May  6 16:39:42 1999 Maxime VERNIER
** Last update Sun Apr  2 16:55:39 2000 Maxime Vernier
*/

#include "events.h"

void	save_widget_events(FILE *fp, int nb_tab, GtkWidget *widget)
{
  char	*text;
  char	*allocated_str;
  
  allocated_str = int_to_str(GtkWidget_show);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "SHOWING", text);

  allocated_str = int_to_str(GtkWidget_hide);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "HIDING", text);

  allocated_str = int_to_str(GtkWidget_button_press_event); 
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "BT_PRESS", text);

  allocated_str = int_to_str(GtkWidget_button_release_event);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "BT_RELEASE", text);

  allocated_str = int_to_str(GtkWidget_motion_notify_event);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "NOTIFY", text);

  allocated_str = int_to_str(GtkWidget_destroy_event);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "DESTROY", text);

  allocated_str = int_to_str(GtkWidget_key_press_event);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "KEY_PRESS", text);

  allocated_str = int_to_str(GtkWidget_key_release_event);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "KEY_RELEASE", text);

  allocated_str = int_to_str(GtkWidget_enter_notify_event);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "ENT_NOTIFY", text);

  allocated_str = int_to_str(GtkWidget_leave_notify_event);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "LEA_NOTIFY", text);

  allocated_str = int_to_str(GtkWidget_drag_drop);
  text = gtk_object_get_data(GTK_OBJECT(widget), allocated_str);
  free(allocated_str);
  write_str_property(fp, nb_tab, "DRAGNDROP", text);
}

void
save_window_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  gint		i;
  
  save_widget_events(fp, nb_tab, widget);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkWindow_set_focus));
  for(i=1; i<=nb_tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<SET_FOCUS>\t%s\n", text); 
}

void
GtkColorSelection_save_events(FILE *fp, int tab, GtkWidget *widget)
{
  gchar *text;

  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkColorSelection_color_changed));
  write_str_property(fp, tab, "COLOR_CHG", text);
}

void
GtkColorSelectionDialog_save_events(FILE *fp, int tab, GtkWidget *widget)
{
  save_window_events(fp, tab, widget);
  GtkColorSelection_save_events(fp, tab, GTK_COLOR_SELECTION_DIALOG(widget)->colorsel);
}

void
save_button_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  gint		i;
  
  save_widget_events(fp, nb_tab, widget);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkButton_pressed));
  for(i=1; i<=nb_tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<PRESSED>\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkButton_released));
  for(i=1; i<=nb_tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<RELEASED>\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkButton_clicked));
  for(i=1; i<=nb_tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<CLICKED>\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkButton_enter));
  for(i=1; i<=nb_tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<ENTER>\t\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkButton_leave));
  for(i=1; i<=nb_tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<LEAVE>\t\t%s\n", text);
}

void
save_toggle_button_events(FILE *fp, gint nb_tab, GtkWidget *widget)
{
  gchar		*text;
  gint		i;
  
  save_button_events(fp, nb_tab, widget);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkToggleButton_toggled));
  for(i=1; i<=nb_tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<TOGGLED>\t%s\n", text);
}

void
save_editable_events(FILE *fp, int tab, GtkWidget *widget)
{
  gchar		*text;
  gint		i;

  save_widget_events(fp, tab, widget);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkEditable_insert_text));
   for(i=1; i<=tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<INS_TEXT>\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkEditable_delete_text));
  for(i=1; i<=tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<DEL_TEXT>\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkEditable_changed));
  for(i=1; i<=tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<CHANGED>\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkEditable_activate));
  for(i=1; i<=tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<ACTIVATE>\t%s\n", text);
  text = gtk_object_get_data(GTK_OBJECT(widget),
			     int_to_str(GtkEditable_set_editable));
  for(i=1; i<=tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<EDITABLE>\t%s\n", text);
}

void
save_entry_events(FILE *fp, int tab, GtkWidget *widget)
{
  save_editable_events(fp, tab, widget);
}
