#include "main.h" 

static void cb_set_editable(GtkWidget *sender, GtkWidget * widget )
{
  g_return_if_fail(GTK_IS_TEXT(widget )); 
  if(GTK_IS_TOGGLE_BUTTON(sender))
    {
      GtkWidget *label;
      
      label = g_list_first(gtk_container_children(GTK_CONTAINER(sender)))->data;
      if(GTK_TOGGLE_BUTTON(sender)->active)
	{
	  gtk_label_set_text(GTK_LABEL(label), "False"); 
	  gtk_text_set_editable(GTK_TEXT(widget), FALSE);
	}
      else
	{
	  gtk_label_set_text(GTK_LABEL(label), "True"); 
	  gtk_text_set_editable(GTK_TEXT(widget), TRUE);
	}
      refresh_widget_code_from_properties(widget);
    }
}

void		GtkText_properties(GtkWidget *widget)
{
  GtkWidget	*button;
  GtkWidget	*table;

  table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
			      "properties"); 
  AddPropertyLabel(table, NB_WIDGET_PROP+1, 
		   "Editable", "If the text is editable");
  if(GTK_TEXT(widget)->editable.editable)
    button = AddToggleProperty(table, NB_WIDGET_PROP+1, FALSE, "True");
  else
    button = AddToggleProperty(table, NB_WIDGET_PROP+1, TRUE, "False");
  gtk_signal_connect(GTK_OBJECT(button), "toggled", 
		     GTK_SIGNAL_FUNC(cb_set_editable), widget); 
}

void	GtkText_save(FILE *fp, gint tab, GtkWidget *widget)
{
  gint	i;
  
  for(i = 1; i <= tab; i++)
    fprintf(fp, "\t");
  fprintf(fp, "<EDITABLE>\t%d\n", (GTK_TEXT(widget)->editable).editable);
}
