#include "main.h" 
#include "button.h" 

static void	state_button_toggled(GtkWidget *sender, GtkWidget *widget)
{
  GtkWidget	*label;
  
  if (GTK_TOGGLE_BUTTON(sender)->active)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
  else
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
  label = g_list_first(gtk_container_children(GTK_CONTAINER(sender)))->data;
  if (!GTK_TOGGLE_BUTTON(sender)->active)
    gtk_label_set(GTK_LABEL(label), "Off");
  else 
    gtk_label_set(GTK_LABEL(label), "On");
  refresh_widget_code(widget);
}

void		GtkToggleButton_properties(GtkWidget *widget)
{
  GtkWidget	*button;
  GtkWidget	*table;
  
  table = gtk_object_get_data(GTK_OBJECT(epingle->win_properties),
			      "properties"); 
  GtkButton_properties(widget);
  AddPropertyLabel(table, NB_BUTTON_PROP+1, "State",
		   "State of the toggle button");
  if(GTK_TOGGLE_BUTTON(widget)->active)
    button = AddToggleProperty(table, NB_BUTTON_PROP+1, TRUE, "On");
  else 
    button = AddToggleProperty(table, NB_BUTTON_PROP+1, FALSE, "Off");
  gtk_signal_connect(GTK_OBJECT(button), "toggled",
		     GTK_SIGNAL_FUNC(state_button_toggled), widget);
}
