/*
** widget_events.c
** 
** Made by (sebastien thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Mon May 31 01:19:47 1999 sebastien thebert
** Last update Wed Apr  5 01:46:46 2000 Sebastien Thebert
*/
#include "main.h"

extern struct alignment	align;

extern GtkWidget	*clist_popup;

extern gint		widget_selected;

gint	frame_moving = 0;

GtkWidget	*widget_under_cursor = NULL;

short	current_cursor = 0;

struct	mouse_pointer
{
  gint	x_decal;
  gint	y_decal;
}	pt;

/***********************************************************/
void		motion_on_widget(gint x, gint y)
{
  GdkCursor	*cursor;
  GtkWidget	*widget;
  gint		widget_x2, widget_y2;

  widget = widget_under_cursor;
  widget_x2 = (widget->allocation.x + widget->allocation.width);
  widget_y2 = widget->allocation.y + widget->allocation.height; 
  if ((x > widget_x2-5) || (y > widget_y2-5) ||
      (x < widget->allocation.x+5) || (y < widget->allocation.y+5))
    {
      if ((x > widget_x2-5) && (y > widget_y2-5))
	{
	  cursor = gdk_cursor_new(GDK_BOTTOM_RIGHT_CORNER);
	  gdk_window_set_cursor(widget->window, cursor);
	  current_cursor = BOTTOM_RIGHT;
	}
      else if ((y > widget_y2-5) && (x < widget->allocation.x+5))
	{
	  cursor = gdk_cursor_new(GDK_BOTTOM_LEFT_CORNER);
	  gdk_window_set_cursor(widget->window, cursor);
	  current_cursor = BOTTOM_LEFT;
	}
      else if ((y < widget->allocation.y+5) && (x < widget->allocation.x+5))
	{
	  cursor = gdk_cursor_new(GDK_TOP_LEFT_CORNER);
	  gdk_window_set_cursor(widget->window, cursor);
	  current_cursor = TOP_LEFT;
	}
      else if ((x > widget_x2-5) && (y < widget->allocation.y+5))
	{
	  cursor = gdk_cursor_new(GDK_TOP_RIGHT_CORNER);
	  gdk_window_set_cursor(widget->window, cursor);
	  current_cursor = TOP_RIGHT;
	}
      else if ((y > widget_y2-5) && (current_cursor != BOTTOM_SIDE))
	{
	  cursor = gdk_cursor_new(GDK_BOTTOM_SIDE);
	  gdk_window_set_cursor(widget->window, cursor);
	  current_cursor = BOTTOM_SIDE;
	}
      else if ((x > widget_x2-5) && (current_cursor != RIGHT_SIDE))
	{
	  cursor = gdk_cursor_new(GDK_RIGHT_SIDE);
	  gdk_window_set_cursor(widget->window, cursor);
	  current_cursor = RIGHT_SIDE;
	}
      else if ((y < widget->allocation.y+5) && (current_cursor != TOP_SIDE))
	{
	  cursor = gdk_cursor_new(GDK_TOP_SIDE);
	  gdk_window_set_cursor(widget->window, cursor);
	  current_cursor = TOP_SIDE;
	}
      else if ((x < widget->allocation.x+5) && (current_cursor != LEFT_SIDE))
	{	  cursor = gdk_cursor_new(GDK_LEFT_SIDE);
	gdk_window_set_cursor(widget->window, cursor);
	current_cursor = LEFT_SIDE;
	}
    }
  else if (current_cursor != FLEUR)
    {
      cursor = gdk_cursor_new(GDK_FLEUR);
      gdk_window_set_cursor(widget->window, cursor);
      current_cursor = FLEUR;
    }
}

/***********************************************************/
void	motion_on_window(GtkWidget *fixed, GdkEventMotion *event)
{
  gint	x, y;

   if (GTK_IS_FIXED(fixed))
    {
      gtk_widget_get_pointer(fixed, &x, &y);
      if (epingle->widget_clicked != NULL)
	gtk_widget_get_pointer(epingle->widget_clicked->parent, &x, &y);
      if ((widget_under_cursor != NULL) && (epingle->widget_clicked == NULL))
	motion_on_widget(x, y);
      if (epingle->widget_clicked != NULL)
	{
	  if (epingle->widget_moving == 1)
	    {
	      x -= pt.x_decal;
	      y -= pt.y_decal;
	      while ((!GTK_IS_FIXED(fixed)) && (fixed->parent))
		fixed = fixed->parent;
	      gtk_fixed_move(GTK_FIXED(fixed), epingle->widget_clicked, x, y);
	      change_properties(epingle->widget_clicked); 
	    }
	  if (epingle->widget_resizing != 0)
	    resize_widget(fixed, x, y);
	}
    }
}

/***********************************************************/
void	widget_alignment(GtkWidget *widget)
{
  GList	*list = NULL;
  gint	x, y;
  
  if (align.coord == -1)
    {
      switch (align.pos)
	{
	case LEFT_ALIGN :
	  align.coord = widget->allocation.x;
	  break;
	case RIGHT_ALIGN :
	  align.coord = widget->allocation.x + widget->allocation.width;
	  break;
	case TOP_ALIGN :
	  align.coord = widget->allocation.y;
	  break;
	case BOTTOM_ALIGN :
	  align.coord = widget->allocation.y + widget->allocation.height;
	  break;
	case WIDTH_ALIGN :
	  align.coord = widget->allocation.width;
	  break;
	case HEIGHT_ALIGN :
	  align.coord = widget->allocation.height;
	  break;  
	}
    }
  else
    {
      switch (align.pos)
	{
	case LEFT_ALIGN :
	  x = align.coord;
	  widget->allocation.x = x;
	  y = widget->allocation.y;
	  gtk_fixed_move(GTK_FIXED(widget->parent), widget, x, y);
	  break;
	case RIGHT_ALIGN :
	  x = align.coord - widget->allocation.width;
	  widget->allocation.x = x;
	  y = widget->allocation.y;
	  gtk_fixed_move(GTK_FIXED(widget->parent), widget, x, y);
	  break;
	case TOP_ALIGN :
	  x = widget->allocation.x;
	  y = align.coord;
	  widget->allocation.y = y;
	  gtk_fixed_move(GTK_FIXED(widget->parent), widget, x, y);
	  break;
	case BOTTOM_ALIGN :
	  x = widget->allocation.x;
	  y = align.coord - widget->allocation.height;
	  widget->allocation.y = y;
	  gtk_fixed_move(GTK_FIXED(widget->parent), widget, x, y);
	  break;  
	case WIDTH_ALIGN :
	  gtk_widget_set_usize(widget, align.coord,
			       widget->allocation.height); 
	  widget->allocation.width = align.coord;
	  break;
	case HEIGHT_ALIGN :
	  gtk_widget_set_usize(widget, widget->allocation.width,
			       align.coord);
	  widget->allocation.height = align.coord;
	  break;  
	}
    }
  if (GTK_IS_EVENT_BOX(widget))
    {
      list = gtk_container_children(GTK_CONTAINER(widget));
      change_properties((g_list_first(list))->data);
    }
  else
    change_properties(widget);
}

/***********************************************************/
void	button_release(GtkWidget *widget, GdkEventButton *event)
{
  GList	*list = NULL;
  
  if (!GTK_IS_FIXED(widget))
    {
      if (GTK_IS_EVENT_BOX(widget))
	{
	  list = gtk_container_children(GTK_CONTAINER(widget));
	  refresh_widget_code((g_list_first(list))->data);
	  edit_properties_of_widget((g_list_first(list))->data);
	}
      else
	{
	  refresh_widget_code(widget);
	  edit_properties_of_widget(widget);
	}
    }
  epingle->widget_clicked = NULL;
  if (GTK_IS_WINDOW(widget->parent))
    align.pos = -1;
}

/***********************************************************/
void	action_on_widget(GtkWidget *widget, GdkEventButton *event)
{
  GList	*list = NULL;

  if (GTK_IS_EVENT_BOX(widget))
    {
      list = gtk_container_children(GTK_CONTAINER(widget));
      edit_properties_of_widget((g_list_first(list))->data);
    }
  else
    edit_properties_of_widget(widget);
  widget_selected = 0;
  if (event->button == 1)
    {
      if (align.pos != -1)
	widget_alignment(widget);
      
      if (GTK_IS_EVENT_BOX(widget))
	{
	  pt.x_decal = event->x + 2;
	  pt.y_decal = event->y;
	  if (GTK_IS_FRAME((g_list_first(list))->data))
	    {
	      pt.x_decal = event->x + 2;
	      pt.y_decal = event->y + 15;
	    }
	  if (GTK_IS_NOTEBOOK((g_list_first(list))->data))
	    {
	      /* pb when tab_pos != up */ 
	      pt.x_decal = event->x + 2;
	      pt.y_decal = event->y + 22;
	    }
	}
      else
	{
	  pt.x_decal = event->x;
	  pt.y_decal = event->y;
	}
      frame_moving = 0;
      epingle->widget_moving = 1;
      epingle->widget_resizing = 0;
      epingle->widget_clicked = widget;
      if ((event->x > widget->allocation.width - 5) || (event->x < 5)
	  || (event->y > widget->allocation.height - 5) || (event->y <5))
	{
	  epingle->widget_moving = 0;
	  if (event->y < 5)
	    epingle->widget_resizing = UP;
	  if (event->y > widget->allocation.height - 5)
	    epingle->widget_resizing = DOWN;
	  if (event->x < 5)
	    epingle->widget_resizing = LEFT;
	  if (event->x > widget->allocation.width - 5) 
	    epingle->widget_resizing = RIGHT;
	  if ((event->y > widget->allocation.height - 5) &&
	      (event->x > widget->allocation.width - 5))
	    epingle->widget_resizing = RIGHTDOWN;
	  if ((event->y < 5) && (event->x > widget->allocation.width - 5))
	    epingle->widget_resizing = RIGHTUP;
	  if ((event->y > widget->allocation.height - 5) && (event->x < 5))
	    epingle->widget_resizing = LEFTDOWN;
	  if ((event->y < 5) && (event->x < 5))
	    epingle->widget_resizing = LEFTUP;
	}
    } 
  else if (event->button == 3)
    {
      edit_properties_of_widget(widget->parent->parent);
      if (GTK_IS_EVENT_BOX(widget))
	{
	  delete_in_widget_list(gtk_widget_get_name
				((g_list_first(list))->data));
	  hierarchy_remove((g_list_first(list))->data);
	  delete_widget_code((g_list_first(list))->data);
	}
      else
	{
	  delete_in_widget_list(gtk_widget_get_name(widget));
	  hierarchy_remove(widget);
	  delete_widget_code(widget);
	}
      widget_under_cursor = NULL;
      gtk_widget_destroy(widget);
    }
}

/***********************************************************/
void	action_on_frame(GtkWidget *fixed, GdkEventButton *event)
{
  edit_properties_of_widget(fixed->parent);
  frame_moving = 1;
  if (event->button == 1)
    {
      if (align.pos != -1)
	widget_alignment(fixed->parent->parent);
      action_on_widget(fixed->parent->parent, event);
    }
  else if (event->button == 2)
    {
      event->button = 1;
      action_on_window(fixed, event);
    }
  else if (event->button == 3)
    {
      delete_in_completion_list(gtk_widget_get_name(fixed->parent));
      hierarchy_remove(fixed->parent);
      widget_under_cursor = NULL;
      delete_widget_code(fixed->parent);
      gtk_widget_destroy(fixed->parent->parent);
    }
}

/***********************************************************/
void			action_on_notebook(GtkWidget *eventbox,
					   GdkEventButton *event)
{
  GList			*list = NULL;
  GtkWidget		*notebook, *fixed;
  GtkNotebookPage	*page = NULL;	
  
  list = gtk_container_children(GTK_CONTAINER(eventbox));
  frame_moving = 1;
  if (event->button == 1)
    {
      if (align.pos != -1)
	widget_alignment(eventbox);
      action_on_widget(eventbox, event);
    }
  else if (event->button == 2)
    {
      event->button = 1;
      notebook = GTK_WIDGET((g_list_first(list))->data);
      fixed = page->child;
      action_on_window(fixed, event);
    }
  else if (event->button == 3)
    {
      hierarchy_remove((g_list_first(list))->data);
      gtk_widget_destroy(eventbox);
    }
}

/***********************************************************/
void	action_on_widget_table(GtkWidget *widget, GdkEventButton *event)
{
  if (event->button == 1)
    action_on_widget(widget, event);  
}

/***********************************************************/
void	enter_widget(GtkWidget *widget, GdkEventButton *event)
{
  widget_under_cursor = widget;
}

/***********************************************************/
void	leave_widget(GtkWidget *widget, GdkEventButton *event)
{
  widget_under_cursor = NULL;
}

/***********************************************************/
void	enter_eventbox(GtkWidget *widget, GdkEventButton *event)
{
  if (GTK_IS_FIXED(widget))
    widget_under_cursor = NULL;
  else
    widget_under_cursor = widget;
}

/***********************************************************/
void	leave_eventbox(GtkWidget *widget, GdkEventButton *event)
{
  widget_under_cursor = NULL;
}


/***********************************************************/
void	set_window_events(GtkWidget *fixed)
{
  gtk_widget_set_events(fixed, GDK_BUTTON_PRESS_MASK
			| GDK_BUTTON_RELEASE_MASK | GDK_BUTTON_MOTION_MASK
			| GDK_POINTER_MOTION_MASK);
  gtk_signal_connect(GTK_OBJECT(fixed), "button_press_event",
		     GTK_SIGNAL_FUNC(action_on_window), NULL);
  gtk_signal_connect(GTK_OBJECT(fixed), "button_release_event",
		     GTK_SIGNAL_FUNC(button_release), NULL);
  gtk_signal_connect(GTK_OBJECT(fixed), "motion_notify_event",
		     GTK_SIGNAL_FUNC(motion_on_window), NULL);
}

/***********************************************************/
void	set_widget_events(GtkWidget *widget)
{
  gtk_widget_set_events(widget, GDK_BUTTON_PRESS_MASK |
			GDK_BUTTON_RELEASE_MASK |
			GDK_ENTER_NOTIFY | GDK_LEAVE_NOTIFY);
  gtk_signal_connect(GTK_OBJECT(widget), "button_press_event",
		     GTK_SIGNAL_FUNC(action_on_widget), NULL);
  gtk_signal_connect(GTK_OBJECT(widget), "button_release_event",
		     GTK_SIGNAL_FUNC(button_release), NULL);
  gtk_signal_connect(GTK_OBJECT(widget), "enter_notify_event",
		     GTK_SIGNAL_FUNC(enter_widget), NULL);
  gtk_signal_connect(GTK_OBJECT(widget), "leave_notify_event",
		     GTK_SIGNAL_FUNC(leave_widget), NULL);  
}

/***********************************************************/
void	set_clist_events(GtkWidget *clist)
{
  gtk_widget_set_events(clist, GDK_BUTTON_PRESS_MASK
			| GDK_BUTTON_RELEASE_MASK
			| GDK_ENTER_NOTIFY | GDK_LEAVE_NOTIFY);
  if (!clist_popup)
    clist_popup = create_clist_popup(clist);
  /*  gtk_signal_connect_object(GTK_OBJECT(clist), "button_press_event",*/
  /*			    GTK_SIGNAL_FUNC(action_on_widget), NULL);*/
  gtk_signal_connect_object(GTK_OBJECT(clist), "button_press_event",
			    GTK_SIGNAL_FUNC(popup_show), 
			    GTK_OBJECT(clist_popup));
  gtk_signal_connect(GTK_OBJECT(clist), "button_release_event",
		     GTK_SIGNAL_FUNC(button_release), NULL);
  gtk_signal_connect(GTK_OBJECT(clist), "enter_notify_event",
		     GTK_SIGNAL_FUNC(enter_widget), NULL);
  gtk_signal_connect(GTK_OBJECT(clist), "leave_notify_event",
		     GTK_SIGNAL_FUNC(leave_widget), NULL);
  gtk_signal_connect(GTK_OBJECT(clist), "click_column",
		     GTK_SIGNAL_FUNC(cb_click_column), NULL);
  gtk_signal_connect(GTK_OBJECT(clist), "select_row",
		     GTK_SIGNAL_FUNC(cb_clist_select_row), NULL);
}





















