/*
** widget_help.c
** 
** Made by (Sebastien Thebert)
** Login   <theber_s@epita.fr>
** 
** Started on  Thu Jun 10 17:31:53 1999 Sebastien Thebert
** Last update Sat Apr  1 19:19:37 2000 Sebastien Thebert
*/
#include "main.h"

/***********************************************************/
char	*get_widget()
{
  gint	i, end_pos, pos, length;
  char	*str;
  
  set_edit_text();
  end_pos = gtk_text_get_point(GTK_TEXT(epingle->edit_text));
  pos = end_pos-1;
  while((GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ' ')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '\n')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '(')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ')')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ','))
    pos--;
  pos++;
  length = end_pos-pos;
  pos = end_pos;
  while((GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ' ')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '\n')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != '(')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ')')
	&& (GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos) != ','))
    pos++;
  length += (pos-end_pos);
  pos = pos - length;
  
  str = xmalloc(sizeof (char) * (length + 1));
  i = 0;
  while(i < length)
    {
      str[i] = GTK_TEXT_INDEX(GTK_TEXT(epingle->edit_text), pos+i);
      i++;
    }
  str[i] = '\0';
  
  return(str);
}

void		show_win_help(gint type)
{
  GtkWidget	*window;
  GtkWidget	*text;
  FILE		*file;
  gchar		*file_str;
  
  window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(window), "EPIngle Widget Help");
  gtk_widget_set_usize(window, 400, 300);
  text = gtk_text_new(NULL, NULL);
  gtk_text_set_editable(GTK_TEXT(text), FALSE);
  gtk_container_add(GTK_CONTAINER(window), text);
  gtk_widget_show(text);
  gtk_widget_show(window);
  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		     GTK_SIGNAL_FUNC(gtk_widget_destroy), NULL);
  file_str = xmalloc(sizeof (char) * 300);
  switch(type)
    {
    case WINDOW :
      file = fopen("./help/gtkwindow", "r");
      break;
    case FILE_SELECTOR :
      file = fopen("./help/gtkfilesel", "r");
      break;
    case COLOR_SELECTION_DIALOG :
      file = fopen("./help/gtkcolorsel", "r");
      break;
    case FONT_SELECTION_DIALOG :
      file = fopen("./help/gtkfontsel", "r");
      break;
    case BUTTON :
      file = fopen("./help/gtkbutton", "r");
      break;
    case TOGGLE_BUTTON :
      file = fopen("./help/gtktogglebutton", "r");
      break;
    case CHECK_BUTTON :
      file = fopen("./help/gtkcheckbutton", "r");
      break;
    case RADIO_BUTTON :
      file = fopen("./help/gtkradiobutton", "r");
      break;
    case LABEL :
      file = fopen("./help/gtklabel", "r");
      break;
    case ENTRY :
      file = fopen("./help/gtkentry", "r");
      break;
    case COMBO :
      file = fopen("./help/gtkcombo", "r");
      break;
    case TEXT :
      file = fopen("./help/gtktext", "r");
      break;
    case DRAWING_AREA :
      file = fopen("./help/gtkdrawingarea", "r");
      break;
    case FRAME :
      file = fopen("./help/gtkframe", "r");
      break;
    case NOTEBOOK :
      file = fopen("./help/gtknotebook", "r");
      break;
    case TABLE :
      file = fopen("./help/gtktable", "r");
      break;
    case OPTION_MENU :
      file = fopen("./help/gtkoptionmenu", "r");
      break;
    case PROGRESS_BAR :
      file = fopen("./help/gtkprogress_bar", "r");
      break; 
    }
  epingle->edit_text = text;
  while(fgets(file_str, 300, file) != NULL)
    coloration(file_str);
  free(file_str);
  fclose(file);
}

void	show_widget_help()
{
  char	*str;
  gint	type;
  
  str = get_widget();
  type = search_in_widget_list(str);
  printf("str %s - type %d\n", str, type);
  show_win_help(type);
  free(str);
}

